GNU bug report logs - #53818
[PATCH 0/3] Add Repology updater

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: guix-patches; Reported by: Xinglu Chen <public@HIDDEN>; Keywords: patch; dated Sun, 6 Feb 2022 11:52:02 UTC; Maintainer for guix-patches is guix-patches@HIDDEN.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 18 Feb 2022 10:29:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 18 05:29:08 2022
Received: from localhost ([127.0.0.1]:53514 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nL0Vg-0005lc-J3
	for submit <at> debbugs.gnu.org; Fri, 18 Feb 2022 05:29:08 -0500
Received: from relay9-d.mail.gandi.net ([217.70.183.199]:33759)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mail@HIDDEN>) id 1nL0Ve-0005l7-Vz
 for 53818 <at> debbugs.gnu.org; Fri, 18 Feb 2022 05:29:07 -0500
Received: (Authenticated sender: admin@HIDDEN)
 by mail.gandi.net (Postfix) with ESMTPSA id 53BDDFF80B;
 Fri, 18 Feb 2022 10:28:59 +0000 (UTC)
From: Nicolas Goaziou <mail@HIDDEN>
To: zimoun <zimon.toutoune@HIDDEN>
Subject: Re: [bug#53818] Improving updaters and =?utf-8?Q?=E2=80=98guix_re?=
 =?utf-8?Q?fresh=E2=80=99?=
In-Reply-To: <86sfsh4u9x.fsf@HIDDEN> (zimoun's message of "Thu, 17 Feb 2022
 12:17:14 +0100")
References: <cover.1644147246.git.public@HIDDEN>
 <87pmnx7ynw.fsf@HIDDEN> <87y22kxkv3.fsf@HIDDEN>
 <87leyi4fcv.fsf@HIDDEN> <87pmnprasd.fsf@HIDDEN>
 <87fsolv109.fsf@HIDDEN> <87leydqohm.fsf@HIDDEN>
 <87ee44pi4p.fsf_-_@HIDDEN> <87a6eroubv.fsf@HIDDEN>
 <87mtipok57.fsf@HIDDEN> <86sfsh4u9x.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
Date: Fri, 18 Feb 2022 11:28:58 +0100
Message-ID: <87tucwmpsl.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 53818
Cc: 53818 <at> debbugs.gnu.org, Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>,
 Xinglu Chen <public@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Hello,

zimoun <zimon.toutoune@HIDDEN> writes:

> On Thu, 17 Feb 2022 at 11:35, Ludovic Court=C3=A8s <ludo@HIDDEN> wrote:


>> How does it fail?  If it=E2=80=99s the GitHub rate limit, then there=E2=
=80=99s only one
>> answer: you have to provide a token.

IIUC, I have to register on GitHub to create this token. This is a bit
sad as a prerequisite to use one core feature of Guix.

> Let mimick a collection if 1000+ packages I care about.  Consider this
> manifest for packages using r-build-system only=E2=80=A6
>
> --8<---------------cut here---------------start------------->8---
> (use-modules (guix packages)
>              (gnu packages)
>              (guix build-system r))
>
> (packages->manifest
>  (fold-packages (lambda (package result)
>                   (if (eq? (package-build-system package) r-build-system)
>                       (cons package result)
>                       result))
>                 '()))
> --8<---------------cut here---------------end--------------->8---

I have to learn about fold-packages.

> Nicolas, considering the complexity of packages and their origins, do
> you think it would be possible to do better (fast and accurate) than
> Repology at scale?

It's not about doing better, but doing differently. We do not need all
of Repology's features.=20

As far as the updater part is concerned, Repology pokes at various
package repositories, which are usually not upstream, extracts package
versions, applies some heuristics to normalize and compare them, then
decides what is the newest version and which repositories provide
outdated packages. This has a two obvious shortcomings:

1. the version number usually doesn't come from an official source, so
   it may be wrong=E2=80=94e.g., our emacs-csv-mode is "outdated" because F=
untoo
   1.4 chose a non-existing higher version number for the same package.

2. version comparison does not understand every local versioning
   scheme=E2=80=94e.g., our emacs-fold-dwim packages is currently at
   "1.2-0.c46f4bb", which is, in Guix parlance, after "1.2", yet
   Repology thinks this is actually older than "1.2".

Therefore, I think a (theoretical) centralized Guix-centric version
checker could be fast: it would only poke at what our packages consider
to be upstream, and accurate, since it would know about our versioning
rules. Basically it could boil down to calling current "guix refresh" on
every package daily, and serializing the results.

>>>>   =E2=80=A2 guix refresh -m packages-i-care-about.scm
>>>
>>> Yes, obviously, this is a nice, too. However, it doesn't scale if you
>>> need to specify 1000+ packages.
>>
>> You can use =E2=80=98fold-packages=E2=80=99 and have three lines that re=
turn a manifest
>> of 10K packages if you want it.
>
> Yes, see example above.

Point taken.

Regards,
--=20
Nicolas Goaziou




Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 17 Feb 2022 11:20:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Feb 17 06:20:45 2022
Received: from localhost ([127.0.0.1]:50297 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nKeq4-0004cO-T9
	for submit <at> debbugs.gnu.org; Thu, 17 Feb 2022 06:20:45 -0500
Received: from mail-wm1-f42.google.com ([209.85.128.42]:46860)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1nKeq3-0004c9-Vo
 for 53818 <at> debbugs.gnu.org; Thu, 17 Feb 2022 06:20:44 -0500
Received: by mail-wm1-f42.google.com with SMTP id
 l67-20020a1c2546000000b00353951c3f62so3796459wml.5
 for <53818 <at> debbugs.gnu.org>; Thu, 17 Feb 2022 03:20:43 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=from:to:cc:subject:in-reply-to:references:date:message-id
 :mime-version:content-transfer-encoding;
 bh=gULrkgwQ1fsi80ryHvjJkOsjzEJH9/6f7+CBn2KhQRo=;
 b=XDIBqvWKqppP5GMiuPSM1XBeLO0EQS7cUjUJEN9Z3XHOqsZCggDLnHjCEFVnURzOHO
 wL/eIBhtQzqHMt78ANs8Eu7pSh9DKrb9P+lr5Pr7aHGbtNYJdfWExL9T4d5kCmcwLxsN
 7ZRIxLr9scuRdkzh6bXTJJbt9I2JYWISh3xdDoALdUg5GIS5vHPTRoePsaY7Eym78C3G
 hfwCZfac+tb3RUGQcAofPEa5wIQH1XxYEJGXGmKB9Ot+lxtlr6uYZZKgAJ18A1KQrnXS
 8xe5p1SpgHU9K059Uv5HLmzSSCITGCPsfOeVdMHeIH5pb8PA8es2VMP9XLtQyjjmZm+4
 D1ag==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=x-gm-message-state:from:to:cc:subject:in-reply-to:references:date
 :message-id:mime-version:content-transfer-encoding;
 bh=gULrkgwQ1fsi80ryHvjJkOsjzEJH9/6f7+CBn2KhQRo=;
 b=Z+fAWJLv+81m3HObMolsuoCasnb86XpJvPRfYvVlp5pUGdhEMhBObXmnBAAT1aqrFq
 vwMNs1wyTjTl5qAfek6MRZHeXm+5aTNvdXWq6E4gDTdEKxjvW2kqXJk5+w5+XyQgVers
 nyL9C9ZlUbAOmr4gZ6wrURaeQ2Fkl86dIjqv2zpo2zjf4yy5cymlFVvSc4zq0zpjC+Ur
 24HL/fY5BIiOyGIvtaWZRp/Ore300nH86YINW+Q8acgzVyov7BViQFdbasG02qumxL+l
 tL5mi6MG220pCkE7tjosHAyJryQGhdZM1UJR7J5nFhGMM8kZi/ZTP7+Z7m/LO4xdmvA9
 lO4A==
X-Gm-Message-State: AOAM532P29xmOM4FGZyeKJ6Y73ezAOC4ZW2vwV4CKqGF8p6ef/LWnONu
 if4RudAjBkDSquZzF6WKD1s=
X-Google-Smtp-Source: ABdhPJwYGEPSjqjSL9byaYbxIR+rNRALtu/cKg5dboWp03I013DjQ1O/U660kX+8+myHfDhXXku65g==
X-Received: by 2002:a05:600c:3b04:b0:37d:342c:3696 with SMTP id
 m4-20020a05600c3b0400b0037d342c3696mr5738050wms.62.1645096837920; 
 Thu, 17 Feb 2022 03:20:37 -0800 (PST)
Received: from lili ([2a01:e0a:59b:9120:65d2:2476:f637:db1e])
 by smtp.gmail.com with ESMTPSA id k28sm1085241wms.23.2022.02.17.03.20.36
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Thu, 17 Feb 2022 03:20:37 -0800 (PST)
From: zimoun <zimon.toutoune@HIDDEN>
To: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>, Nicolas Goaziou
 <mail@HIDDEN>
Subject: Re: [bug#53818] Improving updaters and =?utf-8?Q?=E2=80=98guix_re?=
 =?utf-8?Q?fresh=E2=80=99?=
In-Reply-To: <87mtipok57.fsf@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
 <87pmnx7ynw.fsf@HIDDEN> <87y22kxkv3.fsf@HIDDEN>
 <87leyi4fcv.fsf@HIDDEN> <87pmnprasd.fsf@HIDDEN>
 <87fsolv109.fsf@HIDDEN> <87leydqohm.fsf@HIDDEN>
 <87ee44pi4p.fsf_-_@HIDDEN> <87a6eroubv.fsf@HIDDEN>
 <87mtipok57.fsf@HIDDEN>
Date: Thu, 17 Feb 2022 12:17:14 +0100
Message-ID: <86sfsh4u9x.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 53818
Cc: 53818 <at> debbugs.gnu.org, Xinglu Chen <public@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi,

On Thu, 17 Feb 2022 at 11:35, Ludovic Court=C3=A8s <ludo@HIDDEN> wrote:

>>>   =E2=80=A2 guix refresh $(guix package -A ^emacs- | cut -f1)
>>
>> This one is interesting. This illustrates that the UI is, from my point
>> of view, a bit lacking. It would be a nice improvement to add a regexp
>> mechanism built-in, like in "guix search".
>
> Makes sense, we can do that.

I agree the UI is not nice.  Well, at the command line, I never read the
complete output of =E2=80=9Cguix package -A=E2=80=9D and I always pipe it w=
ith =E2=80=9Ccut
-f1=E2=80=9D.  Well, I think this complete display is only useful for
third-party; the only one I have in mind is emacs-guix.  Therefore, are
we maintaining this CLI for backward compatibility when we could change
both?

Something more useful as output would be:

   name version synopsis

Whatever. :-)

Even the internal etc/completion/bash/guix has to pipe:

--8<---------------cut here---------------start------------->8---
_guix_complete_available_package ()
{
    local prefix=3D"$1"
    if [ -z "$_guix_available_packages" ]
    then
	# Cache the complete list because it rarely changes and makes
	# completion much faster.
	_guix_available_packages=3D"$(${COMP_WORDS[0]} package -A 2> /dev/null \
                                    | cut -f1)"
    fi
    COMPREPLY+=3D($(compgen -W "$_guix_available_packages" -- "$prefix"))
}
--8<---------------cut here---------------end--------------->8---


Last, I am not convinced that =E2=80=9Cguix search=E2=80=9D would be help h=
ere.
Because:

  1. the output requires to pipe with recsel,
  2. it is much slower than =E2=80=9Cpackage -A=E2=80=9D [1].


1: <https://issues.guix.gnu.org/39258#119>


>>>   =E2=80=A2 guix refresh -m packages-i-care-about.scm
>>
>> Yes, obviously, this is a nice, too. However, it doesn't scale if you
>> need to specify 1000+ packages.

[...]

>> In any case, this fails after reporting status of around 50 packages,
>> with this time:
>>
>>   real	0m41,881s
>>   user	0m12,155s
>>   sys	0m0,726s
>
> How does it fail?  If it=E2=80=99s the GitHub rate limit, then there=E2=
=80=99s only one
> answer: you have to provide a token.

Let mimick a collection if 1000+ packages I care about.  Consider this
manifest for packages using r-build-system only=E2=80=A6

--8<---------------cut here---------------start------------->8---
(use-modules (guix packages)
             (gnu packages)
             (guix build-system r))

(packages->manifest
 (fold-packages (lambda (package result)
                  (if (eq? (package-build-system package) r-build-system)
                      (cons package result)
                      result))
                '()))
--8<---------------cut here---------------end--------------->8---

=E2=80=A6it hits the issue of Github token=E2=80=A6

--8<---------------cut here---------------start------------->8---
gnu/packages/bioconductor.scm:6034:13: 1.66.0 is already the latest version=
 of r-plgem
gnu/packages/bioconductor.scm:6011:13: 1.22.0 is already the latest version=
 of r-rots
gnu/packages/bioconductor.scm:12614:2: warning: 'bioconductor' updater fail=
ed to determine available releases for r-fourcseq
Backtrace:
          13 (primitive-load "/home/simon/.config/guix/current/bin/guix")

[...]

ice-9/boot-9.scm:1685:16: In procedure raise-exception:
Error downloading release information through the GitHub
API. This may be fixed by using an access token and setting the environment
variable GUIX_GITHUB_TOKEN, for instance one procured from
https://github.com/settings/tokens

real	10m27.306s
user	4m14.077s
sys	0m12.467s
--8<---------------cut here---------------end--------------->8---

=E2=80=A6when most R packages come from CRAN or Bioconductor archives.


Basically, ~5000 packages come from Github which represents ~25% of
overall.  Therefore, one needs to be really lucky when updating many
package and not hit the Github rate limit.


Yes, large collection of packages cannot be updated easily.  Somehow, it
is an issue from upstream and it is hard to fix=E2=80=A6 except by
duplicating upstream or provide a token. :-)


Well, using the external centralized Repology service is a first step to
update at scale, no?  A second step could be to have this feature
included in the Data Service; but before we have other fishes to fry,
IMHO. :-)


>> Assuming I don't get the "rate limit exceeded" error, at this rate, it
>> would take more than 15 minutes to check all the packages in
>> "emacs-xyz.scm". This is a bit long.
>>
>> I don't see how this could reasonably be made faster without relying on
>> an external centralized service doing the checks regularly (e.g., once
>> a day) before the user actually requests them.
>
> Maybe you=E2=80=99re right, but before jumping to the conclusion, we have=
 to
> investigate a bit.  Like I wrote, the =E2=80=98gnu=E2=80=99 updater for i=
nstance fetches
> a single file that remains in cache afterwards=E2=80=94the cost is consta=
nt.

Repology acts as this =E2=80=9Cexternal centralized service=E2=80=9D, no?  =
On one hand,
it is a practical solution; especially by being fast enough.  On the
other hand, it serves few false positives (say 4% to fix the ideas).

Nicolas, considering the complexity of packages and their origins, do
you think it would be possible to do better (fast and accurate) than
Repology at scale?


>>>   =E2=80=A2 guix refresh -m packages-i-care-about.scm
>>
>> Yes, obviously, this is a nice, too. However, it doesn't scale if you
>> need to specify 1000+ packages.
>
> You can use =E2=80=98fold-packages=E2=80=99 and have three lines that ret=
urn a manifest
> of 10K packages if you want it.

Yes, see example above.


>>> If not, what kind of selection mechanism could help?  =E2=80=98-s=E2=80=
=99 currently
>>> accepts only two values, but we could augment it.
>>
>> Besides regexp matching, it may be useful to filter packages per module,
>> or source file name. Package categories is a bit awkward, tho, and
>> probably not satisfying.
>
> We can add options to make it more convenient, but it=E2=80=99s already
> possible:

Since these features are advanced, why not keep the CLI simple and
instead on rely manifest files for complex filtering?


>>> I realize this is going off-topic, but let=E2=80=99s see if we can impr=
ove the
>>> existing infrastructure to make it more convenient.

[...]

> I think we have nice infrastructure but you raise important
> shortcomings.  What Xinglu Chen did might in fact be one way to address
> it, and there may also be purely UI issues that we could address.

All the points raised here are important but appears to me orthogonal
with the patch series. :-)


Cheers,
simon




Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 17 Feb 2022 10:36:00 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Feb 17 05:36:00 2022
Received: from localhost ([127.0.0.1]:50244 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nKe8m-0003SZ-5T
	for submit <at> debbugs.gnu.org; Thu, 17 Feb 2022 05:36:00 -0500
Received: from hera.aquilenet.fr ([185.233.100.1]:56830)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1nKe8k-0003SL-4R
 for 53818 <at> debbugs.gnu.org; Thu, 17 Feb 2022 05:35:58 -0500
Received: from localhost (localhost [127.0.0.1])
 by hera.aquilenet.fr (Postfix) with ESMTP id 7575E8DE;
 Thu, 17 Feb 2022 11:35:51 +0100 (CET)
X-Virus-Scanned: Debian amavisd-new at aquilenet.fr
Received: from hera.aquilenet.fr ([127.0.0.1])
 by localhost (hera.aquilenet.fr [127.0.0.1]) (amavisd-new, port 10024)
 with ESMTP id PuMFHHma5jqt; Thu, 17 Feb 2022 11:35:50 +0100 (CET)
Received: from ribbon (unknown [IPv6:2001:660:6102:320:e120:2c8f:8909:cdfe])
 by hera.aquilenet.fr (Postfix) with ESMTPSA id B83B44A;
 Thu, 17 Feb 2022 11:35:49 +0100 (CET)
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: Nicolas Goaziou <mail@HIDDEN>
Subject: Re: [bug#53818] Improving updaters and =?utf-8?Q?=E2=80=98guix_re?=
 =?utf-8?Q?fresh=E2=80=99?=
References: <cover.1644147246.git.public@HIDDEN>
 <87pmnx7ynw.fsf@HIDDEN> <87y22kxkv3.fsf@HIDDEN>
 <87leyi4fcv.fsf@HIDDEN> <87pmnprasd.fsf@HIDDEN>
 <87fsolv109.fsf@HIDDEN> <87leydqohm.fsf@HIDDEN>
 <87ee44pi4p.fsf_-_@HIDDEN> <87a6eroubv.fsf@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: 29 =?utf-8?Q?Pluvi=C3=B4se?= an 230 de la
 =?utf-8?Q?R=C3=A9volution?=
X-PGP-Key-ID: 0x090B11993D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-pc-linux-gnu
Date: Thu, 17 Feb 2022 11:35:48 +0100
In-Reply-To: <87a6eroubv.fsf@HIDDEN> (Nicolas Goaziou's message of
 "Wed, 16 Feb 2022 13:43:32 +0100")
Message-ID: <87mtipok57.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spamd-Bar: /
Authentication-Results: hera.aquilenet.fr;
	none
X-Rspamd-Server: hera
X-Rspamd-Queue-Id: 7575E8DE
X-Spamd-Result: default: False [-0.10 / 15.00]; ARC_NA(0.00)[];
 RCVD_VIA_SMTP_AUTH(0.00)[]; FROM_HAS_DN(0.00)[];
 RCPT_COUNT_THREE(0.00)[3]; TO_DN_SOME(0.00)[];
 TO_MATCH_ENVRCPT_ALL(0.00)[]; MIME_GOOD(-0.10)[text/plain];
 FROM_EQ_ENVFROM(0.00)[]; MIME_TRACE(0.00)[0:+];
 RCVD_COUNT_TWO(0.00)[2]; RCVD_TLS_ALL(0.00)[];
 MID_RHS_MATCH_FROM(0.00)[]
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 53818
Cc: 53818 <at> debbugs.gnu.org, Xinglu Chen <public@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

Hi,

Nicolas Goaziou <mail@HIDDEN> skribis:

> Ludovic Court=C3=A8s <ludo@HIDDEN> writes:
>
>> Regarding =E2=80=9Cspecifying many packages=E2=80=9D, do examples like t=
hese work for
>> you:
>>
>>   =E2=80=A2 guix refresh -t elpa
>
> I don't find it very useful in practice. As a user, the packages I'm
> interested in probably rely on more than one updater. I'm not even
> supposed to know what updater relates to a given package.

Right, that=E2=80=99s more for packagers than for users.

As a user, what works better is:

  guix refresh -r $(guix package -I |cut -f1) -s non-core

=E2=80=A6 or simply =E2=80=98--with-latest=E2=80=99, if I=E2=80=99m not int=
erested in updating package
definitions.

>>   =E2=80=A2 guix refresh $(guix package -A ^emacs- | cut -f1)
>
> This one is interesting. This illustrates that the UI is, from my point
> of view, a bit lacking. It would be a nice improvement to add a regexp
> mechanism built-in, like in "guix search".

Makes sense, we can do that.

> In any case, this fails after reporting status of around 50 packages,
> with this time:
>
>   real	0m41,881s
>   user	0m12,155s
>   sys	0m0,726s

How does it fail?  If it=E2=80=99s the GitHub rate limit, then there=E2=80=
=99s only one
answer: you have to provide a token.

> Assuming I don't get the "rate limit exceeded" error, at this rate, it
> would take more than 15 minutes to check all the packages in
> "emacs-xyz.scm". This is a bit long.

> I don't see how this could reasonably be made faster without relying on
> an external centralized service doing the checks regularly (e.g., once
> a day) before the user actually requests them.

Maybe you=E2=80=99re right, but before jumping to the conclusion, we have to
investigate a bit.  Like I wrote, the =E2=80=98gnu=E2=80=99 updater for ins=
tance fetches
a single file that remains in cache afterwards=E2=80=94the cost is constant.

We should identify updaters that have linear cost and check what can be
done.  =E2=80=98github=E2=80=99, =E2=80=98generic-html=E2=80=99, and =E2=80=
=98generic-git=E2=80=99 are of that kind.

Now, the command I gave above looks at 1,134 packages, so is it even
something you want to do as a packager?

>>   =E2=80=A2 guix refresh -r emacs-emms
>
> It also fails with the "rate limit exceeded". While this sounds
> theoretically nice, I wouldn't know how to make use of it yet.
>
>>   =E2=80=A2 guix refresh -s non-core -t generic-git
>
> See above about "-t elpa".
>
>>   =E2=80=A2 guix refresh -m packages-i-care-about.scm
>
> Yes, obviously, this is a nice, too. However, it doesn't scale if you
> need to specify 1000+ packages.

You can use =E2=80=98fold-packages=E2=80=99 and have three lines that retur=
n a manifest
of 10K packages if you want it.

Honestly, since I mostly rely on others these days :-), I=E2=80=99m no long=
er
sure what the packager=E2=80=99s workflow is.  Also, the level of coupling
varies greatly between, say, a C/C++ package and a set of
Python/Emacs/Rust packages.

I find that =E2=80=98guix refresh=E2=80=99 works fine for loosely-coupled C=
/C++ packages
where often you=E2=80=99d want to upgrade packages individually.

But for Python and Emacs packages, what do we want?  Do packagers always
want to check 1K+ packages at once?  Or are there other patterns?

>> If not, what kind of selection mechanism could help?  =E2=80=98-s=E2=80=
=99 currently
>> accepts only two values, but we could augment it.
>
> Besides regexp matching, it may be useful to filter packages per module,
> or source file name. Package categories is a bit awkward, tho, and
> probably not satisfying.

We can add options to make it more convenient, but it=E2=80=99s already
possible:

  guix refresh $(guix package -A | grep emacs-xyz.scm | cut -f1)

>> I realize this is going off-topic, but let=E2=80=99s see if we can impro=
ve the
>> existing infrastructure to make it more convenient.
>
> Is it really off-topic?
>
> Anyway, all of this is only one data point, and, as a reminder,
> I certainly don't want to disparage either Xinglu Chen's work, or
> current "guix refresh" functionality.

Yup, same here!

I think we have nice infrastructure but you raise important
shortcomings.  What Xinglu Chen did might in fact be one way to address
it, and there may also be purely UI issues that we could address.

Thanks,
Ludo=E2=80=99.




Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 16 Feb 2022 12:44:04 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Feb 16 07:44:04 2022
Received: from localhost ([127.0.0.1]:47742 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nKJev-0006bc-55
	for submit <at> debbugs.gnu.org; Wed, 16 Feb 2022 07:44:04 -0500
Received: from relay11.mail.gandi.net ([217.70.178.231]:34731)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mail@HIDDEN>) id 1nKJem-0006b9-OM
 for 53818 <at> debbugs.gnu.org; Wed, 16 Feb 2022 07:43:48 -0500
Received: (Authenticated sender: admin@HIDDEN)
 by mail.gandi.net (Postfix) with ESMTPSA id 395D6100004;
 Wed, 16 Feb 2022 12:43:32 +0000 (UTC)
From: Nicolas Goaziou <mail@HIDDEN>
To: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>
Subject: Re: [bug#53818] Improving updaters and =?utf-8?Q?=E2=80=98guix_re?=
 =?utf-8?Q?fresh=E2=80=99?=
References: <cover.1644147246.git.public@HIDDEN>
 <87pmnx7ynw.fsf@HIDDEN> <87y22kxkv3.fsf@HIDDEN>
 <87leyi4fcv.fsf@HIDDEN> <87pmnprasd.fsf@HIDDEN>
 <87fsolv109.fsf@HIDDEN> <87leydqohm.fsf@HIDDEN>
 <87ee44pi4p.fsf_-_@HIDDEN>
Date: Wed, 16 Feb 2022 13:43:32 +0100
In-Reply-To: <87ee44pi4p.fsf_-_@HIDDEN> ("Ludovic =?utf-8?Q?Court=C3=A8s?=
 =?utf-8?Q?=22's?= message of "Tue, 15 Feb 2022 10:57:10 +0100")
Message-ID: <87a6eroubv.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 53818
Cc: 53818 <at> debbugs.gnu.org, Xinglu Chen <public@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hello,

Ludovic Court=C3=A8s <ludo@HIDDEN> writes:

> Regarding =E2=80=9Cspecifying many packages=E2=80=9D, do examples like th=
ese work for
> you:
>
>   =E2=80=A2 guix refresh -t elpa

I don't find it very useful in practice. As a user, the packages I'm
interested in probably rely on more than one updater. I'm not even
supposed to know what updater relates to a given package.

I actually only use this when I know a GNU ELPA package is outdated
already, and I want it to compute the hash for me:

  ./pre-inst-env guix refresh -t elpa -u emacs-foo

>   =E2=80=A2 guix refresh $(guix package -A ^emacs- | cut -f1)

This one is interesting. This illustrates that the UI is, from my point
of view, a bit lacking. It would be a nice improvement to add a regexp
mechanism built-in, like in "guix search".

In any case, this fails after reporting status of around 50 packages,
with this time:

  real	0m41,881s
  user	0m12,155s
  sys	0m0,726s

Assuming I don't get the "rate limit exceeded" error, at this rate, it
would take more than 15 minutes to check all the packages in
"emacs-xyz.scm". This is a bit long.

I don't see how this could reasonably be made faster without relying on
an external centralized service doing the checks regularly (e.g., once
a day) before the user actually requests them.

>   =E2=80=A2 guix refresh -r emacs-emms

It also fails with the "rate limit exceeded". While this sounds
theoretically nice, I wouldn't know how to make use of it yet.

>   =E2=80=A2 guix refresh -s non-core -t generic-git

See above about "-t elpa".

>   =E2=80=A2 guix refresh -m packages-i-care-about.scm

Yes, obviously, this is a nice, too. However, it doesn't scale if you
need to specify 1000+ packages.

> If not, what kind of selection mechanism could help?  =E2=80=98-s=E2=80=
=99 currently
> accepts only two values, but we could augment it.

Besides regexp matching, it may be useful to filter packages per module,
or source file name. Package categories is a bit awkward, tho, and
probably not satisfying.

> I realize this is going off-topic, but let=E2=80=99s see if we can improv=
e the
> existing infrastructure to make it more convenient.

Is it really off-topic?

Anyway, all of this is only one data point, and, as a reminder,
I certainly don't want to disparage either Xinglu Chen's work, or
current "guix refresh" functionality.

HTH,
--=20
Nicolas Goaziou




Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 15 Feb 2022 09:57:20 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 15 04:57:20 2022
Received: from localhost ([127.0.0.1]:43560 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nJuaG-0003H9-Ef
	for submit <at> debbugs.gnu.org; Tue, 15 Feb 2022 04:57:20 -0500
Received: from hera.aquilenet.fr ([185.233.100.1]:41140)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1nJuaF-0003Gw-16
 for 53818 <at> debbugs.gnu.org; Tue, 15 Feb 2022 04:57:19 -0500
Received: from localhost (localhost [127.0.0.1])
 by hera.aquilenet.fr (Postfix) with ESMTP id 5D98FB18;
 Tue, 15 Feb 2022 10:57:12 +0100 (CET)
X-Virus-Scanned: Debian amavisd-new at aquilenet.fr
Received: from hera.aquilenet.fr ([127.0.0.1])
 by localhost (hera.aquilenet.fr [127.0.0.1]) (amavisd-new, port 10024)
 with ESMTP id xWZlPUr2KllV; Tue, 15 Feb 2022 10:57:11 +0100 (CET)
Received: from ribbon (unknown [IPv6:2001:660:6102:320:e120:2c8f:8909:cdfe])
 by hera.aquilenet.fr (Postfix) with ESMTPSA id 06C1C237;
 Tue, 15 Feb 2022 10:57:10 +0100 (CET)
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: Nicolas Goaziou <mail@HIDDEN>
Subject: Improving updaters and =?utf-8?Q?=E2=80=98guix_refresh=E2=80=99?=
References: <cover.1644147246.git.public@HIDDEN>
 <87pmnx7ynw.fsf@HIDDEN> <87y22kxkv3.fsf@HIDDEN>
 <87leyi4fcv.fsf@HIDDEN> <87pmnprasd.fsf@HIDDEN>
 <87fsolv109.fsf@HIDDEN> <87leydqohm.fsf@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: 27 =?utf-8?Q?Pluvi=C3=B4se?= an 230 de la
 =?utf-8?Q?R=C3=A9volution?=
X-PGP-Key-ID: 0x090B11993D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-pc-linux-gnu
Date: Tue, 15 Feb 2022 10:57:10 +0100
In-Reply-To: <87leydqohm.fsf@HIDDEN> (Nicolas Goaziou's message of
 "Mon, 14 Feb 2022 19:42:13 +0100")
Message-ID: <87ee44pi4p.fsf_-_@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spamd-Bar: /
Authentication-Results: hera.aquilenet.fr;
	none
X-Rspamd-Server: hera
X-Rspamd-Queue-Id: 5D98FB18
X-Spamd-Result: default: False [0.61 / 15.00]; ARC_NA(0.00)[];
 RCVD_VIA_SMTP_AUTH(0.00)[]; FROM_HAS_DN(0.00)[];
 RCPT_COUNT_THREE(0.00)[3]; TO_DN_SOME(0.00)[];
 TO_MATCH_ENVRCPT_ALL(0.00)[]; MIME_GOOD(-0.10)[text/plain];
 FROM_EQ_ENVFROM(0.00)[]; MIME_TRACE(0.00)[0:+];
 R_MIXED_CHARSET(0.71)[subject]; RCVD_COUNT_TWO(0.00)[2];
 RCVD_TLS_ALL(0.00)[]; MID_RHS_MATCH_FROM(0.00)[]
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 53818
Cc: 53818 <at> debbugs.gnu.org, Xinglu Chen <public@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

Hi!

Nicolas Goaziou <mail@HIDDEN> skribis:

> Ludovic Court=C3=A8s <ludo@HIDDEN> writes:
>
>> (I=E2=80=99m confused because my understanding of what you first wrote w=
as that
>> Repology had too many false positives to be useful.)
>
> Repology is okay for my use-case because I've gotten accustomed to its
> quirks. I wouldn't recommend it as a fall-back solution for Guix in its
> current form, tho, for the reason above. Does that make sense?

It sure does, thanks for explaining.

> I wrote about the following facts:
> - it is difficult to specify a large number of packages,
> - when you have specified a large number of packages, the processing is
>   slow,
> - checking GitHub fails for me.

Alright, I had missed that.

Regarding =E2=80=9Cspecifying many packages=E2=80=9D, do examples like thes=
e work for
you:

  =E2=80=A2 guix refresh -t elpa

  =E2=80=A2 guix refresh $(guix package -A ^emacs- | cut -f1)

  =E2=80=A2 guix refresh -r emacs-emms

  =E2=80=A2 guix refresh -s non-core -t generic-git

  =E2=80=A2 guix refresh -m packages-i-care-about.scm

If not, what kind of selection mechanism could help?  =E2=80=98-s=E2=80=99 =
currently
accepts only two values, but we could augment it.

Regarding slow processing, it very much depends on the updater.  For
example, on a warm cache, =E2=80=98guix refresh -t gnu=E2=80=99 is relative=
ly fast
thanks to caching:

--8<---------------cut here---------------start------------->8---
$ time guix refresh -t gnu
gnu/packages/wget.scm:48:13: wget would be upgraded from 1.21.1 to 1.21.2
gnu/packages/tls.scm:86:13: libtasn1 would be upgraded from 4.17.0 to 4.18.0

[...]


real	0m38.314s
user	0m38.981s
sys	0m0.164s
--8<---------------cut here---------------end--------------->8---

It could be that some updaters do many HTTP round trips without any
caching, which slows things down.

[...]

>> Do you have examples of what=E2=80=99s wrong on the UI side?
>
> It has no Emacs interface. Nuff said. ;)

True!  :-)

I realize this is going off-topic, but let=E2=80=99s see if we can improve =
the
existing infrastructure to make it more convenient.

Thanks,
Ludo=E2=80=99.




Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 14 Feb 2022 18:42:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 14 13:42:24 2022
Received: from localhost ([127.0.0.1]:42563 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nJgIp-0002nV-Sv
	for submit <at> debbugs.gnu.org; Mon, 14 Feb 2022 13:42:24 -0500
Received: from relay6-d.mail.gandi.net ([217.70.183.198]:47081)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mail@HIDDEN>) id 1nJgIn-0002nE-GQ
 for 53818 <at> debbugs.gnu.org; Mon, 14 Feb 2022 13:42:23 -0500
Received: (Authenticated sender: admin@HIDDEN)
 by mail.gandi.net (Postfix) with ESMTPSA id 92181C0003;
 Mon, 14 Feb 2022 18:42:14 +0000 (UTC)
From: Nicolas Goaziou <mail@HIDDEN>
To: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>
Subject: Re: [bug#53818] [PATCH 0/3] Add Repology updater
References: <cover.1644147246.git.public@HIDDEN>
 <87pmnx7ynw.fsf@HIDDEN> <87y22kxkv3.fsf@HIDDEN>
 <87leyi4fcv.fsf@HIDDEN> <87pmnprasd.fsf@HIDDEN>
 <87fsolv109.fsf@HIDDEN>
Date: Mon, 14 Feb 2022 19:42:13 +0100
In-Reply-To: <87fsolv109.fsf@HIDDEN> ("Ludovic =?utf-8?Q?Court=C3=A8s=22'?=
 =?utf-8?Q?s?= message of "Mon, 14 Feb 2022 17:58:14 +0100")
Message-ID: <87leydqohm.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 53818
Cc: 53818 <at> debbugs.gnu.org, Xinglu Chen <public@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Hello,

Ludovic Court=C3=A8s <ludo@HIDDEN> writes:

> (I=E2=80=99m confused because my understanding of what you first wrote wa=
s that
> Repology had too many false positives to be useful.)

Repology is okay for my use-case because I've gotten accustomed to its
quirks. I wouldn't recommend it as a fall-back solution for Guix in its
current form, tho, for the reason above. Does that make sense?

> You wrote about your feelings and that=E2=80=99s insightful, but can we f=
ocus on
> specific examples where updaters are not helpful so we can better
> understand and improve the situation?

I wrote about the following facts:
- it is difficult to specify a large number of packages,
- when you have specified a large number of packages, the processing is
  slow,
- checking GitHub fails for me.

I don't see any feelings in there.

>> IMO, to be useful, updaters may need to rely on an external service,
>> which may, or may not, belong to the Guix ecosystem.
>
> All the updaters rely on an external service.  Relying on a centralized
> SaaSS is different, though.

Fair enough. I meant an external centralized service.

> Do you have examples of what=E2=80=99s wrong on the UI side?

It has no Emacs interface. Nuff said. ;)

Again, I don't know how to specify efficiently many packages, e.g., all
Emacs packages, or all games. Also, reading through a massive output in
the terminal is not very user friendly, IMO.

> To me, the main shortcoming is that =E2=80=98guix refresh=E2=80=99 doesn=
=E2=80=99t tell you that
> if you update X, you may also need to update Y and Z.  That info is not
> always available, but it is available in repos such as PyPI and ELPA.

I don't think solving this is realistic. Dependencies are sometimes very
loose.

Regards,
--=20
Nicolas Goaziou




Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 14 Feb 2022 16:58:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 14 11:58:25 2022
Received: from localhost ([127.0.0.1]:42424 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nJegC-00007F-Un
	for submit <at> debbugs.gnu.org; Mon, 14 Feb 2022 11:58:25 -0500
Received: from hera.aquilenet.fr ([185.233.100.1]:48520)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1nJegA-000071-Jw
 for 53818 <at> debbugs.gnu.org; Mon, 14 Feb 2022 11:58:23 -0500
Received: from localhost (localhost [127.0.0.1])
 by hera.aquilenet.fr (Postfix) with ESMTP id 1823EB50;
 Mon, 14 Feb 2022 17:58:16 +0100 (CET)
X-Virus-Scanned: Debian amavisd-new at aquilenet.fr
Received: from hera.aquilenet.fr ([127.0.0.1])
 by localhost (hera.aquilenet.fr [127.0.0.1]) (amavisd-new, port 10024)
 with ESMTP id B7_zIefUA3Fx; Mon, 14 Feb 2022 17:58:15 +0100 (CET)
Received: from ribbon (unknown [IPv6:2a01:e0a:1d:7270:af76:b9b:ca24:c465])
 by hera.aquilenet.fr (Postfix) with ESMTPSA id AE4AC1CA;
 Mon, 14 Feb 2022 17:58:14 +0100 (CET)
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: Nicolas Goaziou <mail@HIDDEN>
Subject: Re: [bug#53818] [PATCH 0/3] Add Repology updater
References: <cover.1644147246.git.public@HIDDEN>
 <87pmnx7ynw.fsf@HIDDEN> <87y22kxkv3.fsf@HIDDEN>
 <87leyi4fcv.fsf@HIDDEN> <87pmnprasd.fsf@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: 26 =?utf-8?Q?Pluvi=C3=B4se?= an 230 de la
 =?utf-8?Q?R=C3=A9volution?=
X-PGP-Key-ID: 0x090B11993D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-pc-linux-gnu
Date: Mon, 14 Feb 2022 17:58:14 +0100
In-Reply-To: <87pmnprasd.fsf@HIDDEN> (Nicolas Goaziou's message of
 "Mon, 14 Feb 2022 11:40:34 +0100")
Message-ID: <87fsolv109.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spamd-Bar: /
Authentication-Results: hera.aquilenet.fr;
	none
X-Rspamd-Server: hera
X-Rspamd-Queue-Id: 1823EB50
X-Spamd-Result: default: False [-0.10 / 15.00]; ARC_NA(0.00)[];
 RCVD_VIA_SMTP_AUTH(0.00)[]; FROM_HAS_DN(0.00)[];
 RCPT_COUNT_THREE(0.00)[3]; TO_DN_SOME(0.00)[];
 TO_MATCH_ENVRCPT_ALL(0.00)[]; MIME_GOOD(-0.10)[text/plain];
 FROM_EQ_ENVFROM(0.00)[]; MIME_TRACE(0.00)[0:+];
 RCVD_COUNT_TWO(0.00)[2]; RCVD_TLS_ALL(0.00)[];
 MID_RHS_MATCH_FROM(0.00)[]
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 53818
Cc: 53818 <at> debbugs.gnu.org, Xinglu Chen <public@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

Hi Nicolas,

Nicolas Goaziou <mail@HIDDEN> skribis:

> Ludovic Court=C3=A8s <ludo@HIDDEN> writes:
>
>> Do you have examples where our updaters perform poorly and where
>> Repology does a better job?  I wonder if there are lessons to be drawn
>> and bugs to be fixed.
>
> As a data point, I'm sorry to say that our updaters are useless to me.
>
> I watch over more than one thousand packages. I would have a hard time
> expressing what are those packages to the updater, besides writing and
> keeping up-to-date a huge manifest file. Assuming I could manage this,
> fetching all version information would take considerable time, and,
> since many packages are from GitHub, the party would stop early anyway
> with GitHub refusing to proceed and requesting some token I don't have.
>
> OTOH, using Repology API, I get the information I want in about ten
> seconds. Sure, I need to eyeball through the results, filtering false
> positives (around 4% in my case), but it still is a practical solution.

(I=E2=80=99m confused because my understanding of what you first wrote was =
that
Repology had too many false positives to be useful.)

You wrote about your feelings and that=E2=80=99s insightful, but can we foc=
us on
specific examples where updaters are not helpful so we can better
understand and improve the situation?

> IMO, to be useful, updaters may need to rely on an external service,
> which may, or may not, belong to the Guix ecosystem.

All the updaters rely on an external service.  Relying on a centralized
SaaSS is different, though.

> They also need a good UI.

Do you have examples of what=E2=80=99s wrong on the UI side?

To me, the main shortcoming is that =E2=80=98guix refresh=E2=80=99 doesn=E2=
=80=99t tell you that
if you update X, you may also need to update Y and Z.  That info is not
always available, but it is available in repos such as PyPI and ELPA.

Thanks,
Ludo=E2=80=99.




Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 14 Feb 2022 16:07:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 14 11:07:20 2022
Received: from localhost ([127.0.0.1]:42345 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nJdsm-0004uD-Kp
	for submit <at> debbugs.gnu.org; Mon, 14 Feb 2022 11:07:20 -0500
Received: from laurent.telenet-ops.be ([195.130.137.89]:57814)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <maximedevos@HIDDEN>) id 1nJdsg-0004u0-UX
 for 53818 <at> debbugs.gnu.org; Mon, 14 Feb 2022 11:07:19 -0500
Received: from ptr-bvsjgyhxw7psv60dyze.18120a2.ip6.access.telenet.be
 ([IPv6:2a02:1811:8c09:9d00:3c5f:2eff:feb0:ba5a])
 by laurent.telenet-ops.be with bizsmtp
 id v47D2600G4UW6Th0147D0m; Mon, 14 Feb 2022 17:07:13 +0100
Message-ID: <0c9466812aeafc33df51270feed16f8f16c531e7.camel@HIDDEN>
Subject: Re: [bug#53818] [PATCH 0/3] Add Repology updater
From: Maxime Devos <maximedevos@HIDDEN>
To: Nicolas Goaziou <mail@HIDDEN>, Ludovic
 =?ISO-8859-1?Q?Court=E8s?= <ludo@HIDDEN>
Date: Mon, 14 Feb 2022 17:07:07 +0100
In-Reply-To: <87pmnprasd.fsf@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
 <87pmnx7ynw.fsf@HIDDEN> <87y22kxkv3.fsf@HIDDEN>
 <87leyi4fcv.fsf@HIDDEN> <87pmnprasd.fsf@HIDDEN>
Content-Type: multipart/signed; micalg="pgp-sha512";
 protocol="application/pgp-signature"; boundary="=-hNi2PQ24BAUsVe0erF0z"
User-Agent: Evolution 3.38.3-1 
MIME-Version: 1.0
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=telenet.be; s=r22;
 t=1644854833; bh=qyrbr8XFRt+3mSPbP6wsSjot67U7LkcGNhY4r6KKd24=;
 h=Subject:From:To:Cc:Date:In-Reply-To:References;
 b=eXyQN+laVt1ft2kRYxLrBQLcIZhZFFh/tTY1hWO4K77u4RcWsyE15O6X41BCIm9xu
 vs3ATBk0AnvqE27N9qUIh3bbNv8GtB2XjFHjCN1wOnGMT9SP+uXhQDyutmj4srvxky
 GnyU1iEv3xyc2BHJyu2kw5ihkAbtoE2wiCqOrvgZxr4w9Bj9+eXA3XGeNcCPPFQ4HT
 pedHy/4ZnOZ2DChbeGlySiEituotYERh+w7lUXJrKCtd6qOBqf4cOa3cPnUuFW062R
 S95rFlZs2b2dGPkdumgbTKhhcdlyFnpJlM1at0X+HCgC8SLTch7MiQ8JtiLLfPmmsN
 g8txrD9w/9Abw==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 53818
Cc: 53818 <at> debbugs.gnu.org, Xinglu Chen <public@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)


--=-hNi2PQ24BAUsVe0erF0z
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable

Nicolas Goaziou schreef op ma 14-02-2022 om 11:40 [+0100]:
> [...]. Assuming I could manage this,
> fetching all version information would take considerable time, and,
> since many packages are from GitHub, the party would stop early anyway
> with GitHub refusing to proceed and requesting some token I don't have.
>=20
> OTOH, using Repology API, I get the information I want in about ten
> seconds. Sure, I need to eyeball through the results, filtering false
> positives (around 4% in my case), but it still is a practical solution.
>=20
> IMO, to be useful, updaters may need to rely on an external service,
> which may, or may not, belong to the Guix ecosystem. They also need
> a good UI.

To avoid exceeding API limits and reduce network traffic, I suggest the
following change:

  Cache HTTP responses, using http-fetch/cached instead of
  http-fetch.  When something is in the cache and not expired,
  this avoids some network traffic and does not bring us closer
  to the API limits.

  When it is expired (and in the cache), then at least
  http-fetch/cached makes a conditional request with
  If-Modified-Since, which GitHub does not count against the rate
  limit, assuming a =E2=80=98304 Not Modified=E2=80=99 response!

That does not address all your concerns but it should help I think.

Greetings,
Maxime.

--=-hNi2PQ24BAUsVe0erF0z
Content-Type: application/pgp-signature; name="signature.asc"
Content-Description: This is a digitally signed message part
Content-Transfer-Encoding: 7bit

-----BEGIN PGP SIGNATURE-----

iI0EABYKADUWIQTB8z7iDFKP233XAR9J4+4iGRcl7gUCYgp+KxccbWF4aW1lZGV2
b3NAdGVsZW5ldC5iZQAKCRBJ4+4iGRcl7rs8AQCPb2Nc7ojg6vJ8KIfvTrVdwhjO
A2RbswK28kuzJzYJVgEA0XaZ4XfcThz6CWWQf9GERfNDQsfmDBW/l1rCGt0pZwo=
=XkiL
-----END PGP SIGNATURE-----

--=-hNi2PQ24BAUsVe0erF0z--





Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 14 Feb 2022 10:40:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 14 05:40:46 2022
Received: from localhost ([127.0.0.1]:39945 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nJYmj-00029f-Sm
	for submit <at> debbugs.gnu.org; Mon, 14 Feb 2022 05:40:46 -0500
Received: from relay6-d.mail.gandi.net ([217.70.183.198]:53485)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mail@HIDDEN>) id 1nJYmh-00029Q-5q
 for 53818 <at> debbugs.gnu.org; Mon, 14 Feb 2022 05:40:44 -0500
Received: (Authenticated sender: admin@HIDDEN)
 by mail.gandi.net (Postfix) with ESMTPSA id 349B1C0006;
 Mon, 14 Feb 2022 10:40:35 +0000 (UTC)
From: Nicolas Goaziou <mail@HIDDEN>
To: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>
Subject: Re: [bug#53818] [PATCH 0/3] Add Repology updater
References: <cover.1644147246.git.public@HIDDEN>
 <87pmnx7ynw.fsf@HIDDEN> <87y22kxkv3.fsf@HIDDEN>
 <87leyi4fcv.fsf@HIDDEN>
Date: Mon, 14 Feb 2022 11:40:34 +0100
In-Reply-To: <87leyi4fcv.fsf@HIDDEN> ("Ludovic =?utf-8?Q?Court=C3=A8s=22'?=
 =?utf-8?Q?s?= message of "Thu, 10 Feb 2022 21:49:04 +0100")
Message-ID: <87pmnprasd.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 53818
Cc: 53818 <at> debbugs.gnu.org, Xinglu Chen <public@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Hello,

Ludovic Court=C3=A8s <ludo@HIDDEN> writes:

> Do you have examples where our updaters perform poorly and where
> Repology does a better job?  I wonder if there are lessons to be drawn
> and bugs to be fixed.

As a data point, I'm sorry to say that our updaters are useless to me.

I watch over more than one thousand packages. I would have a hard time
expressing what are those packages to the updater, besides writing and
keeping up-to-date a huge manifest file. Assuming I could manage this,
fetching all version information would take considerable time, and,
since many packages are from GitHub, the party would stop early anyway
with GitHub refusing to proceed and requesting some token I don't have.

OTOH, using Repology API, I get the information I want in about ten
seconds. Sure, I need to eyeball through the results, filtering false
positives (around 4% in my case), but it still is a practical solution.

IMO, to be useful, updaters may need to rely on an external service,
which may, or may not, belong to the Guix ecosystem. They also need
a good UI.

I don't want to sound too negative, though. And current updaters are
certainly good enough when watching over a couple of packages, which
might be the most common use-case.

Cheers,
--=20
Nicolas Goaziou




Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 10 Feb 2022 20:49:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Feb 10 15:49:13 2022
Received: from localhost ([127.0.0.1]:57305 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nIGNN-0003PR-KB
	for submit <at> debbugs.gnu.org; Thu, 10 Feb 2022 15:49:13 -0500
Received: from hera.aquilenet.fr ([185.233.100.1]:38924)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1nIGNM-0003P9-11
 for 53818 <at> debbugs.gnu.org; Thu, 10 Feb 2022 15:49:12 -0500
Received: from localhost (localhost [127.0.0.1])
 by hera.aquilenet.fr (Postfix) with ESMTP id F27C25DF;
 Thu, 10 Feb 2022 21:49:05 +0100 (CET)
X-Virus-Scanned: Debian amavisd-new at aquilenet.fr
Received: from hera.aquilenet.fr ([127.0.0.1])
 by localhost (hera.aquilenet.fr [127.0.0.1]) (amavisd-new, port 10024)
 with ESMTP id SOheB-Ww_xUy; Thu, 10 Feb 2022 21:49:05 +0100 (CET)
Received: from ribbon (91-160-117-201.subs.proxad.net [91.160.117.201])
 by hera.aquilenet.fr (Postfix) with ESMTPSA id 951EA174;
 Thu, 10 Feb 2022 21:49:04 +0100 (CET)
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: Xinglu Chen <public@HIDDEN>
Subject: Re: [bug#53818] [PATCH 0/3] Add Repology updater
References: <cover.1644147246.git.public@HIDDEN>
 <87pmnx7ynw.fsf@HIDDEN> <87y22kxkv3.fsf@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: 22 =?utf-8?Q?Pluvi=C3=B4se?= an 230 de la
 =?utf-8?Q?R=C3=A9volution?=
X-PGP-Key-ID: 0x090B11993D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-pc-linux-gnu
Date: Thu, 10 Feb 2022 21:49:04 +0100
In-Reply-To: <87y22kxkv3.fsf@HIDDEN> (Xinglu Chen's message of "Wed, 09
 Feb 2022 13:52:48 +0100")
Message-ID: <87leyi4fcv.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spamd-Bar: /
Authentication-Results: hera.aquilenet.fr;
	none
X-Rspamd-Server: hera
X-Rspamd-Queue-Id: F27C25DF
X-Spamd-Result: default: False [-0.10 / 15.00]; ARC_NA(0.00)[];
 RCVD_VIA_SMTP_AUTH(0.00)[]; RCPT_COUNT_TWO(0.00)[2];
 FROM_HAS_DN(0.00)[]; TO_DN_SOME(0.00)[];
 TO_MATCH_ENVRCPT_ALL(0.00)[]; MIME_GOOD(-0.10)[text/plain];
 FROM_EQ_ENVFROM(0.00)[]; MIME_TRACE(0.00)[0:+];
 RCVD_COUNT_TWO(0.00)[2]; RCVD_TLS_ALL(0.00)[];
 MID_RHS_MATCH_FROM(0.00)[]
X-Spam-Score: 2.6 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  Hi, Xinglu Chen <public@HIDDEN> skribis: > Ludovic
 schrieb am Dienstag der 08. Februar 2022 um 23:59 +01: 
 Content analysis details:   (2.6 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
 1.0 SPF_SOFTFAIL           SPF: sender does not match SPF record (softfail)
 1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
 [URI: yoctocell.xyz (xyz)]
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
X-Debbugs-Envelope-To: 53818
Cc: 53818 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.6 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Hi, Xinglu Chen <public@HIDDEN> skribis: > Ludovic
   schrieb am Dienstag der 08. Februar 2022 um 23:59 +01: 
 
 Content analysis details:   (1.6 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
  1.0 SPF_SOFTFAIL           SPF: sender does not match SPF record (softfail)
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager

Hi,

Xinglu Chen <public@HIDDEN> skribis:

> Ludovic schrieb am Dienstag der 08. Februar 2022 um 23:59 +01:

[...]

>> Repology implements the same functionality as our updaters, so
>> repology.org is effectively =E2=80=9Cservice as a software substitute=E2=
=80=9D
>> (SaaSS).
>
> Right, but it tracks a lot more repositories than what our updaters do,
> so why not take advantage of that.

True, but this is kinda self-reinforcing: it=E2=80=99ll sure keep tracking =
more
if we stop maintaining our own code (IIRC, Repology was started after
=E2=80=98guix refresh=E2=80=99 and I believe it=E2=80=99s maintained by one=
 person.)

>> My preference would be to keep our existing updaters rather than
>> effectively ditch them and delegate the work to Repology.  It=E2=80=99s =
tempting
>> to think we can have both, but I=E2=80=99m not sure this would last long.
>
> The point of the Repology updater is to act as a fallback if none of
> the other updaters can update a package, e.g., =E2=80=98maven-dependency-=
tree=E2=80=99.
> I already mentioned that language-specific updaters usually provide more
> accurate and detailed information, so they should be used when possible;
> we aren=E2=80=99t losing anything here.

Hmm yes, could be.  OTOH, like Nicolas writes, we would probably need
some filtering or post-processing to reduce false-positives, right?

Do you have examples where our updaters perform poorly and where
Repology does a better job?  I wonder if there are lessons to be drawn
and bugs to be fixed.

Thanks,
Ludo=E2=80=99.




Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 10 Feb 2022 19:30:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Feb 10 14:30:38 2022
Received: from localhost ([127.0.0.1]:57176 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nIF9K-00017E-Hx
	for submit <at> debbugs.gnu.org; Thu, 10 Feb 2022 14:30:38 -0500
Received: from relay1-d.mail.gandi.net ([217.70.183.193]:49269)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mail@HIDDEN>) id 1nIF9I-000170-Sb
 for 53818 <at> debbugs.gnu.org; Thu, 10 Feb 2022 14:30:37 -0500
Received: (Authenticated sender: admin@HIDDEN)
 by mail.gandi.net (Postfix) with ESMTPSA id C63FB240006;
 Thu, 10 Feb 2022 19:30:29 +0000 (UTC)
From: Nicolas Goaziou <mail@HIDDEN>
To: Xinglu Chen <public@HIDDEN>
Subject: Re: [bug#53818] [PATCH 0/3] Add Repology updater
References: <cover.1644147246.git.public@HIDDEN>
 <87pmnx7ynw.fsf@HIDDEN> <87y22kxkv3.fsf@HIDDEN>
 <87k0e4w1to.fsf@HIDDEN> <87bkzewpqy.fsf@HIDDEN>
Date: Thu, 10 Feb 2022 20:30:28 +0100
In-Reply-To: <87bkzewpqy.fsf@HIDDEN> (Xinglu Chen's message of "Thu, 10
 Feb 2022 19:17:09 +0100")
Message-ID: <87bkzev7sb.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.9 (/)
X-Debbugs-Envelope-To: 53818
Cc: 53818 <at> debbugs.gnu.org, Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.1 (/)

Hello,

Xinglu Chen <public@HIDDEN> writes:

> Yeah, I have noticed that it sometimes thinks that a version like
> =E2=80=9C20080323=E2=80=9D is newer than something like =E2=80=9C0.1.2-0.=
a1b2b3d=E2=80=9D, even though
> it might not necessarily be true.  This seems to be the case for a lot
> of Common Lisp packages which usually don=E2=80=99t have any proper relea=
ses.

[...]

> In my testing, the =E2=80=9Cnewest=E2=80=9D status does a pretty good job=
 (besides the
> problem I mentioned above)
>
> Some other =E2=80=9Cbad=E2=80=9D updates I found[*] are listed below (exc=
luding Common Lisp
> packages).
>
> --8<---------------cut here---------------start------------->8---
> guile-ac-d-bus would be upgraded from 1.0.0-beta.0 to 1.0.0-beta0
> sic would be upgraded from 1.2 to 1.2+20210506_058547e
> tla2tools would be upgraded from 1.7.1-0.6932e19 to 20140313
> quickjs would be upgraded from 2021-03-27 to 2021.03.27
> stow would be upgraded from 2.3.1 to 2.3.1+5.32
> cube would be upgraded from 4.3.5 to 2005.08.29
> python-ratelimiter would be upgraded from 1.2.0 to 1.2.0.post0
> gr-osmosdr would be upgraded from 0.2.3-0.a100eb0 to 0.2.3.20210128
> countdown would be upgraded from 1.0.0 to 20150606
> http-parser would be upgraded from 2.9.4-1.ec8b5ee to 2.9.4.20201223
> xlsx2csv would be upgraded from 0.7.4 to 20200427211949
> keynav would be upgraded from 0.20110708.0 to 20150730+4ae486d
> --8<---------------cut here---------------end--------------->8---
>
> It seems like most of these could be solved by checking if the version
> scheme changed from semver to calver.  I think that=E2=80=99s a pretty go=
od
> result considering how many packages we have.

I think this would not cut it.

As I wrote, almost any package using `git-version' is going to create
a version mismatch. This is because we consider

  (git-version "X.Y" revision commit)

to be greater than "X.Y" whereas Repology either ignore the version, or
consider it to be a pre-release before "X.Y". See, e.g., "emacs:circe"
project, or "joycond". This, I think, the most prominent category of
comparison failures.

Also, there are versions which are plain wrong, e.g., "emacs:csv-mode",
and disqualify correct and up-to-date version. There are also version
disagreement in, e.g., "colobot", or upstream disagreement, e.g.,
"emacs:scala-mode".

See also "emacs:geiser-racket", "python:folium" or "higan" for other
projects with versioning issues.

Regards,
--=20
Nicolas Goaziou




Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 10 Feb 2022 18:17:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Feb 10 13:17:19 2022
Received: from localhost ([127.0.0.1]:57101 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nIE0N-00057o-7K
	for submit <at> debbugs.gnu.org; Thu, 10 Feb 2022 13:17:19 -0500
Received: from h178-251-242-94.cust.a3fiber.se ([178.251.242.94]:50962
 helo=mail.yoctocell.xyz) by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <public@HIDDEN>) id 1nIE0K-00057W-V3
 for 53818 <at> debbugs.gnu.org; Thu, 10 Feb 2022 13:17:18 -0500
From: Xinglu Chen <public@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yoctocell.xyz;
 s=mail; t=1644517030;
 bh=pRUlGVDUq6R2I9sLOfNUz5iwamgL1F6tPwO/7dAQMxU=;
 h=From:To:Cc:Subject:In-Reply-To:References:Date;
 b=TKPa8MkWmLypPo+9caWEvQCfwg4thzaJULZ7lxy7usGHt8Dx8DBGdyvZkS2BuCoP2
 KKzBmy6B5hXhtmPJZhV4sJhYwBklIluLffuzCf6zlZYP6P0ksHBd9avlWzPoz02HwR
 SqV0ydXxvjiql9x+ej/GCChzY9BB0siqegaUZT+c=
To: Nicolas Goaziou <mail@HIDDEN>
Subject: Re: [bug#53818] [PATCH 0/3] Add Repology updater
In-Reply-To: <87k0e4w1to.fsf@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
 <87pmnx7ynw.fsf@HIDDEN> <87y22kxkv3.fsf@HIDDEN>
 <87k0e4w1to.fsf@HIDDEN>
Date: Thu, 10 Feb 2022 19:17:09 +0100
Message-ID: <87bkzewpqy.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Nicolas schrieb am Mittwoch der 09. Februar 2022 um 15:29
   +01: > Hello, > > Xinglu Chen <public@HIDDEN> writes: > >> The point
    of the Repology updater is to act as a fallback if none of >> the other updaters
    can update a package, e.g., ‘maven-dependency- [...] 
 
 Content analysis details:   (2.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps
X-Debbugs-Envelope-To: 53818
Cc: 53818 <at> debbugs.gnu.org, Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Nicolas schrieb am Mittwoch der 09. Februar 2022 um 15:29
   +01: > Hello, > > Xinglu Chen <public@HIDDEN> writes: > >> The point
    of the Repology updater is to act as a fallback if none of >> the other updaters
    can update a package, e.g., ‘maven-dependency- [...] 
 
 Content analysis details:   (2.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  1.0 BULK_RE_SUSP_NTLD      Precedence bulk and RE: from a suspicious TLD
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

Nicolas schrieb am Mittwoch der 09. Februar 2022 um 15:29 +01:

> Hello,
>
> Xinglu Chen <public@HIDDEN> writes:
>
>> The point of the Repology updater is to act as a fallback if none of
>> the other updaters can update a package, e.g., =E2=80=98maven-dependency=
-tree=E2=80=99.
>> I already mentioned that language-specific updaters usually provide more
>> accurate and detailed information, so they should be used when possible;
>> we aren=E2=80=99t losing anything here.
>
> One issue is that such an updater will introduce frequent false
> positives. It is common for Repology to get the latest release wrong,
> because some distribution is doing fancy versioning, or because
> different distributions disagree about what is upstream.

Yeah, I have noticed that it sometimes thinks that a version like
=E2=80=9C20080323=E2=80=9D is newer than something like =E2=80=9C0.1.2-0.a1=
b2b3d=E2=80=9D, even though
it might not necessarily be true.  This seems to be the case for a lot
of Common Lisp packages which usually don=E2=80=99t have any proper release=
s.

> I don't think we can rely on Repology's "newest" status. The updater may
> need to provide its own version comparison tool, because Repology's tool
> and Guix versioning do not play nice, in particular when using
> `git-version'.

In my testing, the =E2=80=9Cnewest=E2=80=9D status does a pretty good job (=
besides the
problem I mentioned above)

Some other =E2=80=9Cbad=E2=80=9D updates I found[*] are listed below (exclu=
ding Common Lisp
packages).

=2D-8<---------------cut here---------------start------------->8---
guile-ac-d-bus would be upgraded from 1.0.0-beta.0 to 1.0.0-beta0
sic would be upgraded from 1.2 to 1.2+20210506_058547e
tla2tools would be upgraded from 1.7.1-0.6932e19 to 20140313
quickjs would be upgraded from 2021-03-27 to 2021.03.27
stow would be upgraded from 2.3.1 to 2.3.1+5.32
cube would be upgraded from 4.3.5 to 2005.08.29
python-ratelimiter would be upgraded from 1.2.0 to 1.2.0.post0
gr-osmosdr would be upgraded from 0.2.3-0.a100eb0 to 0.2.3.20210128
countdown would be upgraded from 1.0.0 to 20150606
http-parser would be upgraded from 2.9.4-1.ec8b5ee to 2.9.4.20201223
xlsx2csv would be upgraded from 0.7.4 to 20200427211949
keynav would be upgraded from 0.20110708.0 to 20150730+4ae486d
=2D-8<---------------cut here---------------end--------------->8---

It seems like most of these could be solved by checking if the version
scheme changed from semver to calver.  I think that=E2=80=99s a pretty good
result considering how many packages we have.

[*] Until I ran into <https://issues.guix.gnu.org/53923>

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQJJBAEBCAAzFiEEAVhh4yyK5+SEykIzrPUJmaL7XHkFAmIFVqUVHHB1YmxpY0B5
b2N0b2NlbGwueHl6AAoJEKz1CZmi+1x5keoQALFZ7lM02DNnOm/wWSH1hTDfkmhw
5oSl96b7q4Sk2LlCPy3BX9NxqUYRLJgHR95m7UQU+1nJeFL8GLvguCc2FJJ/06i3
22wAnZglqrdrnpkf2THx3RoDVCZFTgreJFJczpI08DftvdPbDk6WVuMP/vGxiva+
Gmm2Nhf7ldlyTIXJIHmBRzvBNjKc9qFo0qD4HkodTACFHsQ93Bsm1SjXGcxcggyq
6HXcRzXLXQeu8XwLE1fyIZHkoicO2TZddVZxXYQlggkZTZvxhN1U4gOlYRUrzPWz
Ho+4Be0Cy4GBMsM1JCVbietZa/gW62CpTrGTwCEcH35I1TnYbk4MBOXwY1gPdz7v
R9vdPlEotayxevcQNEnI3KUYi0O79fXXbAJX0Mjy0Vk20TdMWfIAlEIrBJXOKLMx
qsrYOUDcpt2jgrKLvyxj2D7OmPuMXnnd/uk4TcXIdMEh5f2+a7Ae4PvBE0sQnaKw
zsnWJ0AucUSi7/WzEOZn2SKj/IGGkLwkHl2iXlGK9onRZjRcBcjE7Oz4sVVIzdVS
gNLWwnV2gEHqTKpURldx0W9hS9cMHwVaomfUcwekNkxrHDEWHfLiu+qrYfBf+UWg
9ef8pTMvKwdEnnNMmggjoM5lBtMIkCLHWe9VjXrBkOcfa0bRME3YoxsiJJehJWB/
lH5IjK61Ndbo8r6g
=oOl3
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 9 Feb 2022 14:29:44 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Feb 09 09:29:44 2022
Received: from localhost ([127.0.0.1]:50299 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nHnya-0000RV-Dd
	for submit <at> debbugs.gnu.org; Wed, 09 Feb 2022 09:29:44 -0500
Received: from relay7-d.mail.gandi.net ([217.70.183.200]:53181)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mail@HIDDEN>) id 1nHnyN-0000R3-Io
 for 53818 <at> debbugs.gnu.org; Wed, 09 Feb 2022 09:29:43 -0500
Received: (Authenticated sender: admin@HIDDEN)
 by mail.gandi.net (Postfix) with ESMTPSA id CE8CF20011;
 Wed,  9 Feb 2022 14:29:24 +0000 (UTC)
From: Nicolas Goaziou <mail@HIDDEN>
To: Xinglu Chen <public@HIDDEN>
Subject: Re: [bug#53818] [PATCH 0/3] Add Repology updater
References: <cover.1644147246.git.public@HIDDEN>
 <87pmnx7ynw.fsf@HIDDEN> <87y22kxkv3.fsf@HIDDEN>
Date: Wed, 09 Feb 2022 15:29:23 +0100
In-Reply-To: <87y22kxkv3.fsf@HIDDEN> (Xinglu Chen's message of "Wed, 09
 Feb 2022 13:52:48 +0100")
Message-ID: <87k0e4w1to.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 1.6 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Hello, Xinglu Chen <public@HIDDEN> writes: > The point
    of the Repology updater is to act as a fallback if none of > the other updaters
    can update a package, e.g., ‘maven-dependency-tree’. > I already mentioned
    that language-specific update [...] 
 
 Content analysis details:   (1.6 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  0.0 T_SPF_HELO_TEMPERROR   SPF: test of HELO record failed (temperror)
 -0.0 SPF_PASS               SPF: sender matches SPF record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
X-Debbugs-Envelope-To: 53818
Cc: 53818 <at> debbugs.gnu.org, Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.1 (/)

Hello,

Xinglu Chen <public@HIDDEN> writes:

> The point of the Repology updater is to act as a fallback if none of
> the other updaters can update a package, e.g., =E2=80=98maven-dependency-=
tree=E2=80=99.
> I already mentioned that language-specific updaters usually provide more
> accurate and detailed information, so they should be used when possible;
> we aren=E2=80=99t losing anything here.

One issue is that such an updater will introduce frequent false
positives. It is common for Repology to get the latest release wrong,
because some distribution is doing fancy versioning, or because
different distributions disagree about what is upstream.

I don't think we can rely on Repology's "newest" status. The updater may
need to provide its own version comparison tool, because Repology's tool
and Guix versioning do not play nice, in particular when using
`git-version'.

Regards,
--=20
Nicolas Goaziou




Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 9 Feb 2022 13:25:40 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Feb 09 08:25:40 2022
Received: from localhost ([127.0.0.1]:50193 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nHmya-00078K-9z
	for submit <at> debbugs.gnu.org; Wed, 09 Feb 2022 08:25:40 -0500
Received: from h178-251-242-94.cust.a3fiber.se ([178.251.242.94]:44906
 helo=mail.yoctocell.xyz) by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <public@HIDDEN>) id 1nHmyY-00077t-Km
 for 53818 <at> debbugs.gnu.org; Wed, 09 Feb 2022 08:25:38 -0500
From: Xinglu Chen <public@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yoctocell.xyz;
 s=mail; t=1644413133;
 bh=jfMlwFd48Ue03So3eKlueTE4uUT6FJ2S6vUX3eqQoKo=;
 h=From:To:Subject:In-Reply-To:References:Date;
 b=SbKI70X5N76v1awVC9uFFbmMzSsyWXZzJIyLsKsuPeLoZ1uQoyOvwzdJ6fmCGUhoD
 OB/nacJB2CVfMneJDaKswg1kfvEuboIVZ87YvZ8Cojsk3IUb9porkKJdWQtkNEBtfR
 0fh6IahWf9LeOQ7LlhY6uCcf5zjAzWNQbBuYEfbg=
To: 53818 <at> debbugs.gnu.org
Subject: [PATCH v3 7/7] gnu: xorg-server-xwayland: Prepare for
 cross-compilation.
In-Reply-To: <cover.1644412701.git.public@HIDDEN>
References: <cover.1644224421.git.public@HIDDEN>
X-Debbugs-Cc: Maxime Devos <maximedevos@HIDDEN>
Message-Id: <005f249032a707f538768f1b6059706c45e50d24.1644412701.git.public@HIDDEN>
Date: Wed, 09 Feb 2022 14:25:32 +0100
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  * gnu/packages/xorg.scm (xorg-server-xwayland)[arguments]<#:phases>:
    Use ‘search-input-file’ instead of ‘which’. --- gnu/packages/xorg.scm
    | 5 +++-- 1 file changed, 3 insertions(+), 2 deletion [...] 
 
 Content analysis details:   (2.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  * gnu/packages/xorg.scm (xorg-server-xwayland)[arguments]<#:phases>:
    Use ‘search-input-file’ instead of ‘which’. --- gnu/packages/xorg.scm
    | 5 +++-- 1 file changed, 3 insertions(+), 2 deletion [...] 
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps

* gnu/packages/xorg.scm (xorg-server-xwayland)[arguments]<#:phases>: Use
  =E2=80=98search-input-file=E2=80=99 instead of =E2=80=98which=E2=80=99.
---
 gnu/packages/xorg.scm | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

diff --git a/gnu/packages/xorg.scm b/gnu/packages/xorg.scm
index 8be7017da7..dea7268a2e 100644
--- a/gnu/packages/xorg.scm
+++ b/gnu/packages/xorg.scm
@@ -5518,9 +5518,10 @@ (define-public xorg-server-xwayland
              "--localstatedir=3D/var")
        #:phases (modify-phases %standard-phases
                   (add-after 'unpack 'patch-/bin/sh
-                    (lambda _
+                    (lambda* (#:key inputs #:allow-other-keys)
                       (substitute* (find-files "." "\\.c$")
-                        (("/bin/sh") (which "sh"))))))))
+                        (("/bin/sh")
+                         (search-input-file inputs "bin/sh"))))))))
     (properties
      '((repology-name . "xwayland")))
     (synopsis "Xorg server with Wayland backend")
--=20
2.34.1







Information forwarded to maximedevos@HIDDEN, guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 9 Feb 2022 13:25:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Feb 09 08:25:35 2022
Received: from localhost ([127.0.0.1]:50190 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nHmyU-000781-Ro
	for submit <at> debbugs.gnu.org; Wed, 09 Feb 2022 08:25:35 -0500
Received: from h178-251-242-94.cust.a3fiber.se ([178.251.242.94]:44898
 helo=mail.yoctocell.xyz) by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <public@HIDDEN>) id 1nHmyT-00077n-5k
 for 53818 <at> debbugs.gnu.org; Wed, 09 Feb 2022 08:25:33 -0500
From: Xinglu Chen <public@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yoctocell.xyz;
 s=mail; t=1644413127;
 bh=f7r1HprMCgd+yT9MgYeTpNbVfndFbU/YpwUOiR9Yx2Y=;
 h=From:To:Subject:In-Reply-To:References:Date;
 b=DeyUP0ai47XHKzMvgtnR5ofKt/AmLQAyYf8rfdXWRCl+MBzs14DYJ1C9mDu0+fCDv
 46pUYT/X/36C7puAArcbtL4Qodu7NANn9bIgBuu4CIpH0T3/B2f0688X21IKjS3rxI
 BjJPQi2bWvSvvQsvsfujvJ+VMIVucCSNeD91tH7g=
To: 53818 <at> debbugs.gnu.org
Subject: [PATCH v3 6/7] gnu: xorg-server-xwayland: Set 'repology-name'
 property.
In-Reply-To: <cover.1644412701.git.public@HIDDEN>
References: <cover.1644224421.git.public@HIDDEN>
X-Debbugs-Cc: Maxime Devos <maximedevos@HIDDEN>
Message-Id: <683fa3b5867f02268b9e6d09c2f93c749d0f75fb.1644412701.git.public@HIDDEN>
Date: Wed, 09 Feb 2022 14:25:26 +0100
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  * gnu/packages/xorg.scm (xorg-server-xwayland):[properties]:
    Set 'repology-name'. --- gnu/packages/xorg.scm | 3 +++ 1 file changed, 3
   insertions(+) diff --git a/gnu/packages/xorg.scm b/gnu/packages/xorg.scm index
    14e35d19ae..8be7017da7 100644 --- a/gnu/packages/xorg.scm +++ b/gnu/packages/xorg.scm
    @@ -33,6 +33,7 @@ ;;; Copyright © 2021 Maxime De [...] 
 
 Content analysis details:   (2.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  * gnu/packages/xorg.scm (xorg-server-xwayland):[properties]:
    Set 'repology-name'. --- gnu/packages/xorg.scm | 3 +++ 1 file changed, 3
   insertions(+) diff --git a/gnu/packages/xorg.scm b/gnu/packages/xorg.scm index
    14e35d19ae..8be7017da7 100644 --- a/gnu/packages/xorg.scm +++ b/gnu/packages/xorg.scm
    @@ -33,6 +33,7 @@ ;;; Copyright © 2021 Maxime De [...] 
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps

* gnu/packages/xorg.scm (xorg-server-xwayland):[properties]: Set
'repology-name'.
---
 gnu/packages/xorg.scm | 3 +++
 1 file changed, 3 insertions(+)

diff --git a/gnu/packages/xorg.scm b/gnu/packages/xorg.scm
index 14e35d19ae..8be7017da7 100644
--- a/gnu/packages/xorg.scm
+++ b/gnu/packages/xorg.scm
@@ -33,6 +33,7 @@
 ;;; Copyright =C2=A9 2021 Maxime Devos <maximedevos@HIDDEN>
 ;;; Copyright =C2=A9 2021 qblade <qblade@HIDDEN>
 ;;; Copyright =C2=A9 2021 Lu Hui <luhux76@HIDDEN>
+;;; Copyright =C2=A9 2022 Xinglu Chen <public@HIDDEN>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -5520,6 +5521,8 @@ (define-public xorg-server-xwayland
                     (lambda _
                       (substitute* (find-files "." "\\.c$")
                         (("/bin/sh") (which "sh"))))))))
+    (properties
+     '((repology-name . "xwayland")))
     (synopsis "Xorg server with Wayland backend")
     (description "Xwayland is an X server for running X clients under
 Wayland.")
--=20
2.34.1







Information forwarded to maximedevos@HIDDEN, guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 9 Feb 2022 13:25:26 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Feb 09 08:25:26 2022
Received: from localhost ([127.0.0.1]:50187 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nHmyI-00077Z-1F
	for submit <at> debbugs.gnu.org; Wed, 09 Feb 2022 08:25:26 -0500
Received: from h178-251-242-94.cust.a3fiber.se ([178.251.242.94]:44880
 helo=mail.yoctocell.xyz) by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <public@HIDDEN>) id 1nHmyG-00077J-5n
 for 53818 <at> debbugs.gnu.org; Wed, 09 Feb 2022 08:25:21 -0500
From: Xinglu Chen <public@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yoctocell.xyz;
 s=mail; t=1644413113;
 bh=QJPtJwE9OIg++PiCiG6RNGbOTMFbkV9On/88KoOPwYk=;
 h=From:To:Subject:In-Reply-To:References:Date;
 b=Od2NqCRJsnDuAOOVNtc6UkS14BlrtgucrnL0jQJ5tGq5AGj2O2VVNScxLZP0toQhu
 YVUXvhatGK+HdipY+Kv3tRUknMRPVEt88qkn/e0Og/iAr6UR1NIr4I+A7uD2P6B+7Y
 CmZsLyoehp/qd4b2/cEBVc0OODfeQwF5jYBZFUeA=
To: 53818 <at> debbugs.gnu.org
Subject: [PATCH v3 5/7] import: Add 'repology' updater.
In-Reply-To: <cover.1644412701.git.public@HIDDEN>
References: <cover.1644224421.git.public@HIDDEN>
X-Debbugs-Cc: Maxime Devos <maximedevos@HIDDEN>
Message-Id: <452009a171299629965ab860eac2a1fdbe8a3554.1644412701.git.public@HIDDEN>
Date: Wed, 09 Feb 2022 14:25:13 +0100
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: * guix/import/repology.scm * tests/import-repology.scm: New
 files. * Makefile.am (MODULES): Register them. * doc/guix.texi (Invoking
 guix refresh): Document it. --- Makefile.am | 3 + doc/guix.texi | 8 [...] 
 Content analysis details:   (2.5 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
 [URI: yoctocell.xyz (xyz)]
 0.4 RDNS_DYNAMIC           Delivered to internal network by host with
 dynamic-looking rDNS 0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  * guix/import/repology.scm * tests/import-repology.scm: New
    files. * Makefile.am (MODULES): Register them. * doc/guix.texi (Invoking
   guix refresh): Document it. --- Makefile.am | 3 + doc/guix.texi | 8 [...] 
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps

* guix/import/repology.scm
* tests/import-repology.scm: New files.
* Makefile.am (MODULES): Register them.
* doc/guix.texi (Invoking guix refresh): Document it.
---
 Makefile.am               |   3 +
 doc/guix.texi             |   8 ++
 guix/import/repology.scm  | 249 ++++++++++++++++++++++++++++++++++++++
 tests/import-repology.scm | 150 +++++++++++++++++++++++
 4 files changed, 410 insertions(+)
 create mode 100644 guix/import/repology.scm
 create mode 100644 tests/import-repology.scm

diff --git a/Makefile.am b/Makefile.am
index 7463606d20..6792917b59 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -16,6 +16,7 @@
 # Copyright =C2=A9 2019 Efraim Flashner <efraim@HIDDEN>
 # Copyright =C2=A9 2021 Chris Marusich <cmmarusich@HIDDEN>
 # Copyright =C2=A9 2021 Andrew Tropin <andrew@HIDDEN>
+# Copyright =C2=A9 2022 Xinglu Chen <public@HIDDEN>
 #
 # This file is part of GNU Guix.
 #
@@ -271,6 +272,7 @@ MODULES =3D					\
   guix/import/opam.scm				\
   guix/import/print.scm				\
   guix/import/pypi.scm				\
+  guix/import/repology.scm			\
   guix/import/stackage.scm			\
   guix/import/texlive.scm   			\
   guix/import/utils.scm				\
@@ -488,6 +490,7 @@ SCM_TESTS =3D					\
   tests/home-import.scm				\
   tests/import-git.scm				\
   tests/import-github.scm			\
+  tests/import-repology.scm			\
   tests/import-utils.scm			\
   tests/inferior.scm				\
   tests/lint.scm				\
diff --git a/doc/guix.texi b/doc/guix.texi
index 583ba1c61d..2d7612b09a 100644
--- a/doc/guix.texi
+++ b/doc/guix.texi
@@ -12932,6 +12932,14 @@
       (release-tag-version-delimiter . ":"))))
 @end lisp
=20
+@item repology
+an updater that scans @uref{https://repology.org, Repology}, a website
+that tracks packages on various package repositories, for updates.
+
+The name of a package in Guix is not always that same as the name on
+Repology.  In most cases, the updater will be able to guess the name
+correctly.  If it doesn=E2=80=99t, users can set the @code{repology-name}
+package property.
=20
 @end table
=20
diff --git a/guix/import/repology.scm b/guix/import/repology.scm
new file mode 100644
index 0000000000..87fbd2ee6f
--- /dev/null
+++ b/guix/import/repology.scm
@@ -0,0 +1,249 @@
+;;; GNU Guix --- Functional package management for GNU
+;;; Copyright =C2=A9 2022 Xinglu Chen <public@HIDDEN>
+;;;
+;;; This file is part of GNU Guix.
+;;;
+;;; GNU Guix is free software; you can redistribute it and/or modify it
+;;; under the terms of the GNU General Public License as published by
+;;; the Free Software Foundation; either version 3 of the License, or (at
+;;; your option) any later version.
+;;;
+;;; GNU Guix is distributed in the hope that it will be useful, but
+;;; WITHOUT ANY WARRANTY; without even the implied warranty of
+;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+;;; GNU General Public License for more details.
+;;;
+;;; You should have received a copy of the GNU General Public License
+;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
+
+(define-module (guix import repology)
+  #:use-module (guix diagnostics)
+  #:use-module (guix git-download)
+  #:use-module (guix http-client)
+  #:use-module (guix i18n)
+  #:use-module (guix import json)
+  #:use-module (guix import utils)
+  #:use-module (guix memoization)
+  #:use-module (guix packages)
+  #:use-module (guix upstream)
+  #:use-module (guix utils)
+  #:use-module (ice-9 match)
+  #:use-module (json)
+  #:use-module (srfi srfi-1)
+  #:use-module (srfi srfi-2)
+  #:use-module (srfi srfi-26)
+  #:use-module (srfi srfi-43)
+  #:export (%repology-url
+            repology-fetch-info
+            repology-latest-release
+            %repology-updater))
+
+;;; Commentary:
+;;;
+;;; This module provides an updater which scans Repology, a site that moni=
tors
+;;; several package repolsitories, for updates.  This means that if any ot=
her
+;;; package repository has a version of a package that is newer than the
+;;; version in Guix, the package should be able to be updated.  The updater
+;;; should in theory work for all packages in Guix, but the names of some
+;;; packages on Repology don't match the name in Guix.  The 'repology-name'
+;;; package property can be used to fix this.
+;;;
+;;; Guix already has many different updaters for language-specific package=
s,
+;;; and these typically provide more accurate data, e.g., input changes,
+;;; signature URLs.  The Repology updater should really be treated as a la=
st
+;;; resort for those packages that don't have any other updater to rely on.
+;;;
+;;; See <https://repology.org/api/v1> for the API.
+;;;
+;;; Code:
+
+(define %repology-url
+   "https://repology.org/api/v1/project")
+
+(define* (package-name->repology-name name #:key (attempt 1))
+  "Convert NAME, the name of a Guix package, to the name of the package on
+Repology.  It doesn't always guess the correct name on the first attempt, =
so
+on the second attempt it will try to guess another name."
+  (match attempt
+    (1 (cond
+        ((string-prefix? "ghc-" name)
+         (string-append "haskell:"
+                        (string-drop name (string-length "ghc-"))))
+        ((string-prefix? "ocaml-" name)
+         (string-append "ocaml:"
+                        (string-drop name (string-length "ocaml-"))))
+        ((string-prefix? "perl-" name)
+         (string-append "perl:"
+                        (string-drop name (string-length "perl-"))))
+        ((string-prefix? "emacs-" name)
+         (string-append "emacs:"
+                        (string-drop name (string-length "emacs-"))))
+        ((string-prefix? "go-" name)
+         (string-append "go:"
+                        (string-drop name (string-length "go-"))))
+        ((string-prefix? "rust-" name)
+         (string-append "rust:"
+                        (string-drop name (string-length "rust-"))))
+        ((string-prefix? "lua-" name)
+         (string-append "lua:"
+                        (string-drop name (string-length "lua-"))))
+        ((string-prefix? "node-" name)
+         (string-append "node:"
+                        (string-drop name (string-length "node-"))))
+        ((string-prefix? "python-" name)
+         (string-append "python:"
+                        (string-drop name (string-length "python-"))))
+        ((string-prefix? "java-" name)
+         (string-append "java:"
+                        (string-drop name (string-length "java-"))))
+        ((string-prefix? "r-" name)
+         (string-append "r:"
+                        (string-drop name (string-length "r-"))))
+        ((string-prefix? "ruby-" name)
+         (string-append "ruby:"
+                        (string-drop name (string-length "ruby-"))))
+        ((string-prefix? "xf86-" name)
+         (string-append "xdrv:"
+                        (string-drop name (string-length "xf86-"))))
+        ((string-prefix? "font-" name)
+         (string-append "fonts:"
+                        (string-drop name (string-length "font-"))))
+        ((string-prefix? "trytond-" name)
+         (string-append "tryton:"
+                        (string-drop name (string-length "trytond-"))))
+        ((string-prefix? "python-trytond-" name)
+         (string-append "tryton:"
+                        (string-drop name (string-length "python-trytond-"=
))))
+        ((string-suffix? "-minimal" name)
+         (string-drop-right name (string-length "-minimal")))=20=20=20=20=
=20=20=20=20
+        (else name)))
+    (2 (cond
+        ((string-prefix? "xf86-video" name)
+         (string-append "xdrv:"
+                        (string-drop name (string-length "xf86-video-"))))
+        ((string-prefix? "xf86-input" name)
+         (string-append "xdrv:"
+                        (string-drop name (string-length "xf86-input-"))))
+        ((string-prefix? "minetest-" name)
+         (string-append "minetest-mod-"
+                        (string-drop name (string-length "minetest-"))))
+        ((string-prefix? "lib" name)
+         (string-drop name (string-length "lib")))
+        ((string-prefix? "vim-" name)
+         (string-append "vim:"
+                        (string-drop name (string-length "vim-"))))
+        (else name)))))=20=20
+
+
+;;; JSON mappings.
+
+(define-json-mapping <repology-package> make-repology-package
+  repology-package?
+  json->repology-package
+  (repository repology-package-repository "repo")
+  (src-name repology-package-src-name "srcname")
+  (binary-name repology-package-binary-name "binname")
+  (visible-name repology-package-visible-name "visiblename")
+  (version repology-package-version)
+  (original-version repology-package-original-version "origversion")
+  (status repology-package-status)
+  (summary repology-package-summary)
+  (categories repology-package-categories)
+  (licenses repology-package-licenses)
+  (maintainers repology-package-maintainers))
+
+
+;;; Updater.
+
+(define repology-fetch-info
+  (memoize
+   (lambda (package)
+     "Fetch information about PACKAGE using the Repology API."
+     (define (name->info name)
+       (let ((url (string-append %repology-url "/" name)))
+         (and=3D> (json-fetch url #:http-fetch http-fetch/cached)
+                (lambda (url)
+                  (vector-map (lambda (a b)
+                                (json->repology-package b))
+                              url)))))
+=20=20=20=20=20
+     (let* ((name (or (assoc-ref (package-properties package)
+                                 'repology-name)
+                      (package-name->repology-name (package-name package))=
))
+            (info (name->info name)))
+       (if (and info (not (vector-empty? info)))
+           info
+           (let ((info (name->info (package-name->repology-name
+                                    (package-name package)
+                                    #:attempt 2))))
+             (if (and info (not (vector-empty? info)))
+                 info
+                 (begin
+                   (warning (G_ "package not found on Repology: ~a\n")
+                            (package-name package))
+                   #f))))))))
+
+(define (update-version string old-version new-version)
+  "Replace OLD-VERSION in STRING with NEW-VERSION.  This assumes that STRI=
NG
+contains OLD-VERSION verbatim; if it doesn't, #f is returned."
+  (match (factorize-uri string old-version)
+    ((? string?) #f)
+    ((factorized ...)
+     (apply string-append
+            (map (lambda (component)
+                   (match component
+                     ('version new-version)
+                     ((? string?) component)))
+                 factorized)))))
+
+(define (package-source-urls package version)
+  "Return a list of URLs for PACKAGE at VERSION.  If no URL was successful=
ly constructed, return #f."
+  (and-let* ((old-version (package-version package))
+             (source (package-source package)))
+    ;; XXX: (guix upstream) only supports tarballs and Git repos for now.
+    (match (origin-uri source)
+      ((? git-reference? reference)
+       (and-let* ((old-commit (git-reference-commit reference))
+                  (new-commit (if (string=3D? old-version old-commit)
+                                      version
+                                      (update-version old-commit
+                                                      old-version
+                                                      version))))
+         (git-reference
+          (inherit reference)
+          (commit new-commit))))
+      ((? string? url)
+       (list (update-version url old-version version)))
+      ((? list? urls)
+       (map (cut update-version <> old-version version) urls))
+      (_ #f))))
+
+(define (latest-version? repology-package)
+  "Return the latest released version of REPOLOGY-PACKAGE.  If none are fo=
und,
+return #f."
+  (and (or (equal? "newest" (repology-package-status repology-package))
+           (equal? "unique" (repology-package-status repology-package)))
+       (repology-package-version repology-package)))
+
+;; XXX: We use 'pkg' because 'package' will clash with the 'package' field=
 of
+;; 'upstream-source'.
+(define (repology-latest-release pkg)
+  "Return the latest release of the PKG on Repology named NAME."
+  (and-let* ((packages (repology-fetch-info pkg))
+             (versions (filter-map latest-version?
+                                   (vector->list packages)))
+             (latest-version (and (pair? versions) (car versions))))
+    ;; TODO: set 'signature-urls'.
+    (upstream-source
+     (package (package-name pkg))
+     (version latest-version)
+     (urls (package-source-urls pkg latest-version)))))
+
+(define %repology-updater
+  (upstream-updater
+   (name 'repology)
+   (description "Updater for packages on Repology")
+   (pred (const #t))
+   (latest repology-latest-release)))
+
+;;; repology.scm ends here
diff --git a/tests/import-repology.scm b/tests/import-repology.scm
new file mode 100644
index 0000000000..4da01a4106
--- /dev/null
+++ b/tests/import-repology.scm
@@ -0,0 +1,150 @@
+;;; GNU Guix --- Functional package management for GNU
+;;; Copyright =C2=A9 2022 Xinglu Chen <public@HIDDEN>
+;;;
+;;; This file is part of GNU Guix.
+;;;
+;;; GNU Guix is free software; you can redistribute it and/or modify it
+;;; under the terms of the GNU General Public License as published by
+;;; the Free Software Foundation; either version 3 of the License, or (at
+;;; your option) any later version.
+;;;
+;;; GNU Guix is distributed in the hope that it will be useful, but
+;;; WITHOUT ANY WARRANTY; without even the implied warranty of
+;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+;;; GNU General Public License for more details.
+;;;
+;;; You should have received a copy of the GNU General Public License
+;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
+
+(define-module (test-import-repology)
+  #:use-module (guix download)
+  #:use-module (guix git-download)
+  #:use-module (guix import repology)
+  #:use-module (guix memoization)
+  #:use-module (guix packages)
+  #:use-module (guix tests)
+  #:use-module (guix upstream)
+  #:use-module (json)
+  #:use-module (srfi srfi-64))
+
+(test-begin "repology")
+
+(define package-using-git-repository
+  (dummy-package
+   "foo"
+   (version "1.0")
+   (source
+    (origin
+      (method git-fetch)
+      (uri (git-reference
+            (url "https://git.example.org/foo")
+            (commit "1.0")))
+      (sha256 #f)))))
+
+(define package-using-tarball
+  (dummy-package
+   "foo"
+   (version "1.0")
+   (source
+    (origin
+      (method git-fetch)
+      (uri (string-append "https://example.org/foo-" version ".tar.gz"))
+      (sha256 #f)))))
+
+(define package-using-tarball-multiple-urls
+  (dummy-package
+   "foo"
+   (version "1.0")
+   (source
+    (origin
+      (method git-fetch)
+      (uri (list (string-append "https://example.org/foo-"
+                                version ".tar.gz")
+                 (string-append "https://mirror.example.org/foo-"
+                                version ".tar.gz")))
+      (sha256 #f)))))
+
+(define %test-json
+"[
+  {
+    \"repo\": \"aur\",
+    \"srcname\": \"foo\",
+    \"binname\": \"foo\",
+    \"visiblename\": \"foo\",
+    \"version\": \"1.0.r25.gb86405a\",
+    \"maintainers\": [
+      \"bob@aur\"
+    ],
+    \"licenses\": [
+      \"LGPL3+\"
+    ],
+    \"summary\": \"foo bar\"
+    \"status\": \"rolling\",
+    \"origversion\": \"1.0.r25.gb86405a-1\"
+  },
+  {
+    \"repo\": \"gnuguix\",
+    \"srcname\": \"foo\",
+    \"binname\": \"foo\",
+    \"visiblename\": \"foo\",
+    \"version\": \"1.0\",
+    \"summary\": \"foo bar\",
+    \"status\": \"outdated\",
+    \"origversion\": null
+  },
+  {
+    \"repo\": \"nix_unstable\",
+    \"name\": \"foo\",
+    \"visiblename\": \"foo\",
+    \"version\": \"2.0\",
+    \"maintainers\": [
+      \"bob@HIDDEN\"
+    ],
+    \"licenses\": [
+      \"LGPL-3.0-or-later\"
+    ],
+    \"summary\": \"foo bar\",
+    \"status\": \"newest\",
+    \"origversion\": null
+  }
+]")
+
+(define (latest-release package)
+  (invalidate-memoization! repology-fetch-info)
+  (mock ((guix import json) json-fetch
+         (lambda* (url #:key http-fetch)
+           (if (string=3D? url
+                         (string-append %repology-url "/foo"))
+               (json-string->scm %test-json)
+               (error "the URL is not correct"))))
+        (repology-latest-release package)))
+
+(test-equal "package using Git repo: version"
+  "2.0"
+  (upstream-source-version
+   (latest-release package-using-git-repository)))
+
+(test-equal "package using Git repo: git-reference"
+  (git-reference
+   (url "https://git.example.org/foo")
+   (commit "2.0"))
+  (upstream-source-urls
+   (latest-release package-using-git-repository)))
+
+(test-equal "package using tarball: version"
+  "2.0"
+  (upstream-source-version
+   (latest-release package-using-tarball)))
+
+(test-equal "package using tarball: URL"
+  (list "https://example.org/foo-2.0.tar.gz")
+  (upstream-source-urls
+   (latest-release package-using-tarball)))
+
+(test-equal "package using tarball: multiple URLs"
+  (list "https://example.org/foo-2.0.tar.gz"
+        "https://mirror.example.org/foo-2.0.tar.gz")
+  (upstream-source-urls
+   (latest-release package-using-tarball-multiple-urls)))
+
+(test-end "repology")
--=20
2.34.1







Information forwarded to maximedevos@HIDDEN, guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 9 Feb 2022 13:25:10 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Feb 09 08:25:10 2022
Received: from localhost ([127.0.0.1]:50183 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nHmy5-000774-F2
	for submit <at> debbugs.gnu.org; Wed, 09 Feb 2022 08:25:09 -0500
Received: from h178-251-242-94.cust.a3fiber.se ([178.251.242.94]:44870
 helo=mail.yoctocell.xyz) by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <public@HIDDEN>) id 1nHmy3-00076S-FF
 for 53818 <at> debbugs.gnu.org; Wed, 09 Feb 2022 08:25:08 -0500
From: Xinglu Chen <public@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yoctocell.xyz;
 s=mail; t=1644413101;
 bh=5/6RV8SFyjdKwV6zG391UYkeD0BSMa6Utv9ZFGu2arw=;
 h=From:To:Subject:In-Reply-To:References:Date;
 b=sMtleTb2bjyqa0UH/yq2Ag5Vob+Xz5TVDVLN0I5VPmQi2g7gAVti4XYpzH1XNl49J
 T0uK7ThTkckG9IovAMb+NQ07KwZuOobiXyUlhOkDDGyAJUr5BYPEgR7m3G/SYKJ8yZ
 gu0OChwcXNW2YexxG3BvgLfQT9zAQvjZ3ylZ7qPc=
To: 53818 <at> debbugs.gnu.org
Subject: [PATCH v3 4/7] import: json: Make 'json-fetch' take '#:http-fetch'
 argument.
In-Reply-To: <cover.1644412701.git.public@HIDDEN>
References: <cover.1644224421.git.public@HIDDEN>
X-Debbugs-Cc: Maxime Devos <maximedevos@HIDDEN>
Message-Id: <f0eec52af67aa71aa686ec14d5a49b621e95c779.1644412701.git.public@HIDDEN>
Date: Wed, 09 Feb 2022 14:25:01 +0100
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  This will let users of the 'json-fetch' procedure use a custom
    procedure for fetching the URL, e.g., 'http-fetch/cached'. * json.scm (json-fetch):
    Add ‘#:http-fetch’ keyword argument. Suggested-by: Maxime Devos <maximedevos@HIDDEN>
    --- guix/import/json.scm | 9 ++++++--- 1 file changed, 6 insertions(+), 3
    deletions(-) 
 
 Content analysis details:   (2.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  This will let users of the 'json-fetch' procedure use a custom
    procedure for fetching the URL, e.g., 'http-fetch/cached'. * json.scm (json-fetch):
    Add ‘#:http-fetch’ keyword argument. Suggested-by: Maxime Devos <maximedevos@HIDDEN>
    --- guix/import/json.scm | 9 ++++++--- 1 file changed, 6 insertions(+), 3
    deletions(-) 
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps

This will let users of the 'json-fetch' procedure use a custom procedure for
fetching the URL, e.g., 'http-fetch/cached'.

* json.scm (json-fetch): Add =E2=80=98#:http-fetch=E2=80=99 keyword argumen=
t.

Suggested-by: Maxime Devos <maximedevos@HIDDEN>
---
 guix/import/json.scm | 9 ++++++---
 1 file changed, 6 insertions(+), 3 deletions(-)

diff --git a/guix/import/json.scm b/guix/import/json.scm
index 0c98bb25b8..de7ed60e8d 100644
--- a/guix/import/json.scm
+++ b/guix/import/json.scm
@@ -3,6 +3,7 @@
 ;;; Copyright =C2=A9 2015, 2016 Eric Bavier <bavier@HIDDEN>
 ;;; Copyright =C2=A9 2018, 2019 Ludovic Court=C3=A8s <ludo@HIDDEN>
 ;;; Copyright =C2=A9 2020 Ricardo Wurmus <rekado@HIDDEN>
+;;; Copyright =C2=A9 2022 Xinglu Chen <public@HIDDEN>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -37,11 +38,13 @@ (define-module (guix import json)
 (define* (json-fetch url
                      ;; Note: many websites returns 403 if we omit a
                      ;; 'User-Agent' header.
-                     #:key (headers `((user-agent . "GNU Guile")
-                                      (Accept . "application/json"))))
+                     #:key
+                     (headers `((user-agent . "GNU Guile")
+                                (Accept . "application/json")))
+                     (http-fetch http-fetch))
   "Return a representation of the JSON resource URL (a list or hash table)=
, or
 #f if URL returns 403 or 404.  HEADERS is a list of HTTP headers to pass in
-the query."
+the query.  HTTP-FETCH is the procedure that is used to fetch the JSON dat=
a from URL.  It should take the URL as an argument and HEADERS as a keyword=
 argument, and return an input port for the JSON data."
   (guard (c ((and (http-get-error? c)
                   (let ((error (http-get-error-code c)))
                     (or (=3D 403 error)
--=20
2.34.1







Information forwarded to maximedevos@HIDDEN, guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 9 Feb 2022 13:24:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Feb 09 08:24:43 2022
Received: from localhost ([127.0.0.1]:50174 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nHmxf-00075T-7v
	for submit <at> debbugs.gnu.org; Wed, 09 Feb 2022 08:24:43 -0500
Received: from h178-251-242-94.cust.a3fiber.se ([178.251.242.94]:44858
 helo=mail.yoctocell.xyz) by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <public@HIDDEN>) id 1nHmxd-00075E-JL
 for 53818 <at> debbugs.gnu.org; Wed, 09 Feb 2022 08:24:41 -0500
From: Xinglu Chen <public@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yoctocell.xyz;
 s=mail; t=1644413076;
 bh=H8jADRyKH0fzq5VeA6Xl0rjl0GKGDAUsZO7ia0nN2ho=;
 h=From:To:Subject:In-Reply-To:References:Date;
 b=jQePeU76TZV3KTL2/3Ju/7y6F2mCKv9yGgRdadinjXY62d4dlh6BFJME+MwE1B/vt
 zTml6ypXPuQuEVtS5I1wpNkHoEdXaHu7eNy3OHd+Z5wodHbx4TFvjZQVpDwdxbyILY
 a+wpf8c8oJbogF/xXnT8QorGeCPu/Csxr/fn+kxo=
To: 53818 <at> debbugs.gnu.org
Subject: [PATCH v3 3/7] http-client: 'http-fetch/cached' accepts a string or
 a <uri>.
In-Reply-To: <cover.1644412701.git.public@HIDDEN>
References: <cover.1644224421.git.public@HIDDEN>
X-Debbugs-Cc: Maxime Devos <maximedevos@HIDDEN>
Message-Id: <7be659f7ef029ee77df683f3f522f9f51fe40ba5.1644412701.git.public@HIDDEN>
Date: Wed, 09 Feb 2022 14:24:35 +0100
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: This is consistent with the 'http-fetch' procedure. *
 guix/http-client.scm
 (http-fetch/cached): The 'uri' argument can be a string or a <uri> record.
 --- guix/http-client.scm | 5 ++++- 1 file changed, 4 insertions(+),
 1 deletion(-)
 Content analysis details:   (2.5 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
 [URI: yoctocell.xyz (xyz)]
 0.4 RDNS_DYNAMIC           Delivered to internal network by host with
 dynamic-looking rDNS 0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  This is consistent with the 'http-fetch' procedure. * guix/http-client.scm
    (http-fetch/cached): The 'uri' argument can be a string or a <uri> record.
    --- guix/http-client.scm | 5 ++++- 1 file changed, 4 insertions(+), 1 deletion(-)
    
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps

This is consistent with the 'http-fetch' procedure.

* guix/http-client.scm (http-fetch/cached): The 'uri' argument can be a string
  or a <uri> record.
---
 guix/http-client.scm | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

diff --git a/guix/http-client.scm b/guix/http-client.scm
index 058f09852f..08efdd5e47 100644
--- a/guix/http-client.scm
+++ b/guix/http-client.scm
@@ -297,7 +297,10 @@ (define* (http-fetch/cached uri #:key (ttl (%http-cache-ttl)) text?
 TIMEOUT specifies the timeout in seconds for connection establishment.
 
 Write information about redirects to LOG-PORT."
-  (let ((file (cache-file-for-uri uri)))
+  (let* ((uri (if (string? uri)
+                  (string->uri uri)
+                  uri))
+         (file (cache-file-for-uri uri)))
     (define (update-cache cache-port)
       (define cache-time
         (and cache-port
-- 
2.34.1







Information forwarded to maximedevos@HIDDEN, guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 9 Feb 2022 13:24:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Feb 09 08:24:34 2022
Received: from localhost ([127.0.0.1]:50171 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nHmxV-000755-Uf
	for submit <at> debbugs.gnu.org; Wed, 09 Feb 2022 08:24:34 -0500
Received: from h178-251-242-94.cust.a3fiber.se ([178.251.242.94]:44848
 helo=mail.yoctocell.xyz) by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <public@HIDDEN>) id 1nHmxT-00074p-T1
 for 53818 <at> debbugs.gnu.org; Wed, 09 Feb 2022 08:24:33 -0500
From: Xinglu Chen <public@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yoctocell.xyz;
 s=mail; t=1644413066;
 bh=akL6Y2/X0FEbcEKilz3Py/WZu638Uz61mmUyiLjh3JI=;
 h=From:To:Subject:In-Reply-To:References:Date;
 b=Dt5VdwuUzo6NSlpEs+tX+W5Q+gBzb9YIk5rBf74CodrO16s/bgB6nDCuUOFwAA8KH
 lz0VBuVC0xBFBxyR8UcM4iWuch4cLNdk8k7EIhHwsmXja+Hy6+bE0i43pUVIyS/xsb
 MHYuaHDo7txOjrWiwGBwgWNoh9GJ2z9Zv66xqfxc=
To: 53818 <at> debbugs.gnu.org
Subject: [PATCH v3 2/7] http-client: Make 'http-fetch/cached' take
 '#:headers' argument.
In-Reply-To: <cover.1644412701.git.public@HIDDEN>
References: <cover.1644224421.git.public@HIDDEN>
X-Debbugs-Cc: Maxime Devos <maximedevos@HIDDEN>
Message-Id: <0ad40732008ce4a9214df154d431741c90e0f128.1644412701.git.public@HIDDEN>
Date: Wed, 09 Feb 2022 14:24:25 +0100
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  * guix/http-client.scm (http-fetch/cached): Take ‘#:headers’
    keyword argument. --- guix/http-client.scm | 13 ++++++++----- 1 file changed,
    8 insertions(+), 5 deletions(-) diff --git a/guix/http-client.scm b/guix/http-client.scm
    index 10bc278023..058f09852f 100644 --- a/guix/http-client.scm +++ b/guix/http-client.scm
    @@ -3,6 +3,7 @@ ;;; Copyright © 2015 Mark H Weaver < [...] 
 
 Content analysis details:   (2.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  * guix/http-client.scm (http-fetch/cached): Take ‘#:headers’
    keyword argument. --- guix/http-client.scm | 13 ++++++++----- 1 file changed,
    8 insertions(+), 5 deletions(-) diff --git a/guix/http-client.scm b/guix/http-client.scm
    index 10bc278023..058f09852f 100644 --- a/guix/http-client.scm +++ b/guix/http-client.scm
    @@ -3,6 +3,7 @@ ;;; Copyright © 2015 Mark H Weaver < [...] 
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps

* guix/http-client.scm (http-fetch/cached): Take =E2=80=98#:headers=E2=80=
=99 keyword argument.
---
 guix/http-client.scm | 13 ++++++++-----
 1 file changed, 8 insertions(+), 5 deletions(-)

diff --git a/guix/http-client.scm b/guix/http-client.scm
index 10bc278023..058f09852f 100644
--- a/guix/http-client.scm
+++ b/guix/http-client.scm
@@ -3,6 +3,7 @@
 ;;; Copyright =C2=A9 2015 Mark H Weaver <mhw@HIDDEN>
 ;;; Copyright =C2=A9 2012, 2015 Free Software Foundation, Inc.
 ;;; Copyright =C2=A9 2017 Tobias Geerinckx-Rice <me@HIDDEN>
+;;; Copyright =C2=A9 2022 Xinglu Chen <public@HIDDEN>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -283,9 +284,11 @@ (define* (http-fetch/cached uri #:key (ttl (%http-cach=
e-ttl)) text?
                             (write-cache dump-port)
                             (cache-miss (const #t))
                             (log-port (current-error-port))
-                            (timeout 10))
+                            (timeout 10)
+                            (headers '((user-agent . "GNU Guile"))))
   "Like 'http-fetch', return an input port, but cache its contents in
-~/.cache/guix.  The cache remains valid for TTL seconds.
+~/.cache/guix.  The cache remains valid for TTL seconds.  HEADERS is an al=
ist
+of extra HTTP headers.  The cache time will automatically be added to HEAD=
ERS, so there is no need to specify it.
=20
 Call WRITE-CACHE with the HTTP input port and the cache output port to wri=
te
 the data to cache.  Call CACHE-MISS with URI just before fetching data from
@@ -300,8 +303,8 @@ (define cache-time
         (and cache-port
              (stat:mtime (stat cache-port))))
=20
-      (define headers
-        `((user-agent . "GNU Guile")
+      (define headers*
+        `(,@headers
           ,@(if cache-time
                 `((if-modified-since
                    . ,(time-utc->date (make-time time-utc 0 cache-time))))
@@ -316,7 +319,7 @@ (define headers
                      (raise c))))
         (let ((port (http-fetch uri #:text? text?
                                 #:log-port log-port
-                                #:headers headers #:timeout timeout)))
+                                #:headers headers* #:timeout timeout)))
           (cache-miss uri)
           (mkdir-p (dirname file))
           (when cache-port
--=20
2.34.1







Information forwarded to maximedevos@HIDDEN, guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 9 Feb 2022 13:24:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Feb 09 08:24:10 2022
Received: from localhost ([127.0.0.1]:50168 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nHmx8-00074P-MV
	for submit <at> debbugs.gnu.org; Wed, 09 Feb 2022 08:24:10 -0500
Received: from h178-251-242-94.cust.a3fiber.se ([178.251.242.94]:44826
 helo=mail.yoctocell.xyz) by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <public@HIDDEN>) id 1nHmx7-000749-Oe
 for 53818 <at> debbugs.gnu.org; Wed, 09 Feb 2022 08:24:10 -0500
From: Xinglu Chen <public@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yoctocell.xyz;
 s=mail; t=1644413044;
 bh=uePA9eU3rVfA9D2Eoe6XklIGhmYCp8Bpq3h/n9/hOOk=;
 h=From:To:Subject:In-Reply-To:References:Date;
 b=piFvX2WkUE1M1DgHLzOs8GXc/OEfIFmX9GG+w2aXe2yxqy+styolguiqbm2M2ZoS7
 aEvWJeobXGepvFnKylduL7f+/LD4viEXKx48RlhGaKYBmaBf9jFEdrk7Th2NuBM/5+
 OhcRzI3qAbJdlcyJZXukv63b/O19QJZMoIIkfPQE=
To: 53818 <at> debbugs.gnu.org
Subject: [PATCH v3 1/7] upstream: Sort list of updaters.
In-Reply-To: <cover.1644412701.git.public@HIDDEN>
References: <cover.1644224421.git.public@HIDDEN>
X-Debbugs-Cc: Maxime Devos <maximedevos@HIDDEN>
Message-Id: <0f119f2aaf1f3d492bdf733136c310a9f1a6d85d.1644412701.git.public@HIDDEN>
Date: Wed, 09 Feb 2022 14:24:03 +0100
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  The order determines which updater gets used first when running
    ‘guix refresh’ on a package. We want the most generic updaters to be
   last since they usually don’t provide as much or accurate inf [...] 
 
 Content analysis details:   (2.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  The order determines which updater gets used first when running
    ‘guix refresh’ on a package. We want the most generic updaters to be
   last since they usually don’t provide as much or accurate inf [...] 
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps

The order determines which updater gets used first when running =E2=80=98gu=
ix refresh=E2=80=99
on a package.  We want the most generic updaters to be last since they usua=
lly
don=E2=80=99t provide as much or accurate information as language-specific =
updaters.

* guix/upstream.scm (sort-updaters): New procedure.
(%updaters): Use it.
---
 guix/upstream.scm | 29 +++++++++++++++++++++++------
 1 file changed, 23 insertions(+), 6 deletions(-)

diff --git a/guix/upstream.scm b/guix/upstream.scm
index 6666803a92..d5faf9d3ee 100644
--- a/guix/upstream.scm
+++ b/guix/upstream.scm
@@ -250,14 +250,31 @@ (define (importer-modules)
                           %load-path)
                      #:warn warn-about-load-error)))
=20
+(define (sort-updaters updaters)
+  "Sort UPDATERS by putting the more generic ones last."
+  (define (genericity updater)
+    (cond
+     ((equal? 'repology (upstream-updater-name updater))
+      2)
+     ((string-prefix? "generic-"
+                      (symbol->string (upstream-updater-name updater)))
+      1)=20=20=20=20=20
+     (else 0)))
+
+  (define (less a b)
+    (<=3D (genericity a) (genericity b)))
+
+  (stable-sort updaters less))
+
 (define %updaters
   ;; The list of publically-known updaters.
-  (delay (fold-module-public-variables (lambda (obj result)
-                                         (if (upstream-updater? obj)
-                                             (cons obj result)
-                                             result))
-                                       '()
-                                       (importer-modules))))
+  (delay (sort-updaters
+          (fold-module-public-variables (lambda (obj result)
+                                          (if (upstream-updater? obj)
+                                              (cons obj result)
+                                              result))
+                                        '()
+                                        (importer-modules)))))
=20
 ;; Tests need to mock this variable so mark it as "non-declarative".
 (set! %updaters %updaters)
--=20
2.34.1







Information forwarded to maximedevos@HIDDEN, guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 9 Feb 2022 13:22:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Feb 09 08:22:38 2022
Received: from localhost ([127.0.0.1]:50157 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nHmve-00070t-JI
	for submit <at> debbugs.gnu.org; Wed, 09 Feb 2022 08:22:38 -0500
Received: from h178-251-242-94.cust.a3fiber.se ([178.251.242.94]:44788
 helo=mail.yoctocell.xyz) by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <public@HIDDEN>) id 1nHmvb-00070d-QN
 for 53818 <at> debbugs.gnu.org; Wed, 09 Feb 2022 08:22:36 -0500
From: Xinglu Chen <public@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yoctocell.xyz;
 s=mail; t=1644412948;
 bh=2yrC3cnltYaYC4LJFDhbSbQojHlJrdoDxfos1KOYDr8=;
 h=From:To:Subject:In-Reply-To:References:Date;
 b=GZScCNtmGgJL3uejcZIQzAvPqIoHrA1rtOLPlOj5Ptlxp19cDR2FD85wflID0hSFW
 I9poQHdvt/eu1TLPhU7UVQ1UXKM6kUlthTCS5v+1fmdgFr1jQAFEA9JI71tSUDS3B2
 ZDDyGb4iZNY9jvYddM8YxVJ0vXYwV3rWz9N7F0tc=
To: 53818 <at> debbugs.gnu.org
Subject: [PATCH v3 0/7] Add Repology updater
In-Reply-To: <cover.1644224421.git.public@HIDDEN>
References: <cover.1644224421.git.public@HIDDEN>
X-Debbugs-Cc: Maxime Devos <maximedevos@HIDDEN>
Message-Id: <cover.1644412701.git.public@HIDDEN>
Date: Wed, 09 Feb 2022 14:22:27 +0100
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Changes since v2: * Change ‘#:cached?’ argument to ‘#:http-fetch’.
    * Invalidate cache in tests and make sure the requested URL is the one we
    expect. 
 
 Content analysis details:   (2.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Changes since v2: * Change ‘#:cached?’ argument to ‘#:http-fetch’.
    * Invalidate cache in tests and make sure the requested URL is the one we
    expect. 
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

Changes since v2:

* Change =E2=80=98#:cached?=E2=80=99 argument to =E2=80=98#:http-fetch=E2=
=80=99.

* Invalidate cache in tests and make sure the requested URL is the one
  we expect.

* Expound a bit on the documentation in the manual.

* Some more rules for guessing the Repology name of a package.

Xinglu Chen (7):
  upstream: Sort list of updaters.
  http-client: Make 'http-fetch/cached' take '#:headers' argument.
  http-client: 'http-fetch/cached' accepts a string or a <uri>.
  import: json: Make 'json-fetch' take '#:http-fetch' argument.
  import: Add 'repology' updater.
  gnu: xorg-server-xwayland: Set 'repology-name' property.
  gnu: xorg-server-xwayland: Prepare for cross-compilation.

 Makefile.am               |   3 +
 doc/guix.texi             |   8 ++
 gnu/packages/xorg.scm     |   8 +-
 guix/http-client.scm      |  18 ++-
 guix/import/json.scm      |   9 +-
 guix/import/repology.scm  | 249 ++++++++++++++++++++++++++++++++++++++
 guix/upstream.scm         |  29 ++++-
 tests/import-repology.scm | 150 +++++++++++++++++++++++
 8 files changed, 457 insertions(+), 17 deletions(-)
 create mode 100644 guix/import/repology.scm
 create mode 100644 tests/import-repology.scm


base-commit: ad9cd004c81a01e33a605221a102f4d20abe442d
=2D-=20
2.34.1




--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQJJBAEBCAAzFiEEAVhh4yyK5+SEykIzrPUJmaL7XHkFAmIDwBMVHHB1YmxpY0B5
b2N0b2NlbGwueHl6AAoJEKz1CZmi+1x5ILkQAKI8fX1+49Gc4kh4Z8evUNFoLmmu
VdbRLD7nXgKyqFN1YZf4ybL4C/EI15lBQOMhgiYvPUtTle1px2QvL7WxHk4/Q+Sw
m0O2A4pv5E9gG38Wg3yu1gpM3g5HGOWa4Q8hAlFo/CZJlJvRRebJghm7QVETq9LM
BjQxuIgxCCr7+t5psF/Vol0WK0tVemxC7PotXjMNWKzWpAcjiDPs6sFhcnX6ezDm
0UN3z8lreQ3isHUwg8+1LcfMZs9iew7/YojJytYepDUEMCVNyC90XP9SqagpIfDv
KA3wDzIep22Xy3KKyEmBVsVbhcIkdCk8ctmPGMqY5VLq3wWNh9VeycTgzZr7ZVW7
DFlGE2gL3f+U4AfQ9AWtV3Xb9vh7xTH9cikrPOxwGYfjcc9T4jyZ8brgZVP6cXe0
+pxph2MkANaqiWEwFW0FRT3x56dAwg4WA04w3AJueuZJVGRL6Jsofi5378yUTmYy
OhDiq5jK5dMlqq+1ianKFTaBKpEFKOCvtONSJ/hgAirNEMrCtUFJnKv72FECOVqC
+Bk5VoB2S3WLANpoAP4LoAqAFGxNjLGqiOlSWlkDInflqN0uklEUYaWypmNuu8xi
8F06QOiK5XiI8Uuo9IReDtFg3IJ+Gtde+jI44NlDRBkSkoswM/D3JET75nnO2ocL
KlbnNA8nXwG2ZE62
=PsR7
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to maximedevos@HIDDEN, guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 9 Feb 2022 12:54:37 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Feb 09 07:54:37 2022
Received: from localhost ([127.0.0.1]:50122 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nHmUX-0006HN-73
	for submit <at> debbugs.gnu.org; Wed, 09 Feb 2022 07:54:37 -0500
Received: from h178-251-242-94.cust.a3fiber.se ([178.251.242.94]:44138
 helo=mail.yoctocell.xyz) by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <public@HIDDEN>) id 1nHmUU-0006HA-Ng
 for 53818 <at> debbugs.gnu.org; Wed, 09 Feb 2022 07:54:35 -0500
From: Xinglu Chen <public@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yoctocell.xyz;
 s=mail; t=1644411269;
 bh=m2Qb8P1GKGocGTpxmFcX6Vw38Hpj15M05nflGZ6UruI=;
 h=From:To:Subject:In-Reply-To:References:Date;
 b=riTGRBUP4E6WJqterhFM8mxCP0mZPQsOkM6t7/YT7m9nludZ/ieh6d20kB2RIGYWw
 riGPiZW6IvRVMMr8D3x4sctNiZgyQNeO4UTN4l9068M9x9TeM7lYBlMs3bJAYet/bV
 K3cS+cwXymcPvx2OuUaS85tupswnptSZt4dwW7Gc=
To: Maxime Devos <maximedevos@HIDDEN>, 53818 <at> debbugs.gnu.org
Subject: Re: [bug#53818] [PATCH v2 5/7] import: Add 'repology' updater.
In-Reply-To: <3841c2c4ab6dd421237b6b29e9fb746be477380e.camel@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
 <98726379214702d0745f56d9f946e792e803d326.1644224421.git.public@HIDDEN>
 <76a550f4fc82de9491b99786e8086d9d9d8c4c72.camel@HIDDEN>
 <87a6f1zgm1.fsf@HIDDEN>
 <3841c2c4ab6dd421237b6b29e9fb746be477380e.camel@HIDDEN>
Date: Wed, 09 Feb 2022 13:54:27 +0100
Message-ID: <87wni4xksc.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Maxime schrieb am Dienstag der 08. Februar 2022 um 13:49 +01:
    > Xinglu Chen schreef op di 08-02-2022 om 13:29 [+0100]: >> > Xinglu Chen
    schreef op ma 07-02-2022 om 10:07 [+0100]: >> > > +(define (latest-release
    package) >> > > +  (mock ((guix import json) json- [...] 
 
 Content analysis details:   (2.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Maxime schrieb am Dienstag der 08. Februar 2022 um 13:49 +01:
    > Xinglu Chen schreef op di 08-02-2022 om 13:29 [+0100]: >> > Xinglu Chen
    schreef op ma 07-02-2022 om 10:07 [+0100]: >> > > +(define (latest-release
    package) >> > > +  (mock ((guix import json) json- [...] 
 
 Content analysis details:   (2.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  1.0 BULK_RE_SUSP_NTLD      Precedence bulk and RE: from a suspicious TLD
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

Maxime schrieb am Dienstag der 08. Februar 2022 um 13:49 +01:

> Xinglu Chen schreef op di 08-02-2022 om 13:29 [+0100]:
>> > Xinglu Chen schreef op ma 07-02-2022 om 10:07 [+0100]:
>> > > +(define (latest-release package)
>> > > +=C2=A0 (mock ((guix import json) json-fetch
>> > > +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (lambda* (url #:ke=
y cached?)
>> > > +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (json-=
string->scm %test-json)))
>> > > +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (repology-latest-release=
 package)))
>> >=20
>> > It would be nice to verify the URL.
>>=20
>> What do you mean with =E2=80=9Cverify=E2=80=9D
>
> Something along the lines of:
>
> (lambda* (url #:key cached?)
>   (if (equal? url
> "http://[hostname]/release/information/of/PACKAGE.json")
>     (json-string->scm ...)
>     (error "the refresher contacted the wrong URL!")))

Ah, OK, thanks for clarifying!

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQJJBAEBCAAzFiEEAVhh4yyK5+SEykIzrPUJmaL7XHkFAmIDuYQVHHB1YmxpY0B5
b2N0b2NlbGwueHl6AAoJEKz1CZmi+1x5bHcP/1LMGxz5R88mpiGvHMXEnpVPadry
eeKrmZfmiLHjHXAlKGFIVwjVvp0F4MaU8oFuRzk+h++9MZoggp2LaISQdAe4AV8f
9ecU9UC1AGaclOmXRQTgi2ugInfLCIA2T3qh9p2Ed4FPw8TGMl6Dq8HLpnxMGIeO
ARAoiu1JH0NDvMKz0qulg2JtDKytAtqIOjLP5sU9682tXfn7HbFF6MnLI5jzqrCC
zCBWZ9rgUMuzLoHofbdG+UxFveGy3IOg7Ps17iTH/1MX8eeDaJvJLC9vkSbzW+0P
PaQPa7resQ9Ye/vjo2pDXTk0d4W2ig1j0lraZW5flMO1j9qfLgXjqgnrGLyaWRI4
Qg2MsS5kRYrPefSCgLHj89qzPGPASfunJEgZvCM9fsrRs+hmNwLA5ZAS9CHWR2Q4
0YYsXhW0SfmUmSVtCKblVlG8/EUz6fTe9C55cqN2QGJoZe+2akjemeXvkd+5w/uG
T1unWuL3XIKj/ub4U0FwW+JjgL87BCIlewBGBAI2EqiQcnQ6oLsrP/ZPUzAHrmX+
MLNQRZyJSzottnFYNkk/DtUEpikbvdq0DJcLreoMJyloXE9yFoo3EaCJ6tWSJWXZ
PylttRjVm0rpBD0hxTYKfj17ggRwau2RVOjkRB8QiCFUJWdSvpY0UMJKgu+nzxYx
B4blmmBo0ST4Kyyj
=ksoR
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 9 Feb 2022 12:53:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Feb 09 07:53:08 2022
Received: from localhost ([127.0.0.1]:50118 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nHmT5-0006F4-So
	for submit <at> debbugs.gnu.org; Wed, 09 Feb 2022 07:53:08 -0500
Received: from h178-251-242-94.cust.a3fiber.se ([178.251.242.94]:44090
 helo=mail.yoctocell.xyz) by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <public@HIDDEN>) id 1nHmT3-0006EX-N1
 for 53818 <at> debbugs.gnu.org; Wed, 09 Feb 2022 07:53:06 -0500
From: Xinglu Chen <public@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yoctocell.xyz;
 s=mail; t=1644411179;
 bh=qFXMuY68o6uZe1XsLpW68HWfvmcM5bLd5UqZbhInWWs=;
 h=From:To:Cc:Subject:In-Reply-To:References:Date;
 b=BtPHenRf4E6EtMkrUDHgHR+lOtcWE34bnJhbG/qZgdCOBt/nl/tLV9IlqI3q2COzP
 dlhiujEyZydXd71GtfmzPYVmGkA88wtToskuEj163bM8+kP5wpvtKkz0Wz5yhf2l/5
 8G4U0ExP8aSdlCgE2VagfRvq2Dp+bry/fDGTZaCk=
To: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>
Subject: Re: [bug#53818] [PATCH 0/3] Add Repology updater
In-Reply-To: <87pmnx7ynw.fsf@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
 <87pmnx7ynw.fsf@HIDDEN>
Date: Wed, 09 Feb 2022 13:52:48 +0100
Message-ID: <87y22kxkv3.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  Hi, Ludovic schrieb am Dienstag der 08. Februar 2022 um 23:59
 +01: > Hi! > > Xinglu Chen <public@HIDDEN> skribis: > >> This patchset
 adds a new updater,
 which scans Repology[1] for updates. >> It should technically
 support all packages in Guix! :-) > > I would [...] 
 Content analysis details:   (2.5 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
 [URI: yoctocell.xyz (xyz)]
 0.4 RDNS_DYNAMIC           Delivered to internal network by host with
 dynamic-looking rDNS 0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps
X-Debbugs-Envelope-To: 53818
Cc: 53818 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Hi, Ludovic schrieb am Dienstag der 08. Februar 2022 um 23:59
    +01: > Hi! > > Xinglu Chen <public@HIDDEN> skribis: > >> This patchset
    adds a new updater, which scans Repology[1] for updates. >> It should technically
    support all packages in Guix! :-) > > I would [...] 
 
 Content analysis details:   (2.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  1.0 BULK_RE_SUSP_NTLD      Precedence bulk and RE: from a suspicious TLD
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

Hi,

Ludovic schrieb am Dienstag der 08. Februar 2022 um 23:59 +01:

> Hi!
>
> Xinglu Chen <public@HIDDEN> skribis:
>
>> This patchset adds a new updater, which scans Repology[1] for updates.
>> It should technically support all packages in Guix!  :-)
>
> I wouldn=E2=80=99t want to spoil the party, but I=E2=80=99m mildly enthus=
iastic.
>
> Repology implements the same functionality as our updaters, so
> repology.org is effectively =E2=80=9Cservice as a software substitute=E2=
=80=9D
> (SaaSS).

Right, but it tracks a lot more repositories than what our updaters do,
so why not take advantage of that.

> My preference would be to keep our existing updaters rather than
> effectively ditch them and delegate the work to Repology.  It=E2=80=99s t=
empting
> to think we can have both, but I=E2=80=99m not sure this would last long.

The point of the Repology updater is to act as a fallback if none of
the other updaters can update a package, e.g., =E2=80=98maven-dependency-tr=
ee=E2=80=99.
I already mentioned that language-specific updaters usually provide more
accurate and detailed information, so they should be used when possible;
we aren=E2=80=99t losing anything here.

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQJJBAEBCAAzFiEEAVhh4yyK5+SEykIzrPUJmaL7XHkFAmIDuSAVHHB1YmxpY0B5
b2N0b2NlbGwueHl6AAoJEKz1CZmi+1x5SOAP/0aPD1Uk/NPw0Elv1btTEH6obC9R
mxd7fHgZbmOVCcfnD1AXU5WxfdfsgFaDy9tihYPm39YAr21T+3Wpu6tlmRA5hv5Y
CoTGqKYuAaZZO+xuYvtjyV0wlxHjooGn0QJCEa3h0PvrqmwD8XCKJADpywlkRjXu
WEmMQQs6F8cy56kAVnrySLTGw4eVz1BoyCEsIX8SVHBVIk14pw0hBCmqtf1pC5cw
BAO3flGmh1IopyMg05Np+uodI84oHobQu4PZt94IWJyQK2fSnur4QS1C9qcTXf3j
93Ma4hy3KGshhNioaw4zcLXKBngiNyr3JkUq7qyuHaDPj40mzB1gBU1KSNTNPpMb
bYDQgNzp5Zc8rY0/RbLCo84183n52Hxi9MYsGYu67gDCaE4+3NVy3YcdL6lFeCPQ
jwGpkV5nt5/FBat9flc0qGmNyPhXYktASaZQi8YGCzC4EzYnoFsaLD2zmmJtLj2M
n8AefbpQjGo1LUiRpFKpGQJz5zWWG1IuYkDNAesJ1h2AvbW/+r/ywvMnFm7ChbBy
fKoZFSW5AhKC7IqtB4A1yPnpWMDRCvtUPig4u46LTYg8fASAMMHTyYM4z9D1bigH
4HAtXMIDYKxZHCeTlj+4/eNNluNX5tFCeB3BPfq5jB+oqlVvqliU1ptlyLjuM0Od
FenBTIheprFefjiE
=bFVw
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 8 Feb 2022 22:59:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 08 17:59:25 2022
Received: from localhost ([127.0.0.1]:49019 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nHZSH-0006xq-6W
	for submit <at> debbugs.gnu.org; Tue, 08 Feb 2022 17:59:25 -0500
Received: from hera.aquilenet.fr ([185.233.100.1]:57334)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1nHZSG-0006xb-4A
 for 53818 <at> debbugs.gnu.org; Tue, 08 Feb 2022 17:59:24 -0500
Received: from localhost (localhost [127.0.0.1])
 by hera.aquilenet.fr (Postfix) with ESMTP id 71828709;
 Tue,  8 Feb 2022 23:59:17 +0100 (CET)
X-Virus-Scanned: Debian amavisd-new at aquilenet.fr
Received: from hera.aquilenet.fr ([127.0.0.1])
 by localhost (hera.aquilenet.fr [127.0.0.1]) (amavisd-new, port 10024)
 with ESMTP id 4_pfwWab_95L; Tue,  8 Feb 2022 23:59:16 +0100 (CET)
Received: from ribbon (91-160-117-201.subs.proxad.net [91.160.117.201])
 by hera.aquilenet.fr (Postfix) with ESMTPSA id 24F411CA;
 Tue,  8 Feb 2022 23:59:16 +0100 (CET)
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: Xinglu Chen <public@HIDDEN>
Subject: Re: bug#53818: [PATCH 0/3] Add Repology updater
References: <cover.1644147246.git.public@HIDDEN>
Date: Tue, 08 Feb 2022 23:59:15 +0100
In-Reply-To: <cover.1644147246.git.public@HIDDEN> (Xinglu Chen's
 message of "Sun, 06 Feb 2022 12:50:27 +0100")
Message-ID: <87pmnx7ynw.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spamd-Bar: /
Authentication-Results: hera.aquilenet.fr;
	none
X-Rspamd-Server: hera
X-Rspamd-Queue-Id: 71828709
X-Spamd-Result: default: False [-0.10 / 15.00]; ARC_NA(0.00)[];
 RCVD_VIA_SMTP_AUTH(0.00)[]; RCPT_COUNT_TWO(0.00)[2];
 FROM_HAS_DN(0.00)[]; TO_DN_SOME(0.00)[];
 TO_MATCH_ENVRCPT_ALL(0.00)[]; MIME_GOOD(-0.10)[text/plain];
 FROM_EQ_ENVFROM(0.00)[]; MIME_TRACE(0.00)[0:+];
 RCVD_COUNT_TWO(0.00)[2]; RCVD_TLS_ALL(0.00)[];
 MID_RHS_MATCH_FROM(0.00)[]
X-Spam-Score: 2.6 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: Hi! Xinglu Chen <public@HIDDEN> skribis: > This
 patchset adds a new updater,
 which scans Repology[1] for updates. > It should technically
 support all packages in Guix! :-) 
 Content analysis details:   (2.6 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
 1.0 SPF_SOFTFAIL           SPF: sender does not match SPF record (softfail)
 1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
 [URI: yoctocell.xyz (xyz)]
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
X-Debbugs-Envelope-To: 53818
Cc: 53818 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.6 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Hi! Xinglu Chen <public@HIDDEN> skribis: > This patchset
    adds a new updater, which scans Repology[1] for updates. > It should technically
    support all packages in Guix! :-) 
 
 Content analysis details:   (1.6 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
  1.0 SPF_SOFTFAIL           SPF: sender does not match SPF record (softfail)
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager

Hi!

Xinglu Chen <public@HIDDEN> skribis:

> This patchset adds a new updater, which scans Repology[1] for updates.
> It should technically support all packages in Guix!  :-)

I wouldn=E2=80=99t want to spoil the party, but I=E2=80=99m mildly enthusia=
stic.

Repology implements the same functionality as our updaters, so
repology.org is effectively =E2=80=9Cservice as a software substitute=E2=80=
=9D (SaaSS).

My preference would be to keep our existing updaters rather than
effectively ditch them and delegate the work to Repology.  It=E2=80=99s tem=
pting
to think we can have both, but I=E2=80=99m not sure this would last long.

WDYT?

Ludo=E2=80=99.




Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 8 Feb 2022 12:49:26 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 08 07:49:26 2022
Received: from localhost ([127.0.0.1]:45790 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nHPvy-0002MM-Ba
	for submit <at> debbugs.gnu.org; Tue, 08 Feb 2022 07:49:26 -0500
Received: from albert.telenet-ops.be ([195.130.137.90]:38808)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <maximedevos@HIDDEN>) id 1nHPvv-0002MD-RA
 for 53818 <at> debbugs.gnu.org; Tue, 08 Feb 2022 07:49:24 -0500
Received: from ptr-bvsjgyhxw7psv60dyze.18120a2.ip6.access.telenet.be
 ([IPv6:2a02:1811:8c09:9d00:3c5f:2eff:feb0:ba5a])
 by albert.telenet-ops.be with bizsmtp
 id scpN2600v4UW6Th06cpNa4; Tue, 08 Feb 2022 13:49:22 +0100
Message-ID: <3841c2c4ab6dd421237b6b29e9fb746be477380e.camel@HIDDEN>
Subject: Re: [bug#53818] [PATCH v2 5/7] import: Add 'repology' updater.
From: Maxime Devos <maximedevos@HIDDEN>
To: Xinglu Chen <public@HIDDEN>, 53818 <at> debbugs.gnu.org
Date: Tue, 08 Feb 2022 13:49:22 +0100
In-Reply-To: <87a6f1zgm1.fsf@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
 <98726379214702d0745f56d9f946e792e803d326.1644224421.git.public@HIDDEN>
 <76a550f4fc82de9491b99786e8086d9d9d8c4c72.camel@HIDDEN>
 <87a6f1zgm1.fsf@HIDDEN>
Content-Type: multipart/signed; micalg="pgp-sha512";
 protocol="application/pgp-signature"; boundary="=-rwtF/jLvimDhciWk3Eap"
User-Agent: Evolution 3.38.3-1 
MIME-Version: 1.0
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=telenet.be; s=r22;
 t=1644324562; bh=h/dXFKcaaDvSldAgS3VuWYNaAyECC2Vxodmd+wczWYY=;
 h=Subject:From:To:Date:In-Reply-To:References;
 b=OjTLsiEBdwLRvARAsqDbt+9yJ+wsSO2CTG377c2iMy9byBpsKsbDFHOs2Vl8ac/N3
 XMS+JulriDuHjeBS02jT6yFSLoN6Wxx3D+WCpZpnEOLTck9kW83itcdSy8BA21Oj5T
 ZNcA/MbDWn7lXodTH96iGlGHqLwL45PpaY9SNwmWBS+TmB5Fa8TVZipncFlc/cT0wd
 tRssvjRVcixaU5OANYlLdWsQ4oJRdvki+jl1/9vbezaU4oIgyO3/CK81IWw4cs4Ncz
 zXwr6vdmIROtXOnodOA3fTwbe5vxQB+0xZ3l1/HjoWOFTJU83gSL/9bCztxCCKPPHF
 Rqpp2pXYeYShg==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)


--=-rwtF/jLvimDhciWk3Eap
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable

Xinglu Chen schreef op di 08-02-2022 om 13:29 [+0100]:
> > Xinglu Chen schreef op ma 07-02-2022 om 10:07 [+0100]:
> > > +(define (latest-release package)
> > > +=C2=A0 (mock ((guix import json) json-fetch
> > > +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (lambda* (url #:key=
 cached?)
> > > +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (json-s=
tring->scm %test-json)))
> > > +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (repology-latest-release =
package)))
> >=20
> > It would be nice to verify the URL.
>=20
> What do you mean with =E2=80=9Cverify=E2=80=9D

Something along the lines of:

(lambda* (url #:key cached?)
  (if (equal? url
"http://[hostname]/release/information/of/PACKAGE.json")
    (json-string->scm ...)
    (error "the refresher contacted the wrong URL!")))

Greetings,
Maxime.

--=-rwtF/jLvimDhciWk3Eap
Content-Type: application/pgp-signature; name="signature.asc"
Content-Description: This is a digitally signed message part
Content-Transfer-Encoding: 7bit

-----BEGIN PGP SIGNATURE-----

iI0EABYKADUWIQTB8z7iDFKP233XAR9J4+4iGRcl7gUCYgJm0hccbWF4aW1lZGV2
b3NAdGVsZW5ldC5iZQAKCRBJ4+4iGRcl7qGTAQDjW09xDSUrA1D2i4VliqSyNbQy
Lk9HWvwLA4eKTnxLhwD+JV9Ev7v+6vOS/KlZG265AHxFc9jIbjKrthWx2XS/OwU=
=Zb1R
-----END PGP SIGNATURE-----

--=-rwtF/jLvimDhciWk3Eap--





Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 8 Feb 2022 12:29:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 08 07:29:39 2022
Received: from localhost ([127.0.0.1]:45740 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nHPcp-0007yh-8M
	for submit <at> debbugs.gnu.org; Tue, 08 Feb 2022 07:29:39 -0500
Received: from h178-251-242-94.cust.a3fiber.se ([178.251.242.94]:58496
 helo=mail.yoctocell.xyz) by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <public@HIDDEN>) id 1nHPcm-0007yO-GG
 for 53818 <at> debbugs.gnu.org; Tue, 08 Feb 2022 07:29:37 -0500
From: Xinglu Chen <public@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yoctocell.xyz;
 s=mail; t=1644323367;
 bh=PsFSIAyQWih8KNCJ951KnLim3y2NYrmGEBp1HGzGe+k=;
 h=From:To:Subject:In-Reply-To:References:Date;
 b=mnEr8OcEE0d1XcCezvk6DKBKZAP/NWi881BYvPNVDURnhnhQAuxGFD/FTtB9S/eCG
 vUv/nyLpLJQUZy2hFW7a/mzEwiw8SZpIZyM8IECaCPLhjkRpK0MHq5Eayh7XSecsDM
 WOzc2qaPG4OOg6KCeQvMYFnf+O5gOEZJyo+Ga3Kk=
To: Maxime Devos <maximedevos@HIDDEN>, 53818 <at> debbugs.gnu.org
Subject: Re: [bug#53818] [PATCH v2 5/7] import: Add 'repology' updater.
In-Reply-To: <76a550f4fc82de9491b99786e8086d9d9d8c4c72.camel@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
 <98726379214702d0745f56d9f946e792e803d326.1644224421.git.public@HIDDEN>
 <76a550f4fc82de9491b99786e8086d9d9d8c4c72.camel@HIDDEN>
Date: Tue, 08 Feb 2022 13:29:26 +0100
Message-ID: <87a6f1zgm1.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Maxime schrieb am Montag der 07. Februar 2022 um 10:50 +01:
    > Xinglu Chen schreef op ma 07-02-2022 om 10:07 [+0100]: >> +(define (latest-release
    package) >> +  (mock ((guix import json) json-fetch >> +        
    (lambda* (url #:key cached?) >> +     [...] 
 
 Content analysis details:   (2.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Maxime schrieb am Montag der 07. Februar 2022 um 10:50 +01:
    > Xinglu Chen schreef op ma 07-02-2022 om 10:07 [+0100]: >> +(define (latest-release
    package) >> +  (mock ((guix import json) json-fetch >> +        
    (lambda* (url #:key cached?) >> +     [...] 
 
 Content analysis details:   (2.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  1.0 BULK_RE_SUSP_NTLD      Precedence bulk and RE: from a suspicious TLD
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

Maxime schrieb am Montag der 07. Februar 2022 um 10:50 +01:

> Xinglu Chen schreef op ma 07-02-2022 om 10:07 [+0100]:
>> +(define (latest-release package)
>> +=C2=A0 (mock ((guix import json) json-fetch
>> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (lambda* (url #:key ca=
ched?)
>> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (json-stri=
ng->scm %test-json)))
>> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (repology-latest-release pac=
kage)))
>
> It would be nice to verify the URL.

What do you mean with =E2=80=9Cverify=E2=80=9D?

> FWIW, there's a 'with-http-server' macro.
> although it might need to be extended a little, see e.g.
> <https://issues.guix.gnu.org/53389>.
>
> Also, you are using 'memoize' in repology-fetch-info,
> so the memoisation cache needs to be invalidated
> (see e.g. tests/minetest.scm), or not, depending
> on how 'repology-fetch-info' is used and tests are written.

Good catch!  Invalidating the cache would be a good idea.

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQJJBAEBCAAzFiEEAVhh4yyK5+SEykIzrPUJmaL7XHkFAmICYiYVHHB1YmxpY0B5
b2N0b2NlbGwueHl6AAoJEKz1CZmi+1x5mDQQAKTnfhCvES45yP/a0QdlvLBo2EgW
J8ZAlGqEBlMzkYAlaxkH+xiP0gg7aalzMnarNU1KCAUTovZsk6bYhau+nk8mEQ88
QcyjftLBWLWLKaEvucavQ1M8aGoiuQnVDiRs6hJhlLok3EUau+UEdxCT7clsCBG6
tmwyfcGzKuM1UHrq1cAQ2fr1hMkSBW15WN5ksPXG3ug3M2PJBFgHxqFVEzXCZ9QG
JgT0sE4rTSrFASQpEaUKDBLsII3DYiXgF5ntra8+/B+OrCHoSvwYl6lxBITKq/RV
BXmM1Hrqv6Grjq2mLBb8csU72KpjWoId9WHxqqYwEDmgbQea1/r9A7BUBBfmf2Bo
GIW08cdlutc8hW0bua/UNJbxLEGrhU9Xy/3M6f56/LAXQivdegPSEu3G7rsRzyMw
yFZBp5fmw0oBHnMh6Dmf752Jm5H1VGN5phEjl/PMvsjXoCkyw7Fo6w4CPcCGZMIs
jTSK2nnARTCRfVSzsyNfZq6Ev0+lp9GLiStA+GSOeuxc5+ZhrydaexE71plM86Nv
ykaN1gBCXpVNlPG5VOwPJcA1UnYtDToyoi67iaOh6KaZJX/VVTwhbCxQovezGd+A
zHmuhcMKvYTRqAZYiIW7pa4KGaKHsteU/weBtJieSs8QHMBwA5XHBvuFb9T888kk
eGr7o1or6xz8c3rc
=koqK
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 7 Feb 2022 09:50:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 07 04:50:29 2022
Received: from localhost ([127.0.0.1]:41034 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nH0f0-00043G-N2
	for submit <at> debbugs.gnu.org; Mon, 07 Feb 2022 04:50:29 -0500
Received: from michel.telenet-ops.be ([195.130.137.88]:55622)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <maximedevos@HIDDEN>) id 1nH0ez-000432-EI
 for 53818 <at> debbugs.gnu.org; Mon, 07 Feb 2022 04:50:13 -0500
Received: from [172.20.10.9] ([213.119.168.30])
 by michel.telenet-ops.be with bizsmtp
 id s9qB260040fhH05069qBNq; Mon, 07 Feb 2022 10:50:12 +0100
Message-ID: <76a550f4fc82de9491b99786e8086d9d9d8c4c72.camel@HIDDEN>
Subject: Re: [bug#53818] [PATCH v2 5/7] import: Add 'repology' updater.
From: Maxime Devos <maximedevos@HIDDEN>
To: Xinglu Chen <public@HIDDEN>, 53818 <at> debbugs.gnu.org
Date: Mon, 07 Feb 2022 10:50:10 +0100
In-Reply-To: <98726379214702d0745f56d9f946e792e803d326.1644224421.git.public@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
 <98726379214702d0745f56d9f946e792e803d326.1644224421.git.public@HIDDEN>
Content-Type: multipart/signed; micalg="pgp-sha512";
 protocol="application/pgp-signature"; boundary="=-Z/PcsuxPhqf4O0UL9TO2"
User-Agent: Evolution 3.38.3-1 
MIME-Version: 1.0
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=telenet.be; s=r22;
 t=1644227412; bh=Zt+HUVI1efZPLFHtjCgUuqW6HlbB6lch6zPxvxloLnE=;
 h=Subject:From:To:Date:In-Reply-To:References;
 b=lh0glPX0uKAA0zR9ly7SvgE6Q9qPtGUYW23BSHSxaZyXKPCVJoteP6LtT1I0KRZR6
 Vf5q5Yxu6R45D1cSJgoq+bhkhPGJ77qI92NHyK4NwmW23q1a6XLiAKX171yAtTHMNk
 N9eyK8OsG5nFuarShXQyOEQX93ZpmmJPoQew9lR3pxNpymLXwzL2Gm0jIIWLeyis3b
 K2sftXEzZBTMepL0+RhggXpoAGjvryLoaheEsRfetvPJNZ6cbqKsq7iYZ3/Hh30R7W
 OSPRJV0/9+GchNv2jQkS6P2C17r1oNU+0dsjggGB9CgMHvt9AcidK4INcEKKvz9pb/
 jkubEI2SK0ETQ==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


--=-Z/PcsuxPhqf4O0UL9TO2
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable

Xinglu Chen schreef op ma 07-02-2022 om 10:07 [+0100]:
> +(define (latest-release package)
> +=C2=A0 (mock ((guix import json) json-fetch
> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (lambda* (url #:key cac=
hed?)
> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (json-strin=
g->scm %test-json)))
> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (repology-latest-release pack=
age)))

It would be nice to verify the URL.
FWIW, there's a 'with-http-server' macro.
although it might need to be extended a little, see e.g.
<https://issues.guix.gnu.org/53389>.

Also, you are using 'memoize' in repology-fetch-info,
so the memoisation cache needs to be invalidated
(see e.g. tests/minetest.scm), or not, depending
on how 'repology-fetch-info' is used and tests are written.

Greetings,
Maxime.

--=-Z/PcsuxPhqf4O0UL9TO2
Content-Type: application/pgp-signature; name="signature.asc"
Content-Description: This is a digitally signed message part
Content-Transfer-Encoding: 7bit

-----BEGIN PGP SIGNATURE-----

iI0EABYKADUWIQTB8z7iDFKP233XAR9J4+4iGRcl7gUCYgDrUhccbWF4aW1lZGV2
b3NAdGVsZW5ldC5iZQAKCRBJ4+4iGRcl7mdIAP9XBEBiopGDccsznDNFN7/bhNKU
3jS5oGOO0h9qqUUcdgD9EkOUUU0iinGjNIX2MtSjvKwXaxAyx0xhTSCXMQVMjAc=
=AVGv
-----END PGP SIGNATURE-----

--=-Z/PcsuxPhqf4O0UL9TO2--





Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 7 Feb 2022 09:45:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 07 04:45:51 2022
Received: from localhost ([127.0.0.1]:41012 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nH0al-0003sy-EJ
	for submit <at> debbugs.gnu.org; Mon, 07 Feb 2022 04:45:51 -0500
Received: from albert.telenet-ops.be ([195.130.137.90]:34038)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <maximedevos@HIDDEN>) id 1nH0ak-0003qn-9u
 for 53818 <at> debbugs.gnu.org; Mon, 07 Feb 2022 04:45:50 -0500
Received: from [172.20.10.9] ([213.119.168.30])
 by albert.telenet-ops.be with bizsmtp
 id s9lp2600v0fhH05069lpjn; Mon, 07 Feb 2022 10:45:49 +0100
Message-ID: <39e000a43e690d53f64dad1317bec5468b696b06.camel@HIDDEN>
Subject: Re: [bug#53818] [PATCH v2 5/7] import: Add 'repology' updater.
From: Maxime Devos <maximedevos@HIDDEN>
To: Xinglu Chen <public@HIDDEN>, 53818 <at> debbugs.gnu.org
Date: Mon, 07 Feb 2022 10:45:49 +0100
In-Reply-To: <98726379214702d0745f56d9f946e792e803d326.1644224421.git.public@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
 <98726379214702d0745f56d9f946e792e803d326.1644224421.git.public@HIDDEN>
Content-Type: multipart/signed; micalg="pgp-sha512";
 protocol="application/pgp-signature"; boundary="=-y3fOqfqTWEiUbgGOcZNh"
User-Agent: Evolution 3.38.3-1 
MIME-Version: 1.0
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=telenet.be; s=r22;
 t=1644227150; bh=t+ytquhTKSTd1DDtpqag9DE509oY3UOIV3svN+jZPXE=;
 h=Subject:From:To:Date:In-Reply-To:References;
 b=a4CQc3uKT4LGIghIiifY+JNPBNGVNUZT14zkX9ujJ9xnWSRSGTA5AibfS86jUvEYN
 sRYwlZSy+5xCDtcipR97FJ1XPYaFnazNgwbomSNUayru70/TwQz70uk/fb3HjHxXLY
 aLMJGF/VUNVW9sV4q0+PzGstgZwXk8fSc4vugjj8Avd6zM3pMWQC5wLI01cZBt9hp/
 tl24vZiJ03jIXC+1QOC2aGZPuuDIxxLNDlBcr3v5RePq1/g5F+USzZRtKZPnjW4TyF
 NTZ2i0YzotYeUj/Y/u2j9WoxIFQ/afaeA2/L4/PlwaM2W//XHoDcIe7HhZUtAZnFkX
 /e2oc3i9gKmeQ==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)


--=-y3fOqfqTWEiUbgGOcZNh
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable

Xinglu Chen schreef op ma 07-02-2022 om 10:07 [+0100]:
> +The name of a package in Guix is not always that same as the name on
> +Repology; users can set the @code{repology-name} package property to
> +make the updater use the correct name.

Perhaps note that the updater has some heuristics for determining
the Repology name, so setting 'repology-name' often isn't necessary
even when the name in Guix doesn't match the name in Repology?

Greetings,
Maxime.

--=-y3fOqfqTWEiUbgGOcZNh
Content-Type: application/pgp-signature; name="signature.asc"
Content-Description: This is a digitally signed message part
Content-Transfer-Encoding: 7bit

-----BEGIN PGP SIGNATURE-----

iI0EABYKADUWIQTB8z7iDFKP233XAR9J4+4iGRcl7gUCYgDqTRccbWF4aW1lZGV2
b3NAdGVsZW5ldC5iZQAKCRBJ4+4iGRcl7gKdAQCa6apx8Ajef3MEZDv8yh08cofH
NxbUh/XKg3HyvE26EgEAuhy6AnD71nwcSHce8wV+WESSDbYg9o0qE4tafgtTRw8=
=FM4X
-----END PGP SIGNATURE-----

--=-y3fOqfqTWEiUbgGOcZNh--





Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 7 Feb 2022 09:44:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 07 04:44:52 2022
Received: from localhost ([127.0.0.1]:41007 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nH0Zo-0003r0-5H
	for submit <at> debbugs.gnu.org; Mon, 07 Feb 2022 04:44:52 -0500
Received: from albert.telenet-ops.be ([195.130.137.90]:34038)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <maximedevos@HIDDEN>) id 1nH0Zj-0003qn-Ah
 for 53818 <at> debbugs.gnu.org; Mon, 07 Feb 2022 04:44:50 -0500
Received: from [172.20.10.9] ([213.119.168.30])
 by albert.telenet-ops.be with bizsmtp
 id s9kl260010fhH05069klMM; Mon, 07 Feb 2022 10:44:45 +0100
Message-ID: <afbe3757bf6c4031592e1067ae48c82140be1769.camel@HIDDEN>
Subject: Re: [bug#53818] [PATCH v2 4/7] import: json: Make 'json-fetch' take
 '#:cached?' argument.
From: Maxime Devos <maximedevos@HIDDEN>
To: Xinglu Chen <public@HIDDEN>, 53818 <at> debbugs.gnu.org
Date: Mon, 07 Feb 2022 10:44:44 +0100
In-Reply-To: <92ca3095e8a5cf1197afd8883017c6b3729184f3.1644224421.git.public@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
 <92ca3095e8a5cf1197afd8883017c6b3729184f3.1644224421.git.public@HIDDEN>
Content-Type: multipart/signed; micalg="pgp-sha512";
 protocol="application/pgp-signature"; boundary="=-gNFnsbKpf5k/Pcke26mq"
User-Agent: Evolution 3.38.3-1 
MIME-Version: 1.0
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=telenet.be; s=r22;
 t=1644227085; bh=UJfqZcvL6+kWbnw47m3i0bRacF+zeSTl7XqSCxtsDaQ=;
 h=Subject:From:To:Date:In-Reply-To:References;
 b=c7pXEkUlc7MhA3Od7bcRmVKoe89+9ydMFZ+YBz07/WbiNUPN3Xb42CuRYENS6E9a+
 WX+UuLs8OmwADYyG0mfTGNf3mn9FnJ1HPjNxPxUFYcF6DAPhNuYMgI5cpyukJpcSrc
 zRJRSwxMbZwj9JQhm2ab/wt6QfdfulCKSTWZDJJdj+b5fSlHd6f7VWjSzutYLVHGlN
 A+ZTptFuY2wEv/8gYajx8BsR9w1kT5SYb/kXpONarm/QDQNINXRHDFb8xCgIREjfPc
 MEalXQ/N5TRVOA2/kGaEdi8sfCyGR6DNR/DE7PC0qCBomBjyYSar/Cuk5vnk6Zvmoi
 JIxs9VqBNZZeQ==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)


--=-gNFnsbKpf5k/Pcke26mq
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable

Xinglu Chen schreef op ma 07-02-2022 om 10:07 [+0100]:
> +=C2=A0=C2=A0=C2=A0 (let* ((port=C2=A0=C2=A0 ((if cached?
> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=
=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 http-fet=
ch/cached
> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=
=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 http-fet=
ch)

Personally, instead of introdicing a cached? argument,
I would introduce a 'http-fetch' argument defaulting to 'http-fetch',
such that users of 'json-fetch' can set all the options of
'http-fetch/cached' (ttl, cache-miss ...).

(json-fetch #:http-fetch
            (lambda (uri . rest)
              (apply http-fetch/cached uri #:ttl foo #:cache-miss bar
                     rest)))

Greetings,
Maxime.

--=-gNFnsbKpf5k/Pcke26mq
Content-Type: application/pgp-signature; name="signature.asc"
Content-Description: This is a digitally signed message part
Content-Transfer-Encoding: 7bit

-----BEGIN PGP SIGNATURE-----

iI0EABYKADUWIQTB8z7iDFKP233XAR9J4+4iGRcl7gUCYgDqDBccbWF4aW1lZGV2
b3NAdGVsZW5ldC5iZQAKCRBJ4+4iGRcl7sxwAQDNfL5tyjmkkj6ApQ4VqpzMrZo7
Hi93XM6SPbJ4anLh5wEApsPV7vnDzaY0SkEMb46PFyB7fKejHA0vbblafBOMBQ4=
=+w6J
-----END PGP SIGNATURE-----

--=-gNFnsbKpf5k/Pcke26mq--





Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 7 Feb 2022 09:07:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 07 04:07:23 2022
Received: from localhost ([127.0.0.1]:40934 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nGzzX-0002tn-5h
	for submit <at> debbugs.gnu.org; Mon, 07 Feb 2022 04:07:23 -0500
Received: from h178-251-242-94.cust.a3fiber.se ([178.251.242.94]:55312
 helo=mail.yoctocell.xyz) by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <public@HIDDEN>) id 1nGzzV-0002sx-QS
 for 53818 <at> debbugs.gnu.org; Mon, 07 Feb 2022 04:07:22 -0500
From: Xinglu Chen <public@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yoctocell.xyz;
 s=mail; t=1644224836;
 bh=jfMlwFd48Ue03So3eKlueTE4uUT6FJ2S6vUX3eqQoKo=;
 h=From:To:Subject:In-Reply-To:References:Date;
 b=EM/pOGv/fsf2Y+ulVfhRID8ieg60TGeCzr1YrFFjXMYbLTNHSytSrRmjr2Uj+UJAc
 W0zSEFmnvDlFkrpOHQNqXBS3C23Soi5Z6Hm9we9uFFwnSEhU3R6SfWQtBbmFLiWNIc
 4jqSYU/ibyy13bkxqRLT+mBb6WNurhwzkUQLUelc=
To: 53818 <at> debbugs.gnu.org
Subject: [PATCH v2 7/7] gnu: xorg-server-xwayland: Prepare for
 cross-compilation.
In-Reply-To: <cover.1644224421.git.public@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
X-Debbugs-Cc: Maxime Devos <maximedevos@HIDDEN>
Message-Id: <e87678e75f6be71ec5f5b072ff1507e6e903e50b.1644224421.git.public@HIDDEN>
Date: Mon, 07 Feb 2022 10:07:16 +0100
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  * gnu/packages/xorg.scm (xorg-server-xwayland)[arguments]<#:phases>:
    Use ‘search-input-file’ instead of ‘which’. --- gnu/packages/xorg.scm
    | 5 +++-- 1 file changed, 3 insertions(+), 2 deletion [...] 
 
 Content analysis details:   (2.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  * gnu/packages/xorg.scm (xorg-server-xwayland)[arguments]<#:phases>:
    Use ‘search-input-file’ instead of ‘which’. --- gnu/packages/xorg.scm
    | 5 +++-- 1 file changed, 3 insertions(+), 2 deletion [...] 
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps

* gnu/packages/xorg.scm (xorg-server-xwayland)[arguments]<#:phases>: Use
  =E2=80=98search-input-file=E2=80=99 instead of =E2=80=98which=E2=80=99.
---
 gnu/packages/xorg.scm | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

diff --git a/gnu/packages/xorg.scm b/gnu/packages/xorg.scm
index 8be7017da7..dea7268a2e 100644
--- a/gnu/packages/xorg.scm
+++ b/gnu/packages/xorg.scm
@@ -5518,9 +5518,10 @@ (define-public xorg-server-xwayland
              "--localstatedir=3D/var")
        #:phases (modify-phases %standard-phases
                   (add-after 'unpack 'patch-/bin/sh
-                    (lambda _
+                    (lambda* (#:key inputs #:allow-other-keys)
                       (substitute* (find-files "." "\\.c$")
-                        (("/bin/sh") (which "sh"))))))))
+                        (("/bin/sh")
+                         (search-input-file inputs "bin/sh"))))))))
     (properties
      '((repology-name . "xwayland")))
     (synopsis "Xorg server with Wayland backend")
--=20
2.34.1







Information forwarded to maximedevos@HIDDEN, guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 7 Feb 2022 09:07:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 07 04:07:21 2022
Received: from localhost ([127.0.0.1]:40931 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nGzzU-0002tU-U9
	for submit <at> debbugs.gnu.org; Mon, 07 Feb 2022 04:07:21 -0500
Received: from h178-251-242-94.cust.a3fiber.se ([178.251.242.94]:55306
 helo=mail.yoctocell.xyz) by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <public@HIDDEN>) id 1nGzzS-0002so-RJ
 for 53818 <at> debbugs.gnu.org; Mon, 07 Feb 2022 04:07:19 -0500
From: Xinglu Chen <public@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yoctocell.xyz;
 s=mail; t=1644224833;
 bh=f7r1HprMCgd+yT9MgYeTpNbVfndFbU/YpwUOiR9Yx2Y=;
 h=From:To:Subject:In-Reply-To:References:Date;
 b=spQLOrU5g4vRxf19lNAmbPGdSnpb9bh2A+QeQqNtZYG6CsjedMACxjGeGM8KK+J6I
 TWazvBkGRvZxJAPg4806CaJQoIE1xgKlNkTq+Xqq3etbb5Od/1UBr6mJOf9Q3UbDrc
 0OcCMVdnDrYsE2kk7h4j2LqnhnngFYOq3lkQ6RTM=
To: 53818 <at> debbugs.gnu.org
Subject: [PATCH v2 6/7] gnu: xorg-server-xwayland: Set 'repology-name'
 property.
In-Reply-To: <cover.1644224421.git.public@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
X-Debbugs-Cc: Maxime Devos <maximedevos@HIDDEN>
Message-Id: <d6f6d0a9469679d88fdb08124d144339d73655ad.1644224421.git.public@HIDDEN>
Date: Mon, 07 Feb 2022 10:07:12 +0100
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  * gnu/packages/xorg.scm (xorg-server-xwayland):[properties]:
    Set 'repology-name'. --- gnu/packages/xorg.scm | 3 +++ 1 file changed, 3
   insertions(+) diff --git a/gnu/packages/xorg.scm b/gnu/packages/xorg.scm index
    14e35d19ae..8be7017da7 100644 --- a/gnu/packages/xorg.scm +++ b/gnu/packages/xorg.scm
    @@ -33,6 +33,7 @@ ;;; Copyright © 2021 Maxime De [...] 
 
 Content analysis details:   (2.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  * gnu/packages/xorg.scm (xorg-server-xwayland):[properties]:
    Set 'repology-name'. --- gnu/packages/xorg.scm | 3 +++ 1 file changed, 3
   insertions(+) diff --git a/gnu/packages/xorg.scm b/gnu/packages/xorg.scm index
    14e35d19ae..8be7017da7 100644 --- a/gnu/packages/xorg.scm +++ b/gnu/packages/xorg.scm
    @@ -33,6 +33,7 @@ ;;; Copyright © 2021 Maxime De [...] 
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps

* gnu/packages/xorg.scm (xorg-server-xwayland):[properties]: Set
'repology-name'.
---
 gnu/packages/xorg.scm | 3 +++
 1 file changed, 3 insertions(+)

diff --git a/gnu/packages/xorg.scm b/gnu/packages/xorg.scm
index 14e35d19ae..8be7017da7 100644
--- a/gnu/packages/xorg.scm
+++ b/gnu/packages/xorg.scm
@@ -33,6 +33,7 @@
 ;;; Copyright =C2=A9 2021 Maxime Devos <maximedevos@HIDDEN>
 ;;; Copyright =C2=A9 2021 qblade <qblade@HIDDEN>
 ;;; Copyright =C2=A9 2021 Lu Hui <luhux76@HIDDEN>
+;;; Copyright =C2=A9 2022 Xinglu Chen <public@HIDDEN>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -5520,6 +5521,8 @@ (define-public xorg-server-xwayland
                     (lambda _
                       (substitute* (find-files "." "\\.c$")
                         (("/bin/sh") (which "sh"))))))))
+    (properties
+     '((repology-name . "xwayland")))
     (synopsis "Xorg server with Wayland backend")
     (description "Xwayland is an X server for running X clients under
 Wayland.")
--=20
2.34.1






Information forwarded to maximedevos@HIDDEN, guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 7 Feb 2022 09:07:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 07 04:07:20 2022
Received: from localhost ([127.0.0.1]:40929 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nGzzT-0002tM-Vk
	for submit <at> debbugs.gnu.org; Mon, 07 Feb 2022 04:07:20 -0500
Received: from h178-251-242-94.cust.a3fiber.se ([178.251.242.94]:55300
 helo=mail.yoctocell.xyz) by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <public@HIDDEN>) id 1nGzzO-0002si-3V
 for 53818 <at> debbugs.gnu.org; Mon, 07 Feb 2022 04:07:15 -0500
From: Xinglu Chen <public@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yoctocell.xyz;
 s=mail; t=1644224828;
 bh=tM2bgZ0c95q9tm79KzPQw0F7/5o5pTKGvJyzdbNuSOQ=;
 h=From:To:Subject:In-Reply-To:References:Date;
 b=k/rcqoMhqU81atv1BjUpLmBtl6WwkMUJjnOrdcweAuAQsGnnQ9XTMbQTNKguz+MI+
 rEQTYKS+ChBFYRSfA9vNuph3Dhem3f8Cksa7Xls8IPMoz38nYD0G1MdmJaPN5u3Rzy
 Z0QlTySUbpa7GIV3gORwRtZdEazJB9vhM/MIMftw=
To: 53818 <at> debbugs.gnu.org
Subject: [PATCH v2 5/7] import: Add 'repology' updater.
In-Reply-To: <cover.1644224421.git.public@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
X-Debbugs-Cc: Maxime Devos <maximedevos@HIDDEN>
Message-Id: <98726379214702d0745f56d9f946e792e803d326.1644224421.git.public@HIDDEN>
Date: Mon, 07 Feb 2022 10:07:07 +0100
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: * guix/import/repology.scm * tests/import-repology.scm: New
 files. * Makefile.am (MODULES): Register them. * doc/guix.texi (Invoking
 guix refresh): Document it. --- Makefile.am | 3 + doc/guix.texi | 7 [...] 
 Content analysis details:   (2.5 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
 [URI: yoctocell.xyz (xyz)]
 0.4 RDNS_DYNAMIC           Delivered to internal network by host with
 dynamic-looking rDNS 0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  * guix/import/repology.scm * tests/import-repology.scm: New
    files. * Makefile.am (MODULES): Register them. * doc/guix.texi (Invoking
   guix refresh): Document it. --- Makefile.am | 3 + doc/guix.texi | 7 [...] 
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps

* guix/import/repology.scm
* tests/import-repology.scm: New files.
* Makefile.am (MODULES): Register them.
* doc/guix.texi (Invoking guix refresh): Document it.
---
 Makefile.am               |   3 +
 doc/guix.texi             |   7 ++
 guix/import/repology.scm  | 235 ++++++++++++++++++++++++++++++++++++++
 tests/import-repology.scm | 145 +++++++++++++++++++++++
 4 files changed, 390 insertions(+)
 create mode 100644 guix/import/repology.scm
 create mode 100644 tests/import-repology.scm

diff --git a/Makefile.am b/Makefile.am
index 7463606d20..6792917b59 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -16,6 +16,7 @@
 # Copyright =C2=A9 2019 Efraim Flashner <efraim@HIDDEN>
 # Copyright =C2=A9 2021 Chris Marusich <cmmarusich@HIDDEN>
 # Copyright =C2=A9 2021 Andrew Tropin <andrew@HIDDEN>
+# Copyright =C2=A9 2022 Xinglu Chen <public@HIDDEN>
 #
 # This file is part of GNU Guix.
 #
@@ -271,6 +272,7 @@ MODULES =3D					\
   guix/import/opam.scm				\
   guix/import/print.scm				\
   guix/import/pypi.scm				\
+  guix/import/repology.scm			\
   guix/import/stackage.scm			\
   guix/import/texlive.scm   			\
   guix/import/utils.scm				\
@@ -488,6 +490,7 @@ SCM_TESTS =3D					\
   tests/home-import.scm				\
   tests/import-git.scm				\
   tests/import-github.scm			\
+  tests/import-repology.scm			\
   tests/import-utils.scm			\
   tests/inferior.scm				\
   tests/lint.scm				\
diff --git a/doc/guix.texi b/doc/guix.texi
index 0cf865a672..15d215dd48 100644
--- a/doc/guix.texi
+++ b/doc/guix.texi
@@ -12932,6 +12932,13 @@
       (release-tag-version-delimiter . ":"))))
 @end lisp
=20
+@item repology
+an updater that scans @uref{https://repology.org, Repology}, a website
+that tracks packages on various package repositories, for updates.
+
+The name of a package in Guix is not always that same as the name on
+Repology; users can set the @code{repology-name} package property to
+make the updater use the correct name.
=20
 @end table
=20
diff --git a/guix/import/repology.scm b/guix/import/repology.scm
new file mode 100644
index 0000000000..28f3a3af5f
--- /dev/null
+++ b/guix/import/repology.scm
@@ -0,0 +1,235 @@
+;;; GNU Guix --- Functional package management for GNU
+;;; Copyright =C2=A9 2022 Xinglu Chen <public@HIDDEN>
+;;;
+;;; This file is part of GNU Guix.
+;;;
+;;; GNU Guix is free software; you can redistribute it and/or modify it
+;;; under the terms of the GNU General Public License as published by
+;;; the Free Software Foundation; either version 3 of the License, or (at
+;;; your option) any later version.
+;;;
+;;; GNU Guix is distributed in the hope that it will be useful, but
+;;; WITHOUT ANY WARRANTY; without even the implied warranty of
+;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+;;; GNU General Public License for more details.
+;;;
+;;; You should have received a copy of the GNU General Public License
+;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
+
+(define-module (guix import repology)
+  #:use-module (guix diagnostics)
+  #:use-module (guix diagnostics)
+  #:use-module (guix git-download)
+  #:use-module (guix i18n)
+  #:use-module (guix import json)
+  #:use-module (guix import utils)
+  #:use-module (guix memoization)
+  #:use-module (guix packages)
+  #:use-module (guix upstream)
+  #:use-module (guix utils)
+  #:use-module (ice-9 match)
+  #:use-module (json)
+  #:use-module (srfi srfi-1)
+  #:use-module (srfi srfi-2)
+  #:use-module (srfi srfi-26)
+  #:use-module (srfi srfi-43)
+  #:export (repology-latest-release
+            %repology-updater))
+
+;;; Commentary:
+;;;
+;;; This module provides an updater which scans Repology, a site that moni=
tors
+;;; several package repolsitories, for updates.  This means that if any ot=
her
+;;; package repository has a version of a package that is newer than the
+;;; version in Guix, the package should be able to be updated.  The updater
+;;; should in theory work for all packages in Guix, but the names of some
+;;; packages on Repology don't match the name in Guix.  The 'repology-name'
+;;; package property can be used to fix this.
+;;;
+;;; Guix already has many different updaters for language-specific package=
s,
+;;; and these typically provide more accurate data, e.g., input changes,
+;;; signature URLs.  The Repology updater should really be treated as a la=
st
+;;; resort for those packages that don't have any other updater to rely on.
+;;;
+;;; See <https://repology.org/api/v1> for the API.
+;;;
+;;; Code:
+
+(define %repology-url
+   "https://repology.org/api/v1/project")
+
+(define* (package-name->repology-name name #:key (attempt 1))
+  "Convert NAME, the name of a Guix package, to the name of the package on
+Repology.  It doesn't always guess the correct name on the first attempt, =
so
+on the second attempt it will try to guess another name."
+  (match attempt
+    (1 (cond
+        ((string-prefix? "ghc-" name)
+         (string-append "haskell:"
+                        (string-drop name (string-length "ghc-"))))
+        ((string-prefix? "ocaml-" name)
+         (string-append "ocaml:"
+                        (string-drop name (string-length "ocaml-"))))
+        ((string-prefix? "perl-" name)
+         (string-append "perl:"
+                        (string-drop name (string-length "perl-"))))
+        ((string-prefix? "emacs-" name)
+         (string-append "emacs:"
+                        (string-drop name (string-length "emacs-"))))
+        ((string-prefix? "go-" name)
+         (string-append "go:"
+                        (string-drop name (string-length "go-"))))
+        ((string-prefix? "rust-" name)
+         (string-append "rust:"
+                        (string-drop name (string-length "rust-"))))
+        ((string-prefix? "lua-" name)
+         (string-append "lua:"
+                        (string-drop name (string-length "lua-"))))
+        ((string-prefix? "node-" name)
+         (string-append "node:"
+                        (string-drop name (string-length "node-"))))
+        ((string-prefix? "python-" name)
+         (string-append "python:"
+                        (string-drop name (string-length "python-"))))
+        ((string-prefix? "java-" name)
+         (string-append "java:"
+                        (string-drop name (string-length "java-"))))
+        ((string-prefix? "r-" name)
+         (string-append "r:"
+                        (string-drop name (string-length "r-"))))
+        ((string-prefix? "ruby-" name)
+         (string-append "ruby:"
+                        (string-drop name (string-length "ruby-"))))
+        ((string-prefix? "xf86-" name)
+         (string-append "xdrv:"
+                        (string-drop name (string-length "xf86-"))))
+        ((string-prefix? "font-" name)
+         (string-append "fonts:"
+                        (string-drop name (string-length "font-"))))
+        ((string-suffix? "-minimal" name)
+         (string-drop-right name (string-length "-minimal")))
+        (else name)))
+    (2 (cond
+        ((string-prefix? "xf86-video" name)
+         (string-append "xdrv:"
+                        (string-drop name (string-length "xf86-video-"))))
+        ((string-prefix? "xf86-input" name)
+         (string-append "xdrv:"
+                        (string-drop name (string-length "xf86-input-"))))
+        ((string-prefix? "minetest-" name)
+         (string-append "minetest-mod-"
+                        (string-drop name (string-length "minetest-"))))
+        (else name)))))=20=20
+
+
+;;; JSON mappings.
+
+(define-json-mapping <repology-package> make-repology-package
+  repology-package?
+  json->repology-package
+  (repository repology-package-repository "repo")
+  (src-name repology-package-src-name "srcname")
+  (binary-name repology-package-binary-name "binname")
+  (visible-name repology-package-visible-name "visiblename")
+  (version repology-package-version)
+  (original-version repology-package-original-version "origversion")
+  (status repology-package-status)
+  (summary repology-package-summary)
+  (categories repology-package-categories)
+  (licenses repology-package-licenses)
+  (maintainers repology-package-maintainers))
+
+
+;;; Updater.
+
+(define repology-fetch-info
+  (memoize
+   (lambda (package)
+     "Fetch information about PACKAGE using the Repology API."
+     (define (name->info name)
+       (let ((url (string-append %repology-url "/" name)))
+         (and=3D> (json-fetch url #:cached? #t)
+                (lambda (url)
+                  (vector-map (lambda (a b)
+                                (json->repology-package b))
+                              url)))))
+=20=20=20=20=20
+     (let* ((name (or (assoc-ref (package-properties package)
+                                 'repology-name)
+                      (package-name->repology-name (package-name package))=
))
+            (info (name->info name)))
+       (if (and info (not (vector-empty? info)))
+           info
+           (let ((info (name->info (package-name->repology-name
+                                    (package-name package)
+                                    #:attempt 2))))
+             (if (and info (not (vector-empty? info)))
+                 info
+                 (begin
+                   (warning (G_ "package not found on Repology: ~a\n")
+                            (package-name package))
+                   #f))))))))
+
+(define (update-version string old-version new-version)
+  "Replace OLD-VERSION in STRING with NEW-VERSION.  This assumes that STRI=
NG
+contains OLD-VERSION verbatim; if it doesn't, #f is returned."
+  (match (factorize-uri string old-version)
+    ((? string?) #f)
+    ((factorized ...)
+     (apply string-append
+            (map (lambda (component)
+                   (match component
+                     ('version new-version)
+                     ((? string?) component)))
+                 factorized)))))
+
+(define (package-source-urls package version)
+  "Return a list of URLs for PACKAGE at VERSION.  If no URL was successful=
ly constructed, return #f."
+  (let ((old-version (package-version package)))
+    ;; XXX: (guix upstream) only supports tarballs and Git repos for now.
+    (match (origin-uri (package-source package))
+      ((? git-reference? reference)
+       (and-let* ((old-commit (git-reference-commit reference))
+                  (new-commit (if (string=3D? old-version old-commit)
+                                      version
+                                      (update-version old-commit
+                                                      old-version
+                                                      version))))
+         (git-reference
+          (inherit reference)
+          (commit new-commit))))
+      ((? string? url)
+       (list (update-version url old-version version)))
+      ((? list? urls)
+       (map (cut update-version <> old-version version) urls))
+      (_ #f))))
+
+(define (latest-version? repology-package)
+  "Return the latest released version of REPOLOGY-PACKAGE.  If none are fo=
und,
+return #f."
+  (and (or (equal? "newest" (repology-package-status repology-package))
+           (equal? "unique" (repology-package-status repology-package)))
+       (repology-package-version repology-package)))
+
+;; XXX: We use 'pkg' because 'package' will clash with the 'package' field=
 of
+;; 'upstream-source'.
+(define (repology-latest-release pkg)
+  "Return the latest release of the PKG on Repology named NAME."
+  (and-let* ((packages (repology-fetch-info pkg))
+             (versions (filter-map latest-version?
+                                   (vector->list packages)))
+             (latest-version (and (pair? versions) (car versions))))
+    ;; TODO: set 'signature-urls'.
+    (upstream-source
+     (package (package-name pkg))
+     (version latest-version)
+     (urls (package-source-urls pkg latest-version)))))
+
+(define %repology-updater
+  (upstream-updater
+   (name 'repology)
+   (description "Updater for packages on Repology")
+   (pred (const #t))
+   (latest repology-latest-release)))
+
+;;; repology.scm ends here
diff --git a/tests/import-repology.scm b/tests/import-repology.scm
new file mode 100644
index 0000000000..2d366db283
--- /dev/null
+++ b/tests/import-repology.scm
@@ -0,0 +1,145 @@
+;;; GNU Guix --- Functional package management for GNU
+;;; Copyright =C2=A9 2022 Xinglu Chen <public@HIDDEN>
+;;;
+;;; This file is part of GNU Guix.
+;;;
+;;; GNU Guix is free software; you can redistribute it and/or modify it
+;;; under the terms of the GNU General Public License as published by
+;;; the Free Software Foundation; either version 3 of the License, or (at
+;;; your option) any later version.
+;;;
+;;; GNU Guix is distributed in the hope that it will be useful, but
+;;; WITHOUT ANY WARRANTY; without even the implied warranty of
+;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+;;; GNU General Public License for more details.
+;;;
+;;; You should have received a copy of the GNU General Public License
+;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
+
+(define-module (test-import-repology)
+  #:use-module (guix download)
+  #:use-module (guix git-download)
+  #:use-module (guix import repology)
+  #:use-module (guix packages)
+  #:use-module (guix tests)
+  #:use-module (guix upstream)
+  #:use-module (json)
+  #:use-module (srfi srfi-64))
+
+(test-begin "repology")
+
+(define package-using-git-repository
+  (dummy-package
+   "foo"
+   (version "1.0")
+   (source
+    (origin
+      (method git-fetch)
+      (uri (git-reference
+            (url "https://git.example.org/foo")
+            (commit "1.0")))
+      (sha256 #f)))))
+
+(define package-using-tarball
+  (dummy-package
+   "foo"
+   (version "1.0")
+   (source
+    (origin
+      (method git-fetch)
+      (uri (string-append "https://example.org/foo-" version ".tar.gz"))
+      (sha256 #f)))))
+
+(define package-using-tarball-multiple-urls
+  (dummy-package
+   "foo"
+   (version "1.0")
+   (source
+    (origin
+      (method git-fetch)
+      (uri (list (string-append "https://example.org/foo-"
+                                version ".tar.gz")
+                 (string-append "https://mirror.example.org/foo-"
+                                version ".tar.gz")))
+      (sha256 #f)))))
+
+(define %test-json
+"[
+  {
+    \"repo\": \"aur\",
+    \"srcname\": \"foo\",
+    \"binname\": \"foo\",
+    \"visiblename\": \"foo\",
+    \"version\": \"1.0.r25.gb86405a\",
+    \"maintainers\": [
+      \"bob@aur\"
+    ],
+    \"licenses\": [
+      \"LGPL3+\"
+    ],
+    \"summary\": \"foo bar\"
+    \"status\": \"rolling\",
+    \"origversion\": \"1.0.r25.gb86405a-1\"
+  },
+  {
+    \"repo\": \"gnuguix\",
+    \"srcname\": \"foo\",
+    \"binname\": \"foo\",
+    \"visiblename\": \"foo\",
+    \"version\": \"1.0\",
+    \"summary\": \"foo bar\",
+    \"status\": \"outdated\",
+    \"origversion\": null
+  },
+  {
+    \"repo\": \"nix_unstable\",
+    \"name\": \"foo\",
+    \"visiblename\": \"foo\",
+    \"version\": \"2.0\",
+    \"maintainers\": [
+      \"bob@HIDDEN\"
+    ],
+    \"licenses\": [
+      \"LGPL-3.0-or-later\"
+    ],
+    \"summary\": \"foo bar\",
+    \"status\": \"newest\",
+    \"origversion\": null
+  }
+]")
+
+(define (latest-release package)
+  (mock ((guix import json) json-fetch
+         (lambda* (url #:key cached?)
+           (json-string->scm %test-json)))
+        (repology-latest-release package)))
+
+(test-equal "package using Git repo: version"
+  "2.0"
+  (upstream-source-version
+   (latest-release package-using-git-repository)))
+
+(test-equal "package using Git repo: git-reference"
+  (git-reference
+   (url "https://git.example.org/foo")
+   (commit "2.0"))
+  (upstream-source-urls
+   (latest-release package-using-git-repository)))
+
+(test-equal "package using tarball: version"
+  "2.0"
+  (upstream-source-version
+   (latest-release package-using-tarball)))
+
+(test-equal "package using tarball: URL"
+  (list "https://example.org/foo-2.0.tar.gz")
+  (upstream-source-urls
+   (latest-release package-using-tarball)))
+
+(test-equal "package using tarball: multiple URLs"
+  (list "https://example.org/foo-2.0.tar.gz"
+        "https://mirror.example.org/foo-2.0.tar.gz")
+  (upstream-source-urls
+   (latest-release package-using-tarball-multiple-urls)))
+
+(test-end "repology")
--=20
2.34.1







Information forwarded to maximedevos@HIDDEN, guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 7 Feb 2022 09:07:20 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 07 04:07:20 2022
Received: from localhost ([127.0.0.1]:40927 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nGzzT-0002tF-Gb
	for submit <at> debbugs.gnu.org; Mon, 07 Feb 2022 04:07:19 -0500
Received: from h178-251-242-94.cust.a3fiber.se ([178.251.242.94]:55284
 helo=mail.yoctocell.xyz) by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <public@HIDDEN>) id 1nGzzH-0002s5-Hn
 for 53818 <at> debbugs.gnu.org; Mon, 07 Feb 2022 04:07:08 -0500
From: Xinglu Chen <public@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yoctocell.xyz;
 s=mail; t=1644224821;
 bh=KGnmJSu9Rb12ycEVGSc8hZA/7M8jUHmu3RBtBxIxyEs=;
 h=From:To:Subject:In-Reply-To:References:Date;
 b=ogsHEGSjq3rwzjMUnTBfm5VEyTpQhvgVCoJVp3/Im++obZqfmtzQAVcA0bBE0gR/P
 /wiSqN5AnGxslRdcpr2Ipo5Uk4FvLIB9Q+LlTVFYFnYbeGBESYnYOHxwXwySUzsRm3
 O9TWoUw+oZIHXE0x17WF8C97WGVTALijeuQiE0oM=
To: 53818 <at> debbugs.gnu.org
Subject: [PATCH v2 4/7] import: json: Make 'json-fetch' take '#:cached?'
 argument.
In-Reply-To: <cover.1644224421.git.public@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
X-Debbugs-Cc: Maxime Devos <maximedevos@HIDDEN>
Message-Id: <92ca3095e8a5cf1197afd8883017c6b3729184f3.1644224421.git.public@HIDDEN>
Date: Mon, 07 Feb 2022 10:07:01 +0100
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  * json.scm (json-fetch): Add ‘#:cached?’ keyword argument.
    --- guix/import/json.scm | 14 ++++++++++---- 1 file changed, 10 insertions(+),
    4 deletions(-) diff --git a/guix/import/json.scm b/guix/import/json.scm index
    0c98bb25b8..6f88353659 100644 --- a/guix/import/json.scm +++ b/guix/import/json.scm
    @@ -3,6 +3,7 @@ ;;; Copyright © 2015, 2016 Eric Bavi [...] 
 
 Content analysis details:   (2.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  * json.scm (json-fetch): Add ‘#:cached?’ keyword argument.
    --- guix/import/json.scm | 14 ++++++++++---- 1 file changed, 10 insertions(+),
    4 deletions(-) diff --git a/guix/import/json.scm b/guix/import/json.scm index
    0c98bb25b8..6f88353659 100644 --- a/guix/import/json.scm +++ b/guix/import/json.scm
    @@ -3,6 +3,7 @@ ;;; Copyright © 2015, 2016 Eric Bavi [...] 
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps

* json.scm (json-fetch): Add =E2=80=98#:cached?=E2=80=99 keyword argument.
---
 guix/import/json.scm | 14 ++++++++++----
 1 file changed, 10 insertions(+), 4 deletions(-)

diff --git a/guix/import/json.scm b/guix/import/json.scm
index 0c98bb25b8..6f88353659 100644
--- a/guix/import/json.scm
+++ b/guix/import/json.scm
@@ -3,6 +3,7 @@
 ;;; Copyright =C2=A9 2015, 2016 Eric Bavier <bavier@HIDDEN>
 ;;; Copyright =C2=A9 2018, 2019 Ludovic Court=C3=A8s <ludo@HIDDEN>
 ;;; Copyright =C2=A9 2020 Ricardo Wurmus <rekado@HIDDEN>
+;;; Copyright =C2=A9 2022 Xinglu Chen <public@HIDDEN>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -37,17 +38,22 @@ (define-module (guix import json)
 (define* (json-fetch url
                      ;; Note: many websites returns 403 if we omit a
                      ;; 'User-Agent' header.
-                     #:key (headers `((user-agent . "GNU Guile")
-                                      (Accept . "application/json"))))
+                     #:key
+                     (headers `((user-agent . "GNU Guile")
+                                (Accept . "application/json")))
+                     cached?)
   "Return a representation of the JSON resource URL (a list or hash table)=
, or
 #f if URL returns 403 or 404.  HEADERS is a list of HTTP headers to pass in
-the query."
+the query.  If CACHED? is #t, 'http-fetch/cached' will be used to fetch UR=
L."
   (guard (c ((and (http-get-error? c)
                   (let ((error (http-get-error-code c)))
                     (or (=3D 403 error)
                         (=3D 404 error))))
              #f))
-    (let* ((port   (http-fetch url #:headers headers))
+    (let* ((port   ((if cached?
+                        http-fetch/cached
+                        http-fetch)
+                    url #:headers headers))
            (result (json->scm port)))
       (close-port port)
       result)))
--=20
2.34.1







Information forwarded to maximedevos@HIDDEN, guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 7 Feb 2022 09:07:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 07 04:07:19 2022
Received: from localhost ([127.0.0.1]:40925 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nGzzT-0002t1-1e
	for submit <at> debbugs.gnu.org; Mon, 07 Feb 2022 04:07:19 -0500
Received: from h178-251-242-94.cust.a3fiber.se ([178.251.242.94]:55268
 helo=mail.yoctocell.xyz) by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <public@HIDDEN>) id 1nGzz9-0002re-7U
 for 53818 <at> debbugs.gnu.org; Mon, 07 Feb 2022 04:07:03 -0500
From: Xinglu Chen <public@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yoctocell.xyz;
 s=mail; t=1644224813;
 bh=akL6Y2/X0FEbcEKilz3Py/WZu638Uz61mmUyiLjh3JI=;
 h=From:To:Subject:In-Reply-To:References:Date;
 b=daLPuNj11/d24yygmKE0YHg9U889uuPeRQdfSAINyfd5ZNVeJ/4wOrpqB2gi3Efki
 a4MZkFUsxvUPiNcK5RGFo0P7QqjCswJlfltMdkYv4+ROuiUAreSuxPRNFmSfFgnUfM
 NFwbRl5nreY3hiric5qlJskiU2c6fMyVBrCAlR2g=
To: 53818 <at> debbugs.gnu.org
Subject: [PATCH v2 2/7] http-client: Make 'http-fetch/cached' take
 '#:headers' argument.
In-Reply-To: <cover.1644224421.git.public@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
X-Debbugs-Cc: Maxime Devos <maximedevos@HIDDEN>
Message-Id: <fe8af3a502d7b6399834f0426088200936646aed.1644224421.git.public@HIDDEN>
Date: Mon, 07 Feb 2022 10:06:52 +0100
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  * guix/http-client.scm (http-fetch/cached): Take ‘#:headers’
    keyword argument. --- guix/http-client.scm | 13 ++++++++----- 1 file changed,
    8 insertions(+), 5 deletions(-) diff --git a/guix/http-client.scm b/guix/http-client.scm
    index 10bc278023..058f09852f 100644 --- a/guix/http-client.scm +++ b/guix/http-client.scm
    @@ -3,6 +3,7 @@ ;;; Copyright © 2015 Mark H Weaver < [...] 
 
 Content analysis details:   (2.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  0.0 T_SPF_HELO_TEMPERROR   SPF: test of HELO record failed (temperror)
 -0.0 SPF_PASS               SPF: sender matches SPF record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  * guix/http-client.scm (http-fetch/cached): Take ‘#:headers’
    keyword argument. --- guix/http-client.scm | 13 ++++++++----- 1 file changed,
    8 insertions(+), 5 deletions(-) diff --git a/guix/http-client.scm b/guix/http-client.scm
    index 10bc278023..058f09852f 100644 --- a/guix/http-client.scm +++ b/guix/http-client.scm
    @@ -3,6 +3,7 @@ ;;; Copyright © 2015 Mark H Weaver < [...] 
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps

* guix/http-client.scm (http-fetch/cached): Take =E2=80=98#:headers=E2=80=
=99 keyword argument.
---
 guix/http-client.scm | 13 ++++++++-----
 1 file changed, 8 insertions(+), 5 deletions(-)

diff --git a/guix/http-client.scm b/guix/http-client.scm
index 10bc278023..058f09852f 100644
--- a/guix/http-client.scm
+++ b/guix/http-client.scm
@@ -3,6 +3,7 @@
 ;;; Copyright =C2=A9 2015 Mark H Weaver <mhw@HIDDEN>
 ;;; Copyright =C2=A9 2012, 2015 Free Software Foundation, Inc.
 ;;; Copyright =C2=A9 2017 Tobias Geerinckx-Rice <me@HIDDEN>
+;;; Copyright =C2=A9 2022 Xinglu Chen <public@HIDDEN>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -283,9 +284,11 @@ (define* (http-fetch/cached uri #:key (ttl (%http-cach=
e-ttl)) text?
                             (write-cache dump-port)
                             (cache-miss (const #t))
                             (log-port (current-error-port))
-                            (timeout 10))
+                            (timeout 10)
+                            (headers '((user-agent . "GNU Guile"))))
   "Like 'http-fetch', return an input port, but cache its contents in
-~/.cache/guix.  The cache remains valid for TTL seconds.
+~/.cache/guix.  The cache remains valid for TTL seconds.  HEADERS is an al=
ist
+of extra HTTP headers.  The cache time will automatically be added to HEAD=
ERS, so there is no need to specify it.
=20
 Call WRITE-CACHE with the HTTP input port and the cache output port to wri=
te
 the data to cache.  Call CACHE-MISS with URI just before fetching data from
@@ -300,8 +303,8 @@ (define cache-time
         (and cache-port
              (stat:mtime (stat cache-port))))
=20
-      (define headers
-        `((user-agent . "GNU Guile")
+      (define headers*
+        `(,@headers
           ,@(if cache-time
                 `((if-modified-since
                    . ,(time-utc->date (make-time time-utc 0 cache-time))))
@@ -316,7 +319,7 @@ (define headers
                      (raise c))))
         (let ((port (http-fetch uri #:text? text?
                                 #:log-port log-port
-                                #:headers headers #:timeout timeout)))
+                                #:headers headers* #:timeout timeout)))
           (cache-miss uri)
           (mkdir-p (dirname file))
           (when cache-port
--=20
2.34.1







Information forwarded to maximedevos@HIDDEN, guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 7 Feb 2022 09:07:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 07 04:07:19 2022
Received: from localhost ([127.0.0.1]:40920 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nGzzF-0002sZ-10
	for submit <at> debbugs.gnu.org; Mon, 07 Feb 2022 04:07:19 -0500
Received: from h178-251-242-94.cust.a3fiber.se ([178.251.242.94]:55276
 helo=mail.yoctocell.xyz) by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <public@HIDDEN>) id 1nGzzD-0002ri-9A
 for 53818 <at> debbugs.gnu.org; Mon, 07 Feb 2022 04:07:03 -0500
From: Xinglu Chen <public@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yoctocell.xyz;
 s=mail; t=1644224817;
 bh=H8jADRyKH0fzq5VeA6Xl0rjl0GKGDAUsZO7ia0nN2ho=;
 h=From:To:Subject:In-Reply-To:References:Date;
 b=AkBgueNoH55EJP3JJBosf3/c8DZfwgdKy65vWi4gTiZggYkPOsg6mjsiQWHB9iD2f
 X4FLDz/u2vIiJXL9fSMK1j8jpIO3Tb3olEICxkBuPxuk7apPFq6W+JMZAT3/xFtSwE
 P4w2ruk50kgZZKDbiN6YQ61fMBlm7EUHjZ4bdFUc=
To: 53818 <at> debbugs.gnu.org
Subject: [PATCH v2 3/7] http-client: 'http-fetch/cached' accepts a string or
 a <uri>.
In-Reply-To: <cover.1644224421.git.public@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
X-Debbugs-Cc: Maxime Devos <maximedevos@HIDDEN>
Message-Id: <00f4de4c2fddf25566c726dde4a7d52ee80f7f71.1644224421.git.public@HIDDEN>
Date: Mon, 07 Feb 2022 10:06:57 +0100
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: This is consistent with the 'http-fetch' procedure. *
 guix/http-client.scm
 (http-fetch/cached): The 'uri' argument can be a string or a <uri> record.
 --- guix/http-client.scm | 5 ++++- 1 file changed, 4 insertions(+),
 1 deletion(-)
 Content analysis details:   (2.5 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
 [URI: yoctocell.xyz (xyz)]
 0.4 RDNS_DYNAMIC           Delivered to internal network by host with
 dynamic-looking rDNS 0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  This is consistent with the 'http-fetch' procedure. * guix/http-client.scm
    (http-fetch/cached): The 'uri' argument can be a string or a <uri> record.
    --- guix/http-client.scm | 5 ++++- 1 file changed, 4 insertions(+), 1 deletion(-)
    
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  0.0 T_SPF_HELO_TEMPERROR   SPF: test of HELO record failed (temperror)
 -0.0 SPF_PASS               SPF: sender matches SPF record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps

This is consistent with the 'http-fetch' procedure.

* guix/http-client.scm (http-fetch/cached): The 'uri' argument can be a string
  or a <uri> record.
---
 guix/http-client.scm | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

diff --git a/guix/http-client.scm b/guix/http-client.scm
index 058f09852f..08efdd5e47 100644
--- a/guix/http-client.scm
+++ b/guix/http-client.scm
@@ -297,7 +297,10 @@ (define* (http-fetch/cached uri #:key (ttl (%http-cache-ttl)) text?
 TIMEOUT specifies the timeout in seconds for connection establishment.
 
 Write information about redirects to LOG-PORT."
-  (let ((file (cache-file-for-uri uri)))
+  (let* ((uri (if (string? uri)
+                  (string->uri uri)
+                  uri))
+         (file (cache-file-for-uri uri)))
     (define (update-cache cache-port)
       (define cache-time
         (and cache-port
-- 
2.34.1







Information forwarded to maximedevos@HIDDEN, guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 7 Feb 2022 09:06:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 07 04:06:53 2022
Received: from localhost ([127.0.0.1]:40912 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nGzz2-0002rW-Mt
	for submit <at> debbugs.gnu.org; Mon, 07 Feb 2022 04:06:52 -0500
Received: from h178-251-242-94.cust.a3fiber.se ([178.251.242.94]:55260
 helo=mail.yoctocell.xyz) by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <public@HIDDEN>) id 1nGzz0-0002rJ-Rr
 for 53818 <at> debbugs.gnu.org; Mon, 07 Feb 2022 04:06:51 -0500
From: Xinglu Chen <public@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yoctocell.xyz;
 s=mail; t=1644224805;
 bh=uePA9eU3rVfA9D2Eoe6XklIGhmYCp8Bpq3h/n9/hOOk=;
 h=From:To:Subject:In-Reply-To:References:Date;
 b=h11PtFCOM1zR5RujP590b6iLRN3VYdW82tVW0+Rf292w7HAmP8JaqRTHd7qnZujZ0
 eoI9l2cPHzLC6nLYUINzabVlQNYBB/KmR0NXpN7hyxMbusW5pCfQfW3JH+GgffBOl8
 HQXySucp4zwinh1igfTyxDXVpxgfTnD4LIlhB+Ho=
To: 53818 <at> debbugs.gnu.org
Subject: [PATCH v2 1/7] upstream: Sort list of updaters.
In-Reply-To: <cover.1644224421.git.public@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
X-Debbugs-Cc: Maxime Devos <maximedevos@HIDDEN>
Message-Id: <c37b9459451716ba887074e31de919494608832f.1644224421.git.public@HIDDEN>
Date: Mon, 07 Feb 2022 10:06:45 +0100
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  The order determines which updater gets used first when running
    ‘guix refresh’ on a package. We want the most generic updaters to be
   last since they usually don’t provide as much or accurate inf [...] 
 
 Content analysis details:   (2.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  The order determines which updater gets used first when running
    ‘guix refresh’ on a package. We want the most generic updaters to be
   last since they usually don’t provide as much or accurate inf [...] 
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps

The order determines which updater gets used first when running =E2=80=98gu=
ix refresh=E2=80=99
on a package.  We want the most generic updaters to be last since they usua=
lly
don=E2=80=99t provide as much or accurate information as language-specific =
updaters.

* guix/upstream.scm (sort-updaters): New procedure.
(%updaters): Use it.
---
 guix/upstream.scm | 29 +++++++++++++++++++++++------
 1 file changed, 23 insertions(+), 6 deletions(-)

diff --git a/guix/upstream.scm b/guix/upstream.scm
index 6666803a92..d5faf9d3ee 100644
--- a/guix/upstream.scm
+++ b/guix/upstream.scm
@@ -250,14 +250,31 @@ (define (importer-modules)
                           %load-path)
                      #:warn warn-about-load-error)))
=20
+(define (sort-updaters updaters)
+  "Sort UPDATERS by putting the more generic ones last."
+  (define (genericity updater)
+    (cond
+     ((equal? 'repology (upstream-updater-name updater))
+      2)
+     ((string-prefix? "generic-"
+                      (symbol->string (upstream-updater-name updater)))
+      1)=20=20=20=20=20
+     (else 0)))
+
+  (define (less a b)
+    (<=3D (genericity a) (genericity b)))
+
+  (stable-sort updaters less))
+
 (define %updaters
   ;; The list of publically-known updaters.
-  (delay (fold-module-public-variables (lambda (obj result)
-                                         (if (upstream-updater? obj)
-                                             (cons obj result)
-                                             result))
-                                       '()
-                                       (importer-modules))))
+  (delay (sort-updaters
+          (fold-module-public-variables (lambda (obj result)
+                                          (if (upstream-updater? obj)
+                                              (cons obj result)
+                                              result))
+                                        '()
+                                        (importer-modules)))))
=20
 ;; Tests need to mock this variable so mark it as "non-declarative".
 (set! %updaters %updaters)
--=20
2.34.1







Information forwarded to maximedevos@HIDDEN, guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 7 Feb 2022 09:06:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 07 04:06:22 2022
Received: from localhost ([127.0.0.1]:40909 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nGzyY-0002qk-EK
	for submit <at> debbugs.gnu.org; Mon, 07 Feb 2022 04:06:22 -0500
Received: from h178-251-242-94.cust.a3fiber.se ([178.251.242.94]:55232
 helo=mail.yoctocell.xyz) by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <public@HIDDEN>) id 1nGzyU-0002qP-Af
 for 53818 <at> debbugs.gnu.org; Mon, 07 Feb 2022 04:06:21 -0500
From: Xinglu Chen <public@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yoctocell.xyz;
 s=mail; t=1644224770;
 bh=fuWQb7OJwOb7C+dLOr25H2QGE97cRZvlJ87BD1gUlr8=;
 h=From:To:Subject:In-Reply-To:References:Date;
 b=WfGUmBN1Cmb8XZ3rX/fXooaTPaueJ3oI+y/BvF8EE+DB20wei0HoVmHKB/BpApHR+
 0Ttvsb4ccXgnWGUBYK7BHuoYzFFhWEhYKAjQqAcQBGd4MxvwCooxHAXSFuAc4uz7ja
 JG/3xQNBjBDmcJQPibY6H8F3c/+8iSMqi+elj5qc=
To: 53818 <at> debbugs.gnu.org
Subject: [PATCH v2 0/7] Add Repology updater
In-Reply-To: <cover.1644147246.git.public@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
X-Debbugs-Cc: Maxime Devos <maximedevos@HIDDEN>
Message-Id: <cover.1644224421.git.public@HIDDEN>
Date: Mon, 07 Feb 2022 10:06:09 +0100
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  Hi, The following changes have been made since v1: * Sort
 the list of updaters to make generic ones come last. 
 Content analysis details:   (2.5 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
 [URI: yoctocell.xyz (xyz)]
 0.4 RDNS_DYNAMIC           Delivered to internal network by host with
 dynamic-looking rDNS 0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Hi, The following changes have been made since v1: * Sort
   the list of updaters to make generic ones come last. 
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

Hi,

The following changes have been made since v1:

* Sort the list of updaters to make generic ones come last.

* Make =E2=80=98json-fetch=E2=80=99 use =E2=80=98http-fetch/cached=E2=80=99=
 if the #:cached? argument is
  #t.

* Added some additional rules for converting Guix package names to
  Repology package names.

* Some typo fixes and more docstrings.

Xinglu Chen (7):
  upstream: Sort list of updaters.
  http-client: Make 'http-fetch/cached' take '#:headers' argument.
  http-client: 'http-fetch/cached' accepts a string or a <uri>.
  import: json: Make 'json-fetch' take '#:cached?' argument.
  import: Add 'repology' updater.
  gnu: xorg-server-xwayland: Set 'repology-name' property.
  gnu: xorg-server-xwayland: Prepare for cross-compilation.

 Makefile.am               |   3 +
 doc/guix.texi             |   7 ++
 gnu/packages/xorg.scm     |   8 +-
 guix/http-client.scm      |  18 ++-
 guix/import/json.scm      |  14 ++-
 guix/import/repology.scm  | 235 ++++++++++++++++++++++++++++++++++++++
 guix/upstream.scm         |  29 ++++-
 tests/import-repology.scm | 145 +++++++++++++++++++++++
 8 files changed, 441 insertions(+), 18 deletions(-)
 create mode 100644 guix/import/repology.scm
 create mode 100644 tests/import-repology.scm


base-commit: 7c9ad54b0616112c7eea6dd02379616aef206490
=2D-=20
2.34.1




--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQJJBAEBCAAzFiEEAVhh4yyK5+SEykIzrPUJmaL7XHkFAmIA4QEVHHB1YmxpY0B5
b2N0b2NlbGwueHl6AAoJEKz1CZmi+1x5+98P/2E8K0+rbSoyIldhJB0SpAab+35E
W2vBNZMKdzxXe03NmL3Xq83b8MBPzd6jgACppClzM/5Of3kw/xqDNt3uSxSIpqXC
Tobr8pCjycEBMLrmqw07jYFTU+nfT+q/YN1KXY1+FPCmsK8pCpQJpc+yHeuXfmGQ
V2Hub40UtQXdTAEzWhSRMS8nblyLiwOrntpLtHNNh7EhcBBvWLerpb8/4qHhJyNo
I8AXqQ7DZ+CyVRkcBE2Gm6+BshXnnAamJ9PyVXZsB+2/3U0GGNPbYuB1d4FRC1Pf
kJta9Dpay6Y3bUrzyoELvnIUnGV1xBX5kF6lBv07qfesyeYEdX5QraIP2iicTEjo
bXa14K856Q4ffoIq0u1hJFWwMnwhmpdyD9sdzXpfnw069fcwpv0vdknbaPlZgP41
0z/RDtWOu/iWG/g+KMr9DM3wiMA4NZ46vLLQA2hCaLn0WcexcitlYKpzuKMMaPoF
odOxPghHz76rVi3iP8DohCuaFzUf1dLPhUdBZAIj4Xtmm1urpwDIfMJtUpt3GViN
YUMHkRz4l4v3oWbBAJtPiX8VAdWZjlq1tbANHsop1uopU42XBiJxWa4eBufUANDM
LfjbSmeQRgxaPxoPjL+XMFkiTolA6o2RK78ceKZcX5kfRnpV1ElUvlrol7RJt83C
nuj1lNFbrRDWOl0L
=1dnW
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to maximedevos@HIDDEN, guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 6 Feb 2022 15:42:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 06 10:42:50 2022
Received: from localhost ([127.0.0.1]:39607 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nGjgg-0003HE-4n
	for submit <at> debbugs.gnu.org; Sun, 06 Feb 2022 10:42:50 -0500
Received: from h178-251-242-94.cust.a3fiber.se ([178.251.242.94]:35460
 helo=mail.yoctocell.xyz) by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <public@HIDDEN>) id 1nGjgb-0003Gx-RG
 for 53818 <at> debbugs.gnu.org; Sun, 06 Feb 2022 10:42:49 -0500
From: Xinglu Chen <public@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yoctocell.xyz;
 s=mail; t=1644162160;
 bh=cinsR7Gnfg3Jf7zMMAQQXwCn8KWOvdRYnkPVDFRrYDo=;
 h=From:To:Subject:In-Reply-To:References:Date;
 b=QADoHDoa69mvb5CHFYBN3CsraKNRwidvlpIKX78bFkkKO/46ozS7LEgOlhg3Qu4vh
 wCtPH/7+DRZzrShOJSvbeW/Z2rieV8R5487JFmQh3qxZH+FfNI59eEtjdpsjvjBVl0
 xv6HDUE53w4sCu1ScqveLesMx5GGHXLmw5Ts+G80=
To: Maxime Devos <maximedevos@HIDDEN>, 53818 <at> debbugs.gnu.org
Subject: Re: [bug#53818] [PATCH 2/3] import: Add 'repology' updater.
In-Reply-To: <e5eca0fb66221519769e9b10f1376260872a825e.camel@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
 <88f866aff65c0ec9611b6cc0ee9d680ba711df38.1644147246.git.public@HIDDEN>
 <e5eca0fb66221519769e9b10f1376260872a825e.camel@HIDDEN>
Date: Sun, 06 Feb 2022 16:42:39 +0100
Message-ID: <87pmo00zo0.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Spam-Score: 2.8 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Maxime schrieb am Sonntag der 06. Februar 2022 um 14:23 +01:
    > Xinglu Chen schreef op zo 06-02-2022 om 14:00 [+0100]: >> +            
    (latest-version (if (null? versions) > > Perhaps (and (pair? versions) (car
    versions)), YMMV. 
 
 Content analysis details:   (2.8 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  0.0 T_SPF_TEMPERROR        SPF: test of record failed (temperror)
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps
  0.3 KHOP_HELO_FCRDNS       Relay HELO differs from its IP's reverse DNS
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Maxime schrieb am Sonntag der 06. Februar 2022 um 14:23 +01:
    > Xinglu Chen schreef op zo 06-02-2022 om 14:00 [+0100]: >> +            
    (latest-version (if (null? versions) > > Perhaps (and (pair? versions) (car
    versions)), YMMV. 
 
 Content analysis details:   (2.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  1.0 BULK_RE_SUSP_NTLD      Precedence bulk and RE: from a suspicious TLD
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

Maxime schrieb am Sonntag der 06. Februar 2022 um 14:23 +01:

> Xinglu Chen schreef op zo 06-02-2022 om 14:00 [+0100]:
>> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=
=A0 (latest-version (if (null? versions)
>
> Perhaps (and (pair? versions) (car versions)), YMMV.

That looks a little cleaner, thanks!

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQJJBAEBCAAzFiEEAVhh4yyK5+SEykIzrPUJmaL7XHkFAmH/7G8VHHB1YmxpY0B5
b2N0b2NlbGwueHl6AAoJEKz1CZmi+1x5XoAQAKuREi34MbqeRnkWtrS4RyiIrzH1
N+l9m/XutPhDWcJoO9dEpNw/ScyYcheAIETLktxOMDPtLF1GK6k8cwBomubgS9nz
L8d9o/QiYqNR+GFbSukQn/WCP3uiijt6xFacO4/EIpSOd78vWQTorBqGHO4pwCVA
Jq31hDEzNFgqtUUR99IJCHPD83g65p+bz61GHhmrlEzLNoqA+A0prgth2Cn4a5+j
KpA0ejjYNjxXSSOyGfCPU+0TXbwhVTkifJ+GNMrBGNtmH3hXwjI4aT5RGaWdvIHM
EwmeR4hLCjW/gpaecVPN/X5Qm8f+1hPxr98dnetON1bt39MtRha3LzXPkmwY/DLv
FNFZayiwBaAgb69aaGllQ7IKz26KLoIh1wWpU37gVps/jdq3mLjd3ccKFQuWdJ5W
kGFARG0i7ek2nIbszmVnbAI/hXtUrjs4erp66XW9DDqpI3lWYofGNmidAuAX9e1J
8HZ8P8lg2RT7JLT3rJ0yf5Y/4kZd9Mb9pVDuvcMn44EKozrzxk8mv+Bm1PdwkG9h
6PHkpOygPZPtUOB9v1NsZEkuDS+fwP0QvOb6dMNE0ZPhwNG/YBUQQpYXUtYkCo1M
6l763bIypK5QTf9qqeKTWMB2JcrElTHvQ/4TrGJdqD8sM0t2Dh3KIYHiMC4QjD+6
VzjyEmUl3pxCh+Y4
=8bzj
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 6 Feb 2022 15:42:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 06 10:42:07 2022
Received: from localhost ([127.0.0.1]:39604 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nGjfy-0003GE-S4
	for submit <at> debbugs.gnu.org; Sun, 06 Feb 2022 10:42:07 -0500
Received: from h178-251-242-94.cust.a3fiber.se ([178.251.242.94]:35440
 helo=mail.yoctocell.xyz) by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <public@HIDDEN>) id 1nGjfx-0003Fh-Fs
 for 53818 <at> debbugs.gnu.org; Sun, 06 Feb 2022 10:42:06 -0500
From: Xinglu Chen <public@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yoctocell.xyz;
 s=mail; t=1644162119;
 bh=rp8ub8lBMRvRV5FRXcgx4pMTY03fYoWkJrp0VC0heeA=;
 h=From:To:Subject:In-Reply-To:References:Date;
 b=GWRKlXl7n9Ml0e52KHPDZyf8JlbK6hmv1V8qH0PG1PqCbcu3womHnVT59tzclTQgR
 eQaXct0Avry6PVkg8d0EBy0fvHIWSySHcoSMgDxenAdgOqCOh1ZkUqnEwYu3qmn54J
 o1Ct07maK31GMnJLHWuxCLJ+tgRYEG3BFb4LVtso=
To: Maxime Devos <maximedevos@HIDDEN>, 53818 <at> debbugs.gnu.org
Subject: Re: [bug#53818] [PATCH 2/3] import: Add 'repology' updater.
In-Reply-To: <d23e9b226fb9de027f2dae3b7ba4e72254f72998.camel@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
 <88f866aff65c0ec9611b6cc0ee9d680ba711df38.1644147246.git.public@HIDDEN>
 <d23e9b226fb9de027f2dae3b7ba4e72254f72998.camel@HIDDEN>
Date: Sun, 06 Feb 2022 16:41:58 +0100
Message-ID: <87sfsw0zp5.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Maxime schrieb am Sonntag der 06. Februar 2022 um 14:23 +01:
    > Xinglu Chen schreef op zo 06-02-2022 om 14:00 [+0100]: >> +        
    (and=> (json-fetch url) > > Given that we'll be contacting 'repology' for
    _every_ package > when doing "guix refresh -l", [...] 
 
 Content analysis details:   (2.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Maxime schrieb am Sonntag der 06. Februar 2022 um 14:23 +01:
    > Xinglu Chen schreef op zo 06-02-2022 om 14:00 [+0100]: >> +        
    (and=> (json-fetch url) > > Given that we'll be contacting 'repology' for
    _every_ package > when doing "guix refresh -l", [...] 
 
 Content analysis details:   (2.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  1.0 BULK_RE_SUSP_NTLD      Precedence bulk and RE: from a suspicious TLD
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

Maxime schrieb am Sonntag der 06. Februar 2022 um 14:23 +01:

> Xinglu Chen schreef op zo 06-02-2022 om 14:00 [+0100]:
>> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (and=3D> (json-fetch u=
rl)
>
> Given that we'll be contacting 'repology' for _every_ package
> when doing "guix refresh -l", some caching seems in order.
> Could 'http-fetch/cached' be used here?  json-fetch may
> need to be modified to allow overriding the http-fetch procedure
> used.

That would be a good idea.  It seems like =E2=80=98http-fetch/cached=E2=80=
=99 doesn=E2=80=99t
take a #:headers argument, so it will have to be modified first.

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQJJBAEBCAAzFiEEAVhh4yyK5+SEykIzrPUJmaL7XHkFAmH/7EYVHHB1YmxpY0B5
b2N0b2NlbGwueHl6AAoJEKz1CZmi+1x5TyoQAKJoZTiWm/F/zx+lvryIDHqQTXTe
Mri7zJwKEp6PTCVlper+yF63FzBaCvkaFDytjfgycPTMLN9m0fU823XY+yZxcteF
Z84Q7JbZ/YqmhG1oB6gp+ODwabk+mQ2horboXUzAeGVVGzoZwGQo/rnVhZYZdzRK
GhG6G366qY8KjvojHAy9vVHvUTg9myzxbyKN7b8ady95lbhqJC3+bDl0Am/vCPD/
U+1IKCEetOV1dTpY8ZgZTji/H+z+0u36qH6cdwPK5/m70xN7K0w/OqTAkmFD/e1/
x6O/ybbNgMmeOGFqbtRLcywr3LtQDrDwSpLfsgYv//yi7b6MbigHAtW6Bu9ui4bZ
FTkh3fpSQUkisFzwu2vGSZRsP0ngU98FY1XU3WwuuAzJQ4JDfVKVg8iWiZG15X8q
+iRq6mld8s4IFQjPYkR/xKHhVJOaPQx6AqGcDW6DC1jFrazWLB9ULve85Bz0iZSo
aMwJpSNjv3tCfrbnzd60yFhNJb/aX7Cpvpwer5YOGRL+TWVEIIR50k8IKyioZyZc
qzg3qkaSW175NR8S/pC6Mu0PEO7FF+wwUrCmTdSRnfSQtfrmir/2fI/p3fS01KuN
OcjAPukPiCgcEy45yQccMGqKhTYX26iLqEcymkZ1Ew7pPNlCD4aG7Ncira5aa1gL
5FHJw34trYbQ5PIU
=FJZz
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 6 Feb 2022 15:37:10 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 06 10:37:10 2022
Received: from localhost ([127.0.0.1]:39589 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nGjbC-00037Z-FO
	for submit <at> debbugs.gnu.org; Sun, 06 Feb 2022 10:37:10 -0500
Received: from baptiste.telenet-ops.be ([195.130.132.51]:47756)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <maximedevos@HIDDEN>) id 1nGjb7-00037O-TG
 for 53818 <at> debbugs.gnu.org; Sun, 06 Feb 2022 10:37:09 -0500
Received: from [172.20.10.5] ([188.188.37.53])
 by baptiste.telenet-ops.be with bizsmtp
 id rrd32600C18o4tG01rd3Ui; Sun, 06 Feb 2022 16:37:04 +0100
Message-ID: <a3d7121e863f279e2beeb100525cf27c9178ba2f.camel@HIDDEN>
Subject: Re: [bug#53818] [PATCH 2/3] import: Add 'repology' updater.
From: Maxime Devos <maximedevos@HIDDEN>
To: Xinglu Chen <public@HIDDEN>, 53818 <at> debbugs.gnu.org
Date: Sun, 06 Feb 2022 16:36:58 +0100
In-Reply-To: <87wni81023.fsf@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
 <88f866aff65c0ec9611b6cc0ee9d680ba711df38.1644147246.git.public@HIDDEN>
 <dfef21301f4f514357c96d09e1c22adecac09d60.camel@HIDDEN>
 <87wni81023.fsf@HIDDEN>
Content-Type: multipart/signed; micalg="pgp-sha512";
 protocol="application/pgp-signature"; boundary="=-+BcaRn8QstERfgJDetoB"
User-Agent: Evolution 3.38.3-1 
MIME-Version: 1.0
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=telenet.be; s=r22;
 t=1644161824; bh=2Gs56UjYaQhvkUkdaxzdf9vro/YLu88gGjww2beiGhY=;
 h=Subject:From:To:Date:In-Reply-To:References;
 b=mF4OhVR+ekKFjDZAgdFvH2q6yMJXX2NlVJnMM6xnF2oCjc47uNAygHBs7vb70mqIj
 7EAFoHquwyPLjOEpP+NbfbvPU/X/M/xY0Yz8brZv6d2f5RCshfNPZJRQgzm0owxHG4
 ANP7J9nRAwGsYr0DzVjxtoA82W7JJ3QbpPllq6ArIMxh0YPdt32PwTa0HaXy/Kn8dZ
 SmFMSDN1xTzxPbg6LhwxHzwh0Lqh/SE1hg/Yg69hRdyW8ZjmLGetLl6ut5zbWUIH+C
 RBMzWGoNzIM9u0hIwGi/zp30R/ryQ3mqr7/VQZOPjN2oe/OKjL3dUnw0KrYoZT++/s
 6863/nCjJ4dZg==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)


--=-+BcaRn8QstERfgJDetoB
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable

Xinglu Chen schreef op zo 06-02-2022 om 16:34 [+0100]:
> > of a package, unlike, say, Debian stable.
>=20
> =E2=80=9CStable=E2=80=9D refers to a stable release, so things like pre-r=
eleases will
> be
> ignored.=C2=A0 Maybe it should be renamed to =E2=80=98latest-release?=E2=
=80=99 or
> =E2=80=98latest-stable-release?=E2=80=99?

I would go with 'latest-release?' and a comment or docstring explaining
that pre-releases are ignored.

Greetings,
Maxime.

--=-+BcaRn8QstERfgJDetoB
Content-Type: application/pgp-signature; name="signature.asc"
Content-Description: This is a digitally signed message part
Content-Transfer-Encoding: 7bit

-----BEGIN PGP SIGNATURE-----

iI0EABYKADUWIQTB8z7iDFKP233XAR9J4+4iGRcl7gUCYf/rGhccbWF4aW1lZGV2
b3NAdGVsZW5ldC5iZQAKCRBJ4+4iGRcl7sDtAP9bgmc8uJAP2ip8D8XAYl0ZZSMd
hnf3/8DTug2k+Mq3XAD7B6nYjCot2NZz2lSNEGsd/TXAv7sDVhDFfYBprYzIBwg=
=lR8o
-----END PGP SIGNATURE-----

--=-+BcaRn8QstERfgJDetoB--





Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 6 Feb 2022 15:34:20 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 06 10:34:20 2022
Received: from localhost ([127.0.0.1]:39578 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nGjYS-00032C-MO
	for submit <at> debbugs.gnu.org; Sun, 06 Feb 2022 10:34:20 -0500
Received: from h178-251-242-94.cust.a3fiber.se ([178.251.242.94]:35260
 helo=mail.yoctocell.xyz) by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <public@HIDDEN>) id 1nGjYR-00031y-IT
 for 53818 <at> debbugs.gnu.org; Sun, 06 Feb 2022 10:34:19 -0500
From: Xinglu Chen <public@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yoctocell.xyz;
 s=mail; t=1644161654;
 bh=q9NLbiekF9rHFNKbdQhu1Hf/M+0WO9ocYfM6ezqIHkw=;
 h=From:To:Subject:In-Reply-To:References:Date;
 b=kCuC4P6wh6v/l1jz8rCuUZ03BG/t3hCMaSY05vek8wq49ZklI7eVCqA0+5Eb2Nwf7
 dNgCz6SoiJJL0LgGzl1SGZnK12P1MraRwRsSDP11FpMioIT+9a6rlOgWPS0deVBhYv
 lsYz/Yg/YZ6EZ3W3t2/Vu5SXQ/lTsWHXAtRpHjlw=
To: Maxime Devos <maximedevos@HIDDEN>, 53818 <at> debbugs.gnu.org
Subject: Re: [bug#53818] [PATCH 2/3] import: Add 'repology' updater.
In-Reply-To: <dfef21301f4f514357c96d09e1c22adecac09d60.camel@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
 <88f866aff65c0ec9611b6cc0ee9d680ba711df38.1644147246.git.public@HIDDEN>
 <dfef21301f4f514357c96d09e1c22adecac09d60.camel@HIDDEN>
Date: Sun, 06 Feb 2022 16:34:12 +0100
Message-ID: <87wni81023.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Maxime schrieb am Sonntag der 06. Februar 2022 um 14:18 +01:
    > Xinglu Chen schreef op zo 06-02-2022 om 14:00 [+0100]: >> +(define (stable-version?
    repology-package) >> +  (and (or (equal? "newest" (repology-package-status
    repology-package)) >> +        [...] 
 
 Content analysis details:   (2.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Maxime schrieb am Sonntag der 06. Februar 2022 um 14:18 +01:
    > Xinglu Chen schreef op zo 06-02-2022 om 14:00 [+0100]: >> +(define (stable-version?
    repology-package) >> +  (and (or (equal? "newest" (repology-package-status
    repology-package)) >> +        [...] 
 
 Content analysis details:   (2.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  1.0 BULK_RE_SUSP_NTLD      Precedence bulk and RE: from a suspicious TLD
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

Maxime schrieb am Sonntag der 06. Februar 2022 um 14:18 +01:

> Xinglu Chen schreef op zo 06-02-2022 om 14:00 [+0100]:
>> +(define (stable-version? repology-package)
>> +=C2=A0 (and (or (equal? "newest" (repology-package-status repology-pack=
age))
>> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (equal? "u=
nique" (repology-package-status repology-package)))
>> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (repology-package-version repology=
-package)))
>
> What does 'stable' mean here?  We usually just use the latest version
> of a package, unlike, say, Debian stable.

=E2=80=9CStable=E2=80=9D refers to a stable release, so things like pre-rel=
eases will be
ignored.  Maybe it should be renamed to =E2=80=98latest-release?=E2=80=99 or
=E2=80=98latest-stable-release?=E2=80=99?

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQJJBAEBCAAzFiEEAVhh4yyK5+SEykIzrPUJmaL7XHkFAmH/6nUVHHB1YmxpY0B5
b2N0b2NlbGwueHl6AAoJEKz1CZmi+1x5isUP/1M+4Gj/t2swzkDVHDMq6DpLdSik
0W8fWxy8eDxMmW0NDaazHor03/jhneSQlqvp99jOW3LBx37aV+5ysb1Oo7bhcQdV
KyfMH6SJ9AzQIWBs5Km/wc9rdgBKqQn0Vpl+K6Cpx+oSslh5+WxP/TySrYfMVPwH
DFGOtjp0SRftoM04wAMpJ/vHSc4FUZ5wgIzi7FB6c+6p80iWZ5U5t/XxGEvWufZg
1F/pqLwiE/icG1ggO6VVeZXpe2Dl51ErKMA96YCgldDa3RbFabVewWm7Z0JwPpya
nspwmF0DMYBqic/i9Bm1mr5/ZAvYmlOzbZ4wgyZ8Y3Q/Ds8l6TScG5Sn4H7ppLch
Zb1IE/6XGZl+gvfp6P/xzYFu76EuuIkFVbys04clK8edctA0AAqLGcp42uCBfMsp
j5drXD64pRP++4/EdtDmV9y/mP3+kcYcBNBCTCzcohqHVR1w9WS5cmdkuyYMR/JD
qfuessWh1nYfHXHDlpSe8fVC/SB2XtrO8xtGlbjEq2dY3N1xd78MqKdxRJQn14cW
rCMcsNUxhQ1No/BSSJpRuJuTBSu9HbufBqIyvcReINK2tsRxDL9cPRQQ1MhsORHs
AeuXrNjPxbw9dzt4yvUThRaUXnfJa5KQTedOdZDeZaozGcbAhf3y3wGivfXTu224
fxUEnUkSQ5NqEasN
=0PHK
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 6 Feb 2022 15:32:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 06 10:32:11 2022
Received: from localhost ([127.0.0.1]:39574 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nGjWN-0002yv-9r
	for submit <at> debbugs.gnu.org; Sun, 06 Feb 2022 10:32:11 -0500
Received: from h178-251-242-94.cust.a3fiber.se ([178.251.242.94]:35212
 helo=mail.yoctocell.xyz) by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <public@HIDDEN>) id 1nGjWL-0002yh-90
 for 53818 <at> debbugs.gnu.org; Sun, 06 Feb 2022 10:32:09 -0500
From: Xinglu Chen <public@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yoctocell.xyz;
 s=mail; t=1644161523;
 bh=LVVuYmgKkqw+OdBYh1N0/PW09lQdRhrz9XXWLRCi2/Y=;
 h=From:To:Subject:In-Reply-To:References:Date;
 b=iwetYzKK8IOdhoasZsDfq1t2jyqLExz7cgaGacvD3Khd5R+RHJ0UL1eF0PdmAzokI
 PgU8HqIpC66Lf1NNXFLeunSGUrS8t3Kck7IExAdg2wJcM0wc2aDp5EqSv/r4W31qqC
 Dkg+7WEO1q0JcuWMPX0ZOaxXjwA068MEUF2MAsVc=
To: Maxime Devos <maximedevos@HIDDEN>, 53818 <at> debbugs.gnu.org
Subject: Re: [bug#53818] [PATCH 2/3] import: Add 'repology' updater.
In-Reply-To: <97d4bfcc95de2a5bf5143dc7b178c270c0c8afde.camel@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
 <88f866aff65c0ec9611b6cc0ee9d680ba711df38.1644147246.git.public@HIDDEN>
 <97d4bfcc95de2a5bf5143dc7b178c270c0c8afde.camel@HIDDEN>
Date: Sun, 06 Feb 2022 16:32:02 +0100
Message-ID: <87zgn4105p.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Maxime schrieb am Sonntag der 06. Februar 2022 um 14:17 +01:
    > Xinglu Chen schreef op zo 06-02-2022 om 14:00 [+0100]: >> +      (($
    <git-reference> url commit recursive?) >> +       (and-let* ((updated-commit
    (if (string=? old-version commit) >> +  [...] 
 
 Content analysis details:   (2.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Maxime schrieb am Sonntag der 06. Februar 2022 um 14:17 +01:
    > Xinglu Chen schreef op zo 06-02-2022 om 14:00 [+0100]: >> +      (($
    <git-reference> url commit recursive?) >> +       (and-let* ((updated-commit
    (if (string=? old-version commit) >> +  [...] 
 
 Content analysis details:   (2.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  1.0 BULK_RE_SUSP_NTLD      Precedence bulk and RE: from a suspicious TLD
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: base64

TWF4aW1lIHNjaHJpZWIgYW0gU29ubnRhZyBkZXIgMDYuIEZlYnJ1YXIgMjAyMiB1bSAxNDoxNyAr
MDE6DQoNCj4gWGluZ2x1IENoZW4gc2NocmVlZiBvcCB6byAwNi0wMi0yMDIyIG9tIDE0OjAwIFsr
MDEwMF06DQo+PiArwqDCoMKgwqDCoCAoKCQgPGdpdC1yZWZlcmVuY2U+IHVybCBjb21taXQgcmVj
dXJzaXZlPykNCj4+ICvCoMKgwqDCoMKgwqAgKGFuZC1sZXQqICgodXBkYXRlZC1jb21taXQgKGlm
IChzdHJpbmc9PyBvbGQtdmVyc2lvbiBjb21taXQpDQo+PiArwqDCoMKgwqDCoMKgwqDCoMKgwqDC
oMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqAgdmVy
c2lvbg0KPj4gK8KgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDC
oMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgICh1cGRhdGUtdXJsIGNvbW1pdCBvbGQtdmVyc2lv
biB2ZXJzaW9uKSkpKQ0KPg0KPiBXaGVuIGRvZXMgdGhlIFVSTCBvZiBhIGdpdC1yZWZlcmVuY2Ug
aW5jbHVkZSBhIHZlcnNpb24/DQoNCkl0IGRvZXNu4oCZdCwgYnV0IHRoZSB0YWcgdXN1YWxseSBk
b2VzOyBJIHNob3VsZCBwcm9iYWJseSByZW5hbWUgdGhlDQrigJh1cGRhdGUtdXJs4oCZIHByb2Nl
ZHVyZSB0byBzb21ldGhpbmcgZWxzZSwgbWF5YmUg4oCYdXBkYXRlLXZlcnNpb27igJk/DQoNCj4+
ICvCoMKgwqDCoMKgwqDCoMKgIChsaXN0IChnaXQtcmVmZXJlbmNlDQo+PiArwqDCoMKgwqDCoMKg
wqDCoMKgwqDCoMKgwqDCoMKgICh1cmwgdXJsKQ0KPj4gK8KgwqDCoMKgwqDCoMKgwqDCoMKgwqDC
oMKgwqDCoCAoY29tbWl0IHVwZGF0ZWQtY29tbWl0KQ0KPj4gK8KgwqDCoMKgwqDCoMKgwqDCoMKg
wqDCoMKgwqDCoCAocmVjdXJzaXZlPyByZWN1cnNpdmU/KSkpKSkNCj4NCj4gKGd1aXggdXBzdHJl
YW0pIGV4cGVjdHMgYSBzaW5nbGUgZ2l0LXJlZmVyZW5jZSwgbm90IGEgbGlzdCBvZiBnaXQtDQo+
IHJlZmVyZW5jZXMuDQoNCk9vcHMsIG5vdGVkLg0KDQo+IEFsc28sIGRlcGVuZGluZyBvbiB0aGUg
b3JkZXIgb2YgZmllbGRzIGhlcmUgZG9lc24ndCBzZWVtIGdyZWF0LCBJJyBkbw0KPiBzb21ldGhp
bmcgbGlrZQ0KPg0KPiAoKD8gZ2l0LXJlZmVyZW5jZT8gcmVmZXJlbmNlKQ0KPiAgKGdpdC1yZWZl
cmVuY2UNCj4gICAgIChpbmhlcml0IHJlZmVyZW5jZSkNCj4gICAgIChjb21taXQgdXBkYXRlZC1j
b21taXQpKSkNCj4NCj4gaW5zdGVhZC4NCg0KVGhlbiBJIGNhbiBkcm9wIHRoZSBmaXJzdCBwYXRj
aCBvZiB0aGUgc2VyaWVzIHRvby4gIDotKQ0K

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQJJBAEBCAAzFiEEAVhh4yyK5+SEykIzrPUJmaL7XHkFAmH/6fIVHHB1YmxpY0B5
b2N0b2NlbGwueHl6AAoJEKz1CZmi+1x5b0IQAKjEZ36foAKOtys0XF3DzgSwZql6
CD2E+RZLGWoAVZyEWwOIQxsx4EhZd2fyPkSxqcOhUbpIXRLmTPDkO8BL+dcVNtAu
dmCvmwOunHGrKwGuuEuV5/MXgCjTFksJmgTt2lj4VCDDwDVzXWm3dfuQXbKemLL/
5Rna2VbDQ7JqIQvv/9IS9bh+6muSUxOWDC6PDPzD/vjXPcAxiw9VSZVDuy+9xxw+
Y4IjNCEVWn6rWSHnoKKnZL5UiI5PSh72IdsNa8fO/7q5FTYNyGOcXHVcNcjC4Ii/
x91qTpWgiNSJdEqd0mXqtSiVlNcwvA4arY3BANVMYc/DDXup/ABXZofINsYe4V6w
x2R5uqQjaB0q9v6Fgt9tWO/m1DGWAhHn5YkQ9BJr3IHsB1TQ1GNuTnpMMEtKOtqZ
QN0DjxI7E0brvIvxXaSQNHl0eFzNOhnIZV9vt+BuKQB/+f1Lp/7iUYbdp/GXzxXc
50bIDaB8htFjt65iFe/Hdwn24EFQxAbyE43BU+EHVrz3bDOR2rDkLtB9vBU0TIpu
1t7bb4CqFqOfeAowpWZKVGl0Wc+bC5KMnw/oeyCb0uPJ7Hn3qZ2HJzh88xUPaOM8
s+/K07unctQHAARnktF5YZTbJqDZsFTd/YS3LY6cH+MVRB85wlekD4UE8Iq+bSCD
9/Xs2/0+0S8iw34N
=GfKQ
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 6 Feb 2022 15:26:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 06 10:26:29 2022
Received: from localhost ([127.0.0.1]:39565 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nGjQr-0002oF-EP
	for submit <at> debbugs.gnu.org; Sun, 06 Feb 2022 10:26:29 -0500
Received: from h178-251-242-94.cust.a3fiber.se ([178.251.242.94]:35096
 helo=mail.yoctocell.xyz) by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <public@HIDDEN>) id 1nGjQp-0002o1-8b
 for 53818 <at> debbugs.gnu.org; Sun, 06 Feb 2022 10:26:27 -0500
From: Xinglu Chen <public@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yoctocell.xyz;
 s=mail; t=1644161180;
 bh=pHBn5LpaLuCpTNXRhpjga0GtvVHcolriTc6sOekeV/Y=;
 h=From:To:Subject:In-Reply-To:References:Date;
 b=pynDj9OqiiElAtifa+WPeO6ImpszX0nGm1e5CLN6G8qq9AlLE2uSBrYwwvEZV1CqR
 HjYtKOIoOjh9oArp7AgHEomVVjBOUaJSH3vVvVkV6xLmvDHyOb1lklk4d/xSZQuoEw
 tSzJWDleiSSA8z/CbjLJGczwDi0ySFEDctHyrvTs=
To: Maxime Devos <maximedevos@HIDDEN>, 53818 <at> debbugs.gnu.org
Subject: Re: [bug#53818] [PATCH 2/3] import: Add 'repology' updater.
In-Reply-To: <af74ba55be34c098ec2289e2871592a5b5b6d5aa.camel@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
 <88f866aff65c0ec9611b6cc0ee9d680ba711df38.1644147246.git.public@HIDDEN>
 <af74ba55be34c098ec2289e2871592a5b5b6d5aa.camel@HIDDEN>
Date: Sun, 06 Feb 2022 16:26:19 +0100
Message-ID: <8735kw2ezo.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Maxime schrieb am Sonntag der 06. Februar 2022 um 14:13 +01:
    > Xinglu Chen schreef op zo 06-02-2022 om 14:00 [+0100]: >> +            
    (if (and info (not (vector-empty? info))) >> +                
    info >> +              [...] 
 
 Content analysis details:   (2.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Maxime schrieb am Sonntag der 06. Februar 2022 um 14:13 +01:
    > Xinglu Chen schreef op zo 06-02-2022 om 14:00 [+0100]: >> +            
    (if (and info (not (vector-empty? info))) >> +                
    info >> +              [...] 
 
 Content analysis details:   (2.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  1.0 BULK_RE_SUSP_NTLD      Precedence bulk and RE: from a suspicious TLD
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: base64

TWF4aW1lIHNjaHJpZWIgYW0gU29ubnRhZyBkZXIgMDYuIEZlYnJ1YXIgMjAyMiB1bSAxNDoxMyAr
MDE6DQoNCj4gWGluZ2x1IENoZW4gc2NocmVlZiBvcCB6byAwNi0wMi0yMDIyIG9tIDE0OjAwIFsr
MDEwMF06DQo+PiArwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgIChpZiAoYW5kIGluZm8gKG5vdCAo
dmVjdG9yLWVtcHR5PyBpbmZvKSkpDQo+PiArwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKg
wqAgaW5mbw0KPj4gK8KgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgIChiZWdpbg0KPj4g
K8KgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoCAod2FybmluZyAoR18gInBhY2th
Z2Ugbm90IGZvdW5kIG9uIFJlcG9sb2d5OiB+YVxuIikNCj4+ICvCoMKgwqDCoMKgwqDCoMKgwqDC
oMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqAgKHBhY2thZ2UtbmFtZSBwYWNrYWdl
KSkNCj4+ICvCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqAgI2YpKSkpKSkpKQ0K
Pg0KPiBXaHkgYSB3YXJuaW5nIGhlcmU/ICBGb3Igb3RoZXIgcmVmcmVzaGVycywgd2UganVzdCBy
ZXR1cm4gJyNmJyBhbmQNCj4gZG9uJ3QgcHJpbnQgYSB3YXJuaW5nLg0KDQpXZWxsLCBzb21lIGFj
dHVhbGx5IGRvIHByaW50IGEgd2FybmluZywgZS5nLiwgb3BhbS4gIFRoZSB3YXJuaW5nIG1ha2Vz
DQppdCBjbGVhciB0aGF0IGEgcGFja2FnZSB3YXNu4oCZdCBmb3VuZCB3aGVuIHJ1bm5pbmcg4oCY
Z3VpeCByZWZyZXNo4oCZDQood2l0aG91dCBhcmd1bWVudHMpLg0K

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQJJBAEBCAAzFiEEAVhh4yyK5+SEykIzrPUJmaL7XHkFAmH/6JsVHHB1YmxpY0B5
b2N0b2NlbGwueHl6AAoJEKz1CZmi+1x5KSYP/0qdKTGN1CRsDuh1lfE5U8biLIP6
tpmoqNuQEWKZ75HeUfBkOQofek5tGogutbJvuBcgGr/yiF5g8BPn80yJK3mdtj/S
CQHPQ3FrQHl5GmMY0oWTiFC27EGdu3MSeTgZ0+vPXTYVvTdLfmIuBvtdZM8caU9Y
W5NtJIFaEIEpiTRYUgGRnwv08s99XXMPpbYhrASiy83Rul4Mrn0aokM4u405vfg/
5xZUMaQ3OdkiWfQrIzNBaijWyKtliLHllPGjJtdsek5XGIhpzdpHgVj6RfbpcdBW
gc65KM+bA99eRPNdG7z1JeQQgL+5i/mJINMTiqEXCr2UrVBgQrD/AOJX8OonYrpd
YXvP2NWjj+R/S3vhXCqU4++cePnn5OhcMT3xbJUqlTDk4RfazASrHckGHupsoZ+p
w3GmRrJfc8r4RX2ugekaVrRpDaCrNw6S7gJ2GR08cnvG7OSqtzzbMxqa0XuO9BHc
9doQo5ya7pZskMxQvdVREQHkMVioPxZXvbUjzFFuT1KHSr+VpCURZgzD2z0HEhgF
W/3T5uN4Oqug9aFNlpGIIJhJkGdoNfr77JTJMeu9hapjOl2A2GKk14stpU8HZmYl
w+1EmO4v2Zm3i1L7cVoM4bHEajkIv1NKoWmZwRpEjNhWnxcnPAtH3M5JinHDF+Jo
IyMszfCElzVNcje5
=4hEf
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 6 Feb 2022 15:18:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 06 10:18:54 2022
Received: from localhost ([127.0.0.1]:39537 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nGjJW-0002a8-GE
	for submit <at> debbugs.gnu.org; Sun, 06 Feb 2022 10:18:54 -0500
Received: from h178-251-242-94.cust.a3fiber.se ([178.251.242.94]:34932
 helo=mail.yoctocell.xyz) by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <public@HIDDEN>) id 1nGjJU-0002Zt-Rr
 for 53818 <at> debbugs.gnu.org; Sun, 06 Feb 2022 10:18:53 -0500
From: Xinglu Chen <public@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yoctocell.xyz;
 s=mail; t=1644160727;
 bh=qagbcJd65kw5A5/i1RjS24GrYzkv7sQekp8WvuWLVxM=;
 h=From:To:Subject:In-Reply-To:References:Date;
 b=PnVx5JsA/wFJj8sW7jq/7F7zeOXe8pQKcg12Myte+Dl4h8hNZJ83wwNPInrD8Q6FM
 r0EQy8/1aPq36xcJAgZSZUAvAzz1m2+XOuRCXxnu+vXq1v9f3mjAzizGLM1dDcpPSh
 PxOBO0zUZRhqoytizbS2F/QuFupBs61mdLj33+Cg=
To: Maxime Devos <maximedevos@HIDDEN>, 53818 <at> debbugs.gnu.org
Subject: Re: [bug#53818] [PATCH 2/3] import: Add 'repology' updater.
In-Reply-To: <128afdc0bdf163f025cdfaa2876ae7cdea0b5d86.camel@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
 <88f866aff65c0ec9611b6cc0ee9d680ba711df38.1644147246.git.public@HIDDEN>
 <128afdc0bdf163f025cdfaa2876ae7cdea0b5d86.camel@HIDDEN>
Date: Sun, 06 Feb 2022 16:18:46 +0100
Message-ID: <875yps2fc9.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Maxime schrieb am Sonntag der 06. Februar 2022 um 14:11 +01:
    > Xinglu Chen schreef op zo 06-02-2022 om 14:00 [+0100]: >> +(define* (package-name->repology-name
    name #:key (attempt 1)) >> +  "Convert NAME, the name of a Guix package,
    to the name of the package [...] 
 
 Content analysis details:   (2.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Maxime schrieb am Sonntag der 06. Februar 2022 um 14:11 +01:
    > Xinglu Chen schreef op zo 06-02-2022 om 14:00 [+0100]: >> +(define* (package-name->repology-name
    name #:key (attempt 1)) >> +  "Convert NAME, the name of a Guix package,
    to the name of the package [...] 
 
 Content analysis details:   (2.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  1.0 BULK_RE_SUSP_NTLD      Precedence bulk and RE: from a suspicious TLD
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

Maxime schrieb am Sonntag der 06. Februar 2022 um 14:11 +01:

> Xinglu Chen schreef op zo 06-02-2022 om 14:00 [+0100]:
>> +(define* (package-name->repology-name name #:key (attempt 1))
>> +=C2=A0 "Convert NAME, the name of a Guix package, to the name of the pa=
ckage on
>> +Repology.=C2=A0 It doesn't always guess the correct name on the first a=
ttempt, so
>> +on the second attempt it will try to guess another name."
>> +=C2=A0 (match attempt
>> +=C2=A0=C2=A0=C2=A0 (1 (cond
>
> Could you add 'minetest' to the list?  Sometimes they are named
> 'minetest-mod-foo' (Debian), sometimes 'minetest-foo' (Guix,
> Archlinux).

Sure!

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQJJBAEBCAAzFiEEAVhh4yyK5+SEykIzrPUJmaL7XHkFAmH/5tYVHHB1YmxpY0B5
b2N0b2NlbGwueHl6AAoJEKz1CZmi+1x50PcP/1R8UjjiV2xVRrjWU4NlegNQGfVS
WoIINHlwVecl35vlXmz7gZUi1l3MBNDzbyRr6xC/2KaDGkIBuW1FTLdNmPjI0epi
Uv79cztS9Ls78FiNfWykRAKDpz9snRZ+2qng6LGz+toKTasRrvyS4UJk82E0UPWT
zuSTZT5V5PvNboLaSHPJzXJkbpRVMES3krOcuuH9fNN8ZDJxXu+IfWCnjSnrV+S0
IPTuTc8FOJUx3iuLz6u+exBHMGrZ1ldZPfdy874BhJ2PKR0BN0o3cNJS49whnsH7
RCjJMGHKI1nzdTxVabVUCNPZYtHC1ben/56xXrk+n686bx76RdrgDV5gL+DnDNDl
E5oleHMuJLKtVWXQtTbhDv36LF4m7Pyzpdmm2voM3LYZ6S0v8/+dMTljKwaxZ9uv
1E1a+/MQ2Oc34gTszZWogjPK42+tUmwbSRzzO/4G+/OyiKrdy4ONVAm3yIyc40L7
g2Duf9vbq8q++rR5HohdW5jH/Umy1ll7qFENypRxd7+SVUGZHPha9xssFZuR1Dbj
k4rueH+qMaSrED8dEA2pfEGL+T6cRAyT0C7+wxRMyD1AQ0raxtiR8zM9K5SaAuMg
fNaODFfv3mrlt5BtnwuLkE4JZ8+kRFLF8D07P2SsYQ6u7Ndik/aW2WfJZccdOg3Z
XkuiLWlyJTXfN2bX
=Pk0i
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 6 Feb 2022 15:18:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 06 10:18:03 2022
Received: from localhost ([127.0.0.1]:39534 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nGjIh-0002Z3-6f
	for submit <at> debbugs.gnu.org; Sun, 06 Feb 2022 10:18:03 -0500
Received: from h178-251-242-94.cust.a3fiber.se ([178.251.242.94]:34904
 helo=mail.yoctocell.xyz) by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <public@HIDDEN>) id 1nGjIf-0002YR-Eo
 for 53818 <at> debbugs.gnu.org; Sun, 06 Feb 2022 10:18:02 -0500
From: Xinglu Chen <public@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yoctocell.xyz;
 s=mail; t=1644160673;
 bh=G6KSKS6HPjFwVRqKb+Eo8M1Gmol4R8HVGJTQdIUgoBU=;
 h=From:To:Subject:In-Reply-To:References:Date;
 b=hrcCncpJFKqD1M8Wy5r0piL5LNEcHZcQQNCGL9030t/xwheNCOHVgKQfrap/Y9sUK
 d1v9iIHmo/pvp2psK6YTPhPUGDwzTUTSDQU/mxMKWC1igWV96TNPr8hbVl6cALBZhn
 WJPMHZLw5gySwUetP3NAsI5vwriQhO1vEedNKOl4=
To: Maxime Devos <maximedevos@HIDDEN>, 53818 <at> debbugs.gnu.org
Subject: Re: [bug#53818] [PATCH 0/3] Add Repology updater
In-Reply-To: <2ba4a342b6c2b53f7038a84c8337608e51ecf13a.camel@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
 <2ba4a342b6c2b53f7038a84c8337608e51ecf13a.camel@HIDDEN>
Date: Sun, 06 Feb 2022 16:17:38 +0100
Message-ID: <878ruo2fe5.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Maxime schrieb am Sonntag der 06. Februar 2022 um 13:41 +01:
    > Xinglu Chen schreef op zo 06-02-2022 om 12:50 [+0100]: >> Because of the
    way ‘%updaters’ in (guix upstream) works, the Repology >> updater is
   the first or second updater that is used (since it > [...] 
 
 Content analysis details:   (2.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Maxime schrieb am Sonntag der 06. Februar 2022 um 13:41 +01:
    > Xinglu Chen schreef op zo 06-02-2022 om 12:50 [+0100]: >> Because of the
    way ‘%updaters’ in (guix upstream) works, the Repology >> updater is
   the first or second updater that is used (since it > [...] 
 
 Content analysis details:   (2.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  1.0 BULK_RE_SUSP_NTLD      Precedence bulk and RE: from a suspicious TLD
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

Maxime schrieb am Sonntag der 06. Februar 2022 um 13:41 +01:

> Xinglu Chen schreef op zo 06-02-2022 om 12:50 [+0100]:
>> Because of the way =E2=80=98%updaters=E2=80=99 in (guix upstream) works,=
 the Repology
>> updater is the first or second updater that is used (since it
>> technically works on ever package), but because of the limitations I
>> mentioned above, the result might not always be the best.  The Repology
>> updater is mostly useful for things that don=E2=80=99t already have an u=
pdater,
>> e.g., =E2=80=98maven-dependency-tree=E2=80=99.  Would it make sense to h=
ard-code the
>> =E2=80=98%updaters=E2=80=99 variable and put the Repology last in the li=
st?
>
> I would prefer not to hardcode %updaters and keep the current
> discovery mechanism, such that people can experiment with updaters
> outside a git checkout of guix and in channels.

Good point.

> FWIW it would be useful to have the same mechanism for importers.
>
> However, it might be a good idea to do some _postprocessing_ on
> the discovered list of updaters, e.g. they could be sorted on
> 'genericity' with 'stable-sort' (*):
>
> (define (genericity x)
>   (cond ((it is "generic-SOMETHING") 1)
>         ((it is repology) 2)
>         (#true 0)))
>
> (define (less x y)
>   (<=3D (genericity x) (genericity y)))
>
> (*) stable-sort and not sort, to preserve alphabetical ordering
> for updaters with the same genericity.

That looks like a good idea

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQJJBAEBCAAzFiEEAVhh4yyK5+SEykIzrPUJmaL7XHkFAmH/5pIVHHB1YmxpY0B5
b2N0b2NlbGwueHl6AAoJEKz1CZmi+1x5zoEP/iTocn9Z57276DXaWFmwwa7uHczT
L+SQbXM9hB0UHR1k2R+1/UOeZcxJMiVAxTcq63tigRpmdzf105Osl0qK+vyASox0
RTDS07T6tmunXNGyosIOXRbftpVhSLZPzFWGb2km1ZT0sawKHmGUjFcAl77cBtW4
PNsclQEm2iBanYx/bC8ElgiW0so6nRzQ4mqERsM1x73XgJqgAUWYN6URk/aW5XVE
/Zeq/hsDAsZRLyDnBhZc1V8w8xX302C4oNlakJb0/BCtHW0fAG5/c3q8Ss54Wbgu
som4LqLgxnC9qD4EM+Xe4PIzsIYG4tJu+35+bnfEpBDbIV1a67D49JxBsOk42/Dy
fib2vcku2ggTbnYCQyJqPEiVfhtWb2PcWQwYVwixylJANoMyE/cUa+MgE1I0rZsZ
O+7aGBZZefmNaDfGw6i2FF+8QpbRoEOBusxGVcZALqT1cSH0SJvWGxKc2cjkymXV
ggExtdjlevgiQllXvv/M10kweOmQD8aAtKenWT8ccfJdxG9PulrZO+u/h53kW/ER
PJmjfVNZH52qr84qxeB+1mL9L41cZGGd3ezJ4Z+qlHdXplZ90R7O2fXvnOmoR9Mb
1tqfdOLlwgEr3Tk3r/OnC2slEqrgtG6JoMhaSROxAZjdcvSXDDldNk7gTBetEM17
SwCZ8ayY1vbTR/f6
=vIQq
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 6 Feb 2022 14:16:01 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 06 09:16:01 2022
Received: from localhost ([127.0.0.1]:36832 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nGiKf-0000Jk-5d
	for submit <at> debbugs.gnu.org; Sun, 06 Feb 2022 09:16:01 -0500
Received: from andre.telenet-ops.be ([195.130.132.53]:59824)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <maximedevos@HIDDEN>) id 1nGiKc-0000JZ-Bs
 for 53818 <at> debbugs.gnu.org; Sun, 06 Feb 2022 09:15:59 -0500
Received: from [172.20.10.5] ([188.188.251.13])
 by andre.telenet-ops.be with bizsmtp
 id rqFv2600c0J677g01qFw7t; Sun, 06 Feb 2022 15:15:56 +0100
Message-ID: <a83cf38d9cec226310e630c48704e7094eaaedac.camel@HIDDEN>
Subject: Re: [bug#53818] [PATCH 3/3] gnu: xorg-server-xwayland: Set
 'repology-name' property.
From: Maxime Devos <maximedevos@HIDDEN>
To: Xinglu Chen <public@HIDDEN>, 53818 <at> debbugs.gnu.org
Date: Sun, 06 Feb 2022 15:15:51 +0100
In-Reply-To: <c648a7af35de04f863e4ffed1b935b2f486ec869.1644147246.git.public@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
 <c648a7af35de04f863e4ffed1b935b2f486ec869.1644147246.git.public@HIDDEN>
Content-Type: multipart/signed; micalg="pgp-sha512";
 protocol="application/pgp-signature"; boundary="=-NVx1D9ItfHKjx/zzA797"
User-Agent: Evolution 3.38.3-1 
MIME-Version: 1.0
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=telenet.be; s=r22;
 t=1644156956; bh=jbtVxZgCbbxUj6v3h+KAVCkrul/gSGohioZGmzfwgbk=;
 h=Subject:From:To:Date:In-Reply-To:References;
 b=mqgYFwhsoK6OFiPHfdpAQkWfvvhdA+C1ID+WhTnGgS0ch2TXdO2RYYUyTChE9z+EO
 TQsPYBqbOhX7/BGM8Fmve7RlG2DCc4a/aNlsXI7qGvAwyLuVE+PWqa6ZakOm4hKjgr
 avyIzdqMlkBelr55w58zu1nK9qmWPJ/S4ZurE2z362euoNv8HS0ckLfMO1tTq19JOJ
 2EMN/q9LWbqBHm8ibuLnX388CvF2DdoLTs57Jw/NKFddegOQ4QO4RwNcpSdrSTlYT5
 Hpw8jafSQFsypkW1HYuDo95+1iscNrAaQKsNdDeE3dnkMZkjEYcSJIEPvZuKasN6Jq
 9uDrVogZU8SwA==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)


--=-NVx1D9ItfHKjx/zzA797
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: base64

WGluZ2x1IENoZW4gc2NocmVlZiBvcCB6byAwNi0wMi0yMDIyIG9tIDE0OjAwIFsrMDEwMF06Cj4g
wqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoCAobGFtYmRhIF8KPiDCoMKg
wqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoCAoc3Vic3RpdHV0ZSogKGZp
bmQtZmlsZXMgIi4iICJcXC5jJCIpCj4gwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDC
oMKgwqDCoMKgwqDCoMKgICgoIi9iaW4vc2giKSAod2hpY2ggInNoIikpKSkpKSkpCgpGV0lXIHRo
aXMgaXMgd3Jvbmcgd2hlbiBjcm9zcy1jb21waWxpbmcsCnRoaXMgbmVlZHMgdG8gdXNlIChzZWFy
Y2gtaW5wdXQtZmlsZSBpbnB1dHMgImJpbi9zaCIpIGluc3RlYWQKc3VjaCB0aGF0IGEgKGNyb3Nz
LWNvbXBpbGVkKSBzaGVsbCBmcm9tICdpbnB1dHMnIGlzIHVzZWQgaW5zdGVhZCBvZiBhCihuYXRp
dmUpIGJhc2ggZnJvbSAnbmF0aXZlLWlucHV0cycuCgpUaGF0J3MgYSBidWcgaW4gdGhlIG9sZCBw
YWNrYWdlIGRlZmluaXRpb24gdGhvdWdoLgoKR3JlZXRpbmdzLApNYXhpbWUuCg==


--=-NVx1D9ItfHKjx/zzA797
Content-Type: application/pgp-signature; name="signature.asc"
Content-Description: This is a digitally signed message part
Content-Transfer-Encoding: 7bit

-----BEGIN PGP SIGNATURE-----

iI0EABYKADUWIQTB8z7iDFKP233XAR9J4+4iGRcl7gUCYf/YFxccbWF4aW1lZGV2
b3NAdGVsZW5ldC5iZQAKCRBJ4+4iGRcl7j6lAP911CsZ9LKrL3aa3BzQVAairgwJ
Q2ogrsFbQUmXYuKfoAD/QCZTOYgEYqooh4ZuHECkHF+sNRqxXeZJZ+ePPBqRdw0=
=eSwI
-----END PGP SIGNATURE-----

--=-NVx1D9ItfHKjx/zzA797--





Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 6 Feb 2022 13:23:59 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 06 08:23:59 2022
Received: from localhost ([127.0.0.1]:36803 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nGhWI-0007Rs-ST
	for submit <at> debbugs.gnu.org; Sun, 06 Feb 2022 08:23:59 -0500
Received: from andre.telenet-ops.be ([195.130.132.53]:54046)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <maximedevos@HIDDEN>) id 1nGhWH-0007Rl-Re
 for 53818 <at> debbugs.gnu.org; Sun, 06 Feb 2022 08:23:58 -0500
Received: from [172.20.10.5] ([188.188.251.13])
 by andre.telenet-ops.be with bizsmtp
 id rpPw260030J677g01pPwEa; Sun, 06 Feb 2022 14:23:57 +0100
Message-ID: <e5eca0fb66221519769e9b10f1376260872a825e.camel@HIDDEN>
Subject: Re: [bug#53818] [PATCH 2/3] import: Add 'repology' updater.
From: Maxime Devos <maximedevos@HIDDEN>
To: Xinglu Chen <public@HIDDEN>, 53818 <at> debbugs.gnu.org
Date: Sun, 06 Feb 2022 14:23:55 +0100
In-Reply-To: <88f866aff65c0ec9611b6cc0ee9d680ba711df38.1644147246.git.public@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
 <88f866aff65c0ec9611b6cc0ee9d680ba711df38.1644147246.git.public@HIDDEN>
Content-Type: multipart/signed; micalg="pgp-sha512";
 protocol="application/pgp-signature"; boundary="=-XVZ7qpwFaBJVVPeT3Gdv"
User-Agent: Evolution 3.38.3-1 
MIME-Version: 1.0
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=telenet.be; s=r22;
 t=1644153837; bh=HRu+pwopyeYseni3eM+X7MHRl8XC1s/aD1OIxBQntyg=;
 h=Subject:From:To:Date:In-Reply-To:References;
 b=GZ5EAbC0rsjqxKPAHOYtnu4JnB69kNRxLnQ9nv1zTqvyPJ02MZ+3P55rROprfQwDo
 N3/T7mj16sja97FkJzjhm2/8vMtDwu06PBozf+CVKyYgRnMdm9wGkSCRVG4rWIGdLv
 34D6O4vo3CMg2Z5E0F2+GAMd8UT7Q0I4tmB7jh8j4HOoGFdGSFotf/JyapzSSVlAiH
 qyY+wrrircCiHpr9SLwtGo3g0b5B1SGI9/SW3sqApb3/mc+lKc0pChx0boqCrOYiyt
 4Uolp7Mv/Z0yfM6yqN2S78RU8pEo5cvF5oXtmXM6vDXffqLyDZOCpZZlRgMvQyOKZ+
 0ezw71TNyzIdQ==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)


--=-XVZ7qpwFaBJVVPeT3Gdv
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable

Xinglu Chen schreef op zo 06-02-2022 om 14:00 [+0100]:
> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=
 (latest-version (if (null? versions)

Perhaps (and (pair? versions) (car versions)), YMMV.

Greetings,
Maxime.

--=-XVZ7qpwFaBJVVPeT3Gdv
Content-Type: application/pgp-signature; name="signature.asc"
Content-Description: This is a digitally signed message part
Content-Transfer-Encoding: 7bit

-----BEGIN PGP SIGNATURE-----

iI0EABYKADUWIQTB8z7iDFKP233XAR9J4+4iGRcl7gUCYf/L6xccbWF4aW1lZGV2
b3NAdGVsZW5ldC5iZQAKCRBJ4+4iGRcl7kxDAQC3H6dqqIh9CiF9jN6vB5eWj+7c
ueBEUCfEXC+7SbAMcgD6Arw5MpfPxv0HkLcv/fxHgGgEyJiPYjW5WzSSPaWj0Qs=
=+415
-----END PGP SIGNATURE-----

--=-XVZ7qpwFaBJVVPeT3Gdv--





Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 6 Feb 2022 13:23:05 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 06 08:23:05 2022
Received: from localhost ([127.0.0.1]:36799 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nGhVR-0007Qh-Ju
	for submit <at> debbugs.gnu.org; Sun, 06 Feb 2022 08:23:05 -0500
Received: from xavier.telenet-ops.be ([195.130.132.52]:59760)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <maximedevos@HIDDEN>) id 1nGhVQ-0007Qa-HA
 for 53818 <at> debbugs.gnu.org; Sun, 06 Feb 2022 08:23:04 -0500
Received: from [172.20.10.5] ([188.188.251.13])
 by xavier.telenet-ops.be with bizsmtp
 id rpP3260010J677g01pP3QR; Sun, 06 Feb 2022 14:23:03 +0100
Message-ID: <d23e9b226fb9de027f2dae3b7ba4e72254f72998.camel@HIDDEN>
Subject: Re: [bug#53818] [PATCH 2/3] import: Add 'repology' updater.
From: Maxime Devos <maximedevos@HIDDEN>
To: Xinglu Chen <public@HIDDEN>, 53818 <at> debbugs.gnu.org
Date: Sun, 06 Feb 2022 14:23:02 +0100
In-Reply-To: <88f866aff65c0ec9611b6cc0ee9d680ba711df38.1644147246.git.public@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
 <88f866aff65c0ec9611b6cc0ee9d680ba711df38.1644147246.git.public@HIDDEN>
Content-Type: multipart/signed; micalg="pgp-sha512";
 protocol="application/pgp-signature"; boundary="=-LwLxvPCddHM9kkTGojsZ"
User-Agent: Evolution 3.38.3-1 
MIME-Version: 1.0
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=telenet.be; s=r22;
 t=1644153783; bh=0wT8KeC8NFgbuHeP6pow73cGoFS4XbP/q40MZzmyMMg=;
 h=Subject:From:To:Date:In-Reply-To:References;
 b=WBVj96bQ+OvA3P01kpcr0N0dXB1MtyHYyHb9ashUzQqvuTmisAOQv7E0+1Bxxyqix
 WfgV8vqO6pFlodCgDOcmiU7BAevGGE+ubTCKItzxjnm7kwafJI6CXON5DiUQWTGdDV
 No4mgT+WlC36NsIr8ehbsCz9PY+jd3tNl3cf0YTx5lOxdXLA/YTB5E9vHYBoTfcjeG
 RcDjZq87l1opZGSV/tvuD8cDWPQPgxKmabDyBZHpx8ZOqfhBb3onFeDzwh4hHesrc6
 aZYKSBtXDtkcfxiXO783CAuK7sAPzb2l/9i57we36UHB6cUN0xB/DXx+1Onja3jwFC
 f1Tp4HidktysA==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)


--=-LwLxvPCddHM9kkTGojsZ
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable

Xinglu Chen schreef op zo 06-02-2022 om 14:00 [+0100]:
> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (and=3D> (json-fetch ur=
l)

Given that we'll be contacting 'repology' for _every_ package
when doing "guix refresh -l", some caching seems in order.
Could 'http-fetch/cached' be used here?  json-fetch may
need to be modified to allow overriding the http-fetch procedure
used.

FWIW this could be useful for some other updaters (e.g. the
Minetest/ContentDB updater), to a lesser degree.

Greetings,
Maxime.

--=-LwLxvPCddHM9kkTGojsZ
Content-Type: application/pgp-signature; name="signature.asc"
Content-Description: This is a digitally signed message part
Content-Transfer-Encoding: 7bit

-----BEGIN PGP SIGNATURE-----

iI0EABYKADUWIQTB8z7iDFKP233XAR9J4+4iGRcl7gUCYf/LthccbWF4aW1lZGV2
b3NAdGVsZW5ldC5iZQAKCRBJ4+4iGRcl7tv6AQC4gGDjZ9WlWzsCljnPTXWLpzZG
Sj55w0l5G64qxJU7EQD+J/6N8jvtHLoIVN4zhjjnslERQHhR82tFJroVb32yvwQ=
=LCp2
-----END PGP SIGNATURE-----

--=-LwLxvPCddHM9kkTGojsZ--





Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 6 Feb 2022 13:19:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 06 08:19:48 2022
Received: from localhost ([127.0.0.1]:36782 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nGhSG-0007KN-5u
	for submit <at> debbugs.gnu.org; Sun, 06 Feb 2022 08:19:48 -0500
Received: from andre.telenet-ops.be ([195.130.132.53]:49366)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <maximedevos@HIDDEN>) id 1nGhSE-0007K6-Oq
 for 53818 <at> debbugs.gnu.org; Sun, 06 Feb 2022 08:19:47 -0500
Received: from [172.20.10.5] ([188.188.251.13])
 by andre.telenet-ops.be with bizsmtp
 id rpKl2600L0J677g01pKlcH; Sun, 06 Feb 2022 14:19:46 +0100
Message-ID: <232779a14d33f69de0665500099f9968fe6d0ca1.camel@HIDDEN>
Subject: Re: [bug#53818] [PATCH 2/3] import: Add 'repology' updater.
From: Maxime Devos <maximedevos@HIDDEN>
To: Xinglu Chen <public@HIDDEN>, 53818 <at> debbugs.gnu.org
Date: Sun, 06 Feb 2022 14:19:45 +0100
In-Reply-To: <88f866aff65c0ec9611b6cc0ee9d680ba711df38.1644147246.git.public@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
 <88f866aff65c0ec9611b6cc0ee9d680ba711df38.1644147246.git.public@HIDDEN>
Content-Type: multipart/signed; micalg="pgp-sha512";
 protocol="application/pgp-signature"; boundary="=-4XF0YbLbGHHrhpGk7T/f"
User-Agent: Evolution 3.38.3-1 
MIME-Version: 1.0
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=telenet.be; s=r22;
 t=1644153586; bh=wB759+6eFXr7rwUlyIEWFbK3w/56SCOrx5lITkI1ZrY=;
 h=Subject:From:To:Date:In-Reply-To:References;
 b=lF2DYpJE34f2/HKZ7dP8RaqiRZSk4WJXBQ62T/EIIhlEMEry+gb8UEP2oS5r2qQJ3
 0JKhoTMpb3TRpapiSrUNa1wzrlVuZDaxOYK12UAcObZ49GkQss2+WYieFahx34rLOO
 b0LF37m+a3w/bs2k7flBHD3p6IfG93QPS+UixW4s1/PiZU0cZzyoOlF3eURcKnbALU
 7zFyvDnXpPg6Gj0Wzs/eHXUr9vDGqsQmbzjziZUZJQXJEH6aYj8eUhYCmpKj2aYWnj
 UotooPNcsYxyTBM4JFEfHyppdBJ6GKGSuCF9hgyKQ2uF3A7nw0XsQm3E4Ea02PVlCN
 muNq2eoUo80Fw==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)


--=-4XF0YbLbGHHrhpGk7T/f
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable

Xinglu Chen schreef op zo 06-02-2022 om 14:00 [+0100]:
> +(test-equal "package using Git repo: git-reference"
> +=C2=A0 (list (git-reference
> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (url "https://git.examp=
le.org/foo")
> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (commit "2.0")))

Drop 'list', (guix upstream) doesn't expect a list here.

Greetings,
Maxime

--=-4XF0YbLbGHHrhpGk7T/f
Content-Type: application/pgp-signature; name="signature.asc"
Content-Description: This is a digitally signed message part
Content-Transfer-Encoding: 7bit

-----BEGIN PGP SIGNATURE-----

iI0EABYKADUWIQTB8z7iDFKP233XAR9J4+4iGRcl7gUCYf/K8RccbWF4aW1lZGV2
b3NAdGVsZW5ldC5iZQAKCRBJ4+4iGRcl7mTWAQCQuKqErajwXrLQSTyhqeU6Iwgl
eeTFpC4jkSkCo6UiYwD/YfIUskfiROHeqVt/3FiqAuQKXuqmnQUgwLpRF1xMCwI=
=z0mH
-----END PGP SIGNATURE-----

--=-4XF0YbLbGHHrhpGk7T/f--





Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 6 Feb 2022 13:18:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 06 08:18:55 2022
Received: from localhost ([127.0.0.1]:36775 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nGhRO-0007Ih-Tl
	for submit <at> debbugs.gnu.org; Sun, 06 Feb 2022 08:18:55 -0500
Received: from xavier.telenet-ops.be ([195.130.132.52]:55402)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <maximedevos@HIDDEN>) id 1nGhRN-0007IZ-Bd
 for 53818 <at> debbugs.gnu.org; Sun, 06 Feb 2022 08:18:53 -0500
Received: from [172.20.10.5] ([188.188.251.13])
 by xavier.telenet-ops.be with bizsmtp
 id rpJs260050J677g01pJsqv; Sun, 06 Feb 2022 14:18:52 +0100
Message-ID: <dfef21301f4f514357c96d09e1c22adecac09d60.camel@HIDDEN>
Subject: Re: [bug#53818] [PATCH 2/3] import: Add 'repology' updater.
From: Maxime Devos <maximedevos@HIDDEN>
To: Xinglu Chen <public@HIDDEN>, 53818 <at> debbugs.gnu.org
Date: Sun, 06 Feb 2022 14:18:51 +0100
In-Reply-To: <88f866aff65c0ec9611b6cc0ee9d680ba711df38.1644147246.git.public@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
 <88f866aff65c0ec9611b6cc0ee9d680ba711df38.1644147246.git.public@HIDDEN>
Content-Type: multipart/signed; micalg="pgp-sha512";
 protocol="application/pgp-signature"; boundary="=-l5YXggqKysSGdzwdsrYj"
User-Agent: Evolution 3.38.3-1 
MIME-Version: 1.0
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=telenet.be; s=r22;
 t=1644153532; bh=E7jszfTGrQLH54BzTFSoKWPcV/3hIqRkJy/1DJtAU6A=;
 h=Subject:From:To:Date:In-Reply-To:References;
 b=Ef50jKGkJzt2L/qq1I7DZAyaLgRaVUQi/wLilHUjwwNx3ApPLRYoRDCGwwlB42pzG
 XQ8yKY7bgZ8NaALO/yjAcUBaq8wXp14Qe6h0A8Ie+H/mXmRHsQgo/28u9WMvXmsUJF
 5WfQinEPNRF+tUqdmb3ND1HtQ9pKNX1Q+Plp1+lj2b/3caobl9kj6GUyI2VK14cFhU
 FqOJJn3kucmHclBtQ5/6E3fRI/mxIDsuOSNpyqdsZwAnDK8u+Bt0WkHnmjXhbu+G7G
 eE8e94Uojjmom0El8q42HMfcpGTlooAvlzNWbj7I5tHGyYG68Px/bFFrswzLYqTHr2
 lZVT11z16xASQ==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)


--=-l5YXggqKysSGdzwdsrYj
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable

Xinglu Chen schreef op zo 06-02-2022 om 14:00 [+0100]:
> +(define (stable-version? repology-package)
> +=C2=A0 (and (or (equal? "newest" (repology-package-status repology-packa=
ge))
> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (equal? "un=
ique" (repology-package-status repology-package)))
> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (repology-package-version repology-=
package)))

What does 'stable' mean here?  We usually just use the latest version
of a package, unlike, say, Debian stable.

Greetings,
Maxime.

--=-l5YXggqKysSGdzwdsrYj
Content-Type: application/pgp-signature; name="signature.asc"
Content-Description: This is a digitally signed message part
Content-Transfer-Encoding: 7bit

-----BEGIN PGP SIGNATURE-----

iI0EABYKADUWIQTB8z7iDFKP233XAR9J4+4iGRcl7gUCYf/KuxccbWF4aW1lZGV2
b3NAdGVsZW5ldC5iZQAKCRBJ4+4iGRcl7lezAQDYAW0azBB2X1MyLpTZ97awncNE
U0f0sJwVp2Fs64c0rwEAwVCUtjb09dAaRGbomN+/Jb3W37RoobCZhVjdE7dY8Ag=
=MM7o
-----END PGP SIGNATURE-----

--=-l5YXggqKysSGdzwdsrYj--





Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 6 Feb 2022 13:17:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 06 08:17:52 2022
Received: from localhost ([127.0.0.1]:36770 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nGhQO-0007Gx-Kk
	for submit <at> debbugs.gnu.org; Sun, 06 Feb 2022 08:17:52 -0500
Received: from xavier.telenet-ops.be ([195.130.132.52]:54150)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <maximedevos@HIDDEN>) id 1nGhQN-0007Gq-8O
 for 53818 <at> debbugs.gnu.org; Sun, 06 Feb 2022 08:17:51 -0500
Received: from [172.20.10.5] ([188.188.251.13])
 by xavier.telenet-ops.be with bizsmtp
 id rpHp2600E0J677g01pHqg6; Sun, 06 Feb 2022 14:17:50 +0100
Message-ID: <97d4bfcc95de2a5bf5143dc7b178c270c0c8afde.camel@HIDDEN>
Subject: Re: [bug#53818] [PATCH 2/3] import: Add 'repology' updater.
From: Maxime Devos <maximedevos@HIDDEN>
To: Xinglu Chen <public@HIDDEN>, 53818 <at> debbugs.gnu.org
Date: Sun, 06 Feb 2022 14:17:49 +0100
In-Reply-To: <88f866aff65c0ec9611b6cc0ee9d680ba711df38.1644147246.git.public@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
 <88f866aff65c0ec9611b6cc0ee9d680ba711df38.1644147246.git.public@HIDDEN>
Content-Type: multipart/signed; micalg="pgp-sha512";
 protocol="application/pgp-signature"; boundary="=-DmRvG4Of3dI83qWxKcSR"
User-Agent: Evolution 3.38.3-1 
MIME-Version: 1.0
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=telenet.be; s=r22;
 t=1644153470; bh=1nvNsDI1kGqZk4W/J/v0+3mikKeSWBhOXGD3LK1GWZI=;
 h=Subject:From:To:Date:In-Reply-To:References;
 b=noW1iPiBk3QjAEkpSnJogOp5wZ/3y0XhyJkkJnGdbgGzYY9JkjZ+Yw9qz2Kgm0bn1
 5YRRp2+VsG+CxAfs/WEg4xMKIY5mDNBs/39NRcb7ukV/YpYNof0rLzWWWn1jdGYlLm
 R+8dpVJ2pGsJLDfcZUi6CjvNk+Di0Fm6AdrHY46WstLmtK2FXoXgWvErwybH3cYdjH
 N1KFwv35zolncA7qALD4QCmXL/dSGnZnCVWw5WwHhcfKaskRsLsEus0xOLyDfRgkd1
 x9gttgEMGYQTYmQsLGwX0Tpw+6C9OmK/pChVpZ13VLnqsBKqROlM+rGUqO3qbvR09b
 NFBpl16Zj4jIw==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)


--=-DmRvG4Of3dI83qWxKcSR
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: base64

WGluZ2x1IENoZW4gc2NocmVlZiBvcCB6byAwNi0wMi0yMDIyIG9tIDE0OjAwIFsrMDEwMF06Cj4g
K8KgwqDCoMKgwqAgKCgkIDxnaXQtcmVmZXJlbmNlPiB1cmwgY29tbWl0IHJlY3Vyc2l2ZT8pCj4g
K8KgwqDCoMKgwqDCoCAoYW5kLWxldCogKCh1cGRhdGVkLWNvbW1pdCAoaWYgKHN0cmluZz0/IG9s
ZC12ZXJzaW9uIGNvbW1pdCkKPiArwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKg
wqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqAgdmVyc2lvbgo+ICvCoMKgwqDC
oMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKg
wqDCoMKgwqDCoCAodXBkYXRlLXVybCBjb21taXQgb2xkLXZlcnNpb24gdmVyc2lvbikpKSkKCldo
ZW4gZG9lcyB0aGUgVVJMIG9mIGEgZ2l0LXJlZmVyZW5jZSBpbmNsdWRlIGEgdmVyc2lvbj8KCj4g
K8KgwqDCoMKgwqDCoMKgwqAgKGxpc3QgKGdpdC1yZWZlcmVuY2UKPiArwqDCoMKgwqDCoMKgwqDC
oMKgwqDCoMKgwqDCoMKgICh1cmwgdXJsKQo+ICvCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKg
wqAgKGNvbW1pdCB1cGRhdGVkLWNvbW1pdCkKPiArwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDC
oMKgIChyZWN1cnNpdmU/IHJlY3Vyc2l2ZT8pKSkpKQoKKGd1aXggdXBzdHJlYW0pIGV4cGVjdHMg
YSBzaW5nbGUgZ2l0LXJlZmVyZW5jZSwgbm90IGEgbGlzdCBvZiBnaXQtCnJlZmVyZW5jZXMuCgpB
bHNvLCBkZXBlbmRpbmcgb24gdGhlIG9yZGVyIG9mIGZpZWxkcyBoZXJlIGRvZXNuJ3Qgc2VlbSBn
cmVhdCwgSScgZG8Kc29tZXRoaW5nIGxpa2UKCigoPyBnaXQtcmVmZXJlbmNlPyByZWZlcmVuY2Up
CiAoZ2l0LXJlZmVyZW5jZQogICAgKGluaGVyaXQgcmVmZXJlbmNlKQogICAgKGNvbW1pdCB1cGRh
dGVkLWNvbW1pdCkpKQoKaW5zdGVhZC4KCkdyZWV0aW5ncywKTWF4aW1lLgo=


--=-DmRvG4Of3dI83qWxKcSR
Content-Type: application/pgp-signature; name="signature.asc"
Content-Description: This is a digitally signed message part
Content-Transfer-Encoding: 7bit

-----BEGIN PGP SIGNATURE-----

iI0EABYKADUWIQTB8z7iDFKP233XAR9J4+4iGRcl7gUCYf/KfRccbWF4aW1lZGV2
b3NAdGVsZW5ldC5iZQAKCRBJ4+4iGRcl7pdhAQD24DXPEmzQP5Me8ECaQ3sXUH49
cq83mXM8qrpyJQq3fgD/WcaqSTdWk5r6W/16VmKJM2FWUQsVVpec2wC31692Jwg=
=8GI1
-----END PGP SIGNATURE-----

--=-DmRvG4Of3dI83qWxKcSR--





Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 6 Feb 2022 13:13:58 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 06 08:13:58 2022
Received: from localhost ([127.0.0.1]:36757 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nGhMc-0007AE-BZ
	for submit <at> debbugs.gnu.org; Sun, 06 Feb 2022 08:13:58 -0500
Received: from andre.telenet-ops.be ([195.130.132.53]:41804)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <maximedevos@HIDDEN>) id 1nGhMa-0007A1-FH
 for 53818 <at> debbugs.gnu.org; Sun, 06 Feb 2022 08:13:57 -0500
Received: from [172.20.10.5] ([188.188.251.13])
 by andre.telenet-ops.be with bizsmtp
 id rpDu2600Q0J677g01pDvL9; Sun, 06 Feb 2022 14:13:55 +0100
Message-ID: <5b98cea5ddb2ef9ba79a80003cbd79ec2f5c955c.camel@HIDDEN>
Subject: Re: [bug#53818] [PATCH 2/3] import: Add 'repology' updater.
From: Maxime Devos <maximedevos@HIDDEN>
To: Xinglu Chen <public@HIDDEN>, 53818 <at> debbugs.gnu.org
Date: Sun, 06 Feb 2022 14:13:54 +0100
In-Reply-To: <88f866aff65c0ec9611b6cc0ee9d680ba711df38.1644147246.git.public@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
 <88f866aff65c0ec9611b6cc0ee9d680ba711df38.1644147246.git.public@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
User-Agent: Evolution 3.38.3-1 
MIME-Version: 1.0
Content-Transfer-Encoding: 8bit
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=telenet.be; s=r22;
 t=1644153235; bh=heT5jQld2fRrE7/MNQ5mR8hdi2X1ytdyi9Z6ix7DpSc=;
 h=Subject:From:To:Date:In-Reply-To:References;
 b=eSLp1abMChCjooxp6hoOCcm9C1Q8s8pr/TE3GA/E0eFZ9PcoNZjB4/zKs38MUv5qt
 Rc5UCjuhbIVkomo0Pdh1aVlxPnnwPrV5MwtsHFPRPkOQC/jloITzJRR2pl8n5Bi8fy
 00AbI20Fj9SMvSSNaGfKXgTLTkaThMiWpfNAsxd1wMsLtdCdTAU27ZQ+tQMkk/UCtL
 2xNKW4QuFWQXud8MkwZWZ+kCOSWqHcNwQ5UNhp33q2/Hv4iTCHrEC53fLufBoBOad9
 AMsmCQvubSvhlPDzXMQXE0OfN4eMi17s8udhxj5CMsYFuqL1MRL881AnmhDaWbOkdT
 XjWoSPitNR3DQ==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Xinglu Chen schreef op zo 06-02-2022 om 14:00 [+0100]:
> +     (define (name->info name )

Superfluous space.





Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 6 Feb 2022 13:13:26 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 06 08:13:26 2022
Received: from localhost ([127.0.0.1]:36753 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nGhM6-00079Q-3g
	for submit <at> debbugs.gnu.org; Sun, 06 Feb 2022 08:13:26 -0500
Received: from baptiste.telenet-ops.be ([195.130.132.51]:50126)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <maximedevos@HIDDEN>) id 1nGhM5-00079G-9Q
 for 53818 <at> debbugs.gnu.org; Sun, 06 Feb 2022 08:13:25 -0500
Received: from [172.20.10.5] ([188.188.251.13])
 by baptiste.telenet-ops.be with bizsmtp
 id rpDP260020J677g01pDPUP; Sun, 06 Feb 2022 14:13:23 +0100
Message-ID: <af74ba55be34c098ec2289e2871592a5b5b6d5aa.camel@HIDDEN>
Subject: Re: [bug#53818] [PATCH 2/3] import: Add 'repology' updater.
From: Maxime Devos <maximedevos@HIDDEN>
To: Xinglu Chen <public@HIDDEN>, 53818 <at> debbugs.gnu.org
Date: Sun, 06 Feb 2022 14:13:22 +0100
In-Reply-To: <88f866aff65c0ec9611b6cc0ee9d680ba711df38.1644147246.git.public@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
 <88f866aff65c0ec9611b6cc0ee9d680ba711df38.1644147246.git.public@HIDDEN>
Content-Type: multipart/signed; micalg="pgp-sha512";
 protocol="application/pgp-signature"; boundary="=-DpjyG9csFlLWjMkDVmwR"
User-Agent: Evolution 3.38.3-1 
MIME-Version: 1.0
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=telenet.be; s=r22;
 t=1644153203; bh=NHKvvDnh0UnZGz/VbRBDIYPLfaaBIOvQBm9e6uzq81o=;
 h=Subject:From:To:Date:In-Reply-To:References;
 b=OZJM/RLA+kzT2dtHD4l2xnRCIdhQXLGEtDe1IR93gDbTAfWyxZXrMDasJxKRB2q3j
 t1yGzRTtnRTh+AZlOiUrV7cyQtJXS3pIIwZQfjqUXLRhZTlSJYluZFH8mEiF6mTazh
 r6f2OAewfZA99k8HJtppg6i5fWCNWjhcJuSu8+NKkshbCLhEuD2rrXuNel0RybYAy/
 glyC0gVc/f2Lq49HdWFAsIWVp+SPRLfKIKKiGts2X52fSppDLzzVPiTs9vMvpIXPWs
 fyDgOqMtaKSn3yz/J+sBsnvLqOOzPM25ycnfkBDg8MiKr8CnRHaZ3+TpZwJP+ARYj2
 7cGj1vkFlH6Rg==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)


--=-DpjyG9csFlLWjMkDVmwR
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: base64

WGluZ2x1IENoZW4gc2NocmVlZiBvcCB6byAwNi0wMi0yMDIyIG9tIDE0OjAwIFsrMDEwMF06Cj4g
K8KgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoCAoaWYgKGFuZCBpbmZvIChub3QgKHZlY3Rvci1lbXB0
eT8gaW5mbykpKQo+ICvCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoCBpbmZvCj4gK8Kg
wqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgIChiZWdpbgo+ICvCoMKgwqDCoMKgwqDCoMKg
wqDCoMKgwqDCoMKgwqDCoMKgwqAgKHdhcm5pbmcgKEdfICJwYWNrYWdlIG5vdCBmb3VuZCBvbiBS
ZXBvbG9neTogfmFcbiIpCj4gK8KgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKgwqDCoMKg
wqDCoMKgwqDCoMKgwqDCoCAocGFja2FnZS1uYW1lIHBhY2thZ2UpKQo+ICvCoMKgwqDCoMKgwqDC
oMKgwqDCoMKgwqDCoMKgwqDCoMKgwqAgI2YpKSkpKSkpKQoKV2h5IGEgd2FybmluZyBoZXJlPyAg
Rm9yIG90aGVyIHJlZnJlc2hlcnMsIHdlIGp1c3QgcmV0dXJuICcjZicgYW5kCmRvbid0IHByaW50
IGEgd2FybmluZy4KCkdyZWV0aW5ncywKTWF4aW1lLgo=


--=-DpjyG9csFlLWjMkDVmwR
Content-Type: application/pgp-signature; name="signature.asc"
Content-Description: This is a digitally signed message part
Content-Transfer-Encoding: 7bit

-----BEGIN PGP SIGNATURE-----

iI0EABYKADUWIQTB8z7iDFKP233XAR9J4+4iGRcl7gUCYf/JchccbWF4aW1lZGV2
b3NAdGVsZW5ldC5iZQAKCRBJ4+4iGRcl7pgvAP9MDm8gzYpmus13b5o5OWkQBahG
3zLOsWwrXGh2+DYgawD/dwQ7eppXIF+gdxhSyDb1mc5n60V+e6itzveXQOZFQwI=
=kMCU
-----END PGP SIGNATURE-----

--=-DpjyG9csFlLWjMkDVmwR--





Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 6 Feb 2022 13:11:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 06 08:11:21 2022
Received: from localhost ([127.0.0.1]:36748 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nGhK5-00076K-On
	for submit <at> debbugs.gnu.org; Sun, 06 Feb 2022 08:11:21 -0500
Received: from xavier.telenet-ops.be ([195.130.132.52]:46314)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <maximedevos@HIDDEN>) id 1nGhK3-000768-Kg
 for 53818 <at> debbugs.gnu.org; Sun, 06 Feb 2022 08:11:20 -0500
Received: from [172.20.10.5] ([188.188.251.13])
 by xavier.telenet-ops.be with bizsmtp
 id rpBH260050J677g01pBHHg; Sun, 06 Feb 2022 14:11:18 +0100
Message-ID: <128afdc0bdf163f025cdfaa2876ae7cdea0b5d86.camel@HIDDEN>
Subject: Re: [bug#53818] [PATCH 2/3] import: Add 'repology' updater.
From: Maxime Devos <maximedevos@HIDDEN>
To: Xinglu Chen <public@HIDDEN>, 53818 <at> debbugs.gnu.org
Date: Sun, 06 Feb 2022 14:11:16 +0100
In-Reply-To: <88f866aff65c0ec9611b6cc0ee9d680ba711df38.1644147246.git.public@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
 <88f866aff65c0ec9611b6cc0ee9d680ba711df38.1644147246.git.public@HIDDEN>
Content-Type: multipart/signed; micalg="pgp-sha512";
 protocol="application/pgp-signature"; boundary="=-iCZgeQQWhtTyZAEr2X2C"
User-Agent: Evolution 3.38.3-1 
MIME-Version: 1.0
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=telenet.be; s=r22;
 t=1644153078; bh=+lhcO9xkXB2CjuarFQNM1eIPb/F/pqwzMMA25+W75Rw=;
 h=Subject:From:To:Date:In-Reply-To:References;
 b=KkAv0IMY6rpUTjLNfHNILfRJUSxORnxYlQ/DYFhjzFEXoJtYy/nJgUAip0VoJS394
 9UnthWli88PBgjJw0qXfWtGPL/smeh7WyZFlgub2VGNMPkL6eHnM8gGppNZbE9pARn
 MfQHx4wy0kmnOdEUfoD0u/zl6LGSoFQF6+bkq0DSzrdRHK63aMsq1cduqQTfs8Qeh0
 nUdGZ0AA4Z4+mqvXB6zkQgBi9zkLzlJNFhfSSr8Av2w1vAYhCQ7hbu4dXT14hAFErq
 18hV35FmImpzpcAYxJpru3vI2/x92AHegaRlexqdn/aTmv5u8rHVddlk5DtWPnl8L6
 yc7XtFqRbMPFQ==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)


--=-iCZgeQQWhtTyZAEr2X2C
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable

Xinglu Chen schreef op zo 06-02-2022 om 14:00 [+0100]:
> +(define* (package-name->repology-name name #:key (attempt 1))
> +=C2=A0 "Convert NAME, the name of a Guix package, to the name of the pac=
kage on
> +Repology.=C2=A0 It doesn't always guess the correct name on the first at=
tempt, so
> +on the second attempt it will try to guess another name."
> +=C2=A0 (match attempt
> +=C2=A0=C2=A0=C2=A0 (1 (cond

Could you add 'minetest' to the list?  Sometimes they are named
'minetest-mod-foo' (Debian), sometimes 'minetest-foo' (Guix,
Archlinux).

Greetings,
Maxime.

--=-iCZgeQQWhtTyZAEr2X2C
Content-Type: application/pgp-signature; name="signature.asc"
Content-Description: This is a digitally signed message part
Content-Transfer-Encoding: 7bit

-----BEGIN PGP SIGNATURE-----

iI0EABYKADUWIQTB8z7iDFKP233XAR9J4+4iGRcl7gUCYf/I9BccbWF4aW1lZGV2
b3NAdGVsZW5ldC5iZQAKCRBJ4+4iGRcl7kXwAQCIwOYnHU/22IG0R+eLe2a9n4uC
VyvO++Yt12q0rD8TUwD/aMCWwjLMDqek5OdZHRBQ/rSKRZORDwaA3LmlKEnttQc=
=ZVD+
-----END PGP SIGNATURE-----

--=-iCZgeQQWhtTyZAEr2X2C--





Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 6 Feb 2022 13:00:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 06 08:00:56 2022
Received: from localhost ([127.0.0.1]:36741 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nGh9z-0006rA-Pi
	for submit <at> debbugs.gnu.org; Sun, 06 Feb 2022 08:00:55 -0500
Received: from h178-251-242-94.cust.a3fiber.se ([178.251.242.94]:59572
 helo=mail.yoctocell.xyz) by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <public@HIDDEN>) id 1nGh9y-0006qs-Cv
 for 53818 <at> debbugs.gnu.org; Sun, 06 Feb 2022 08:00:54 -0500
From: Xinglu Chen <public@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yoctocell.xyz;
 s=mail; t=1644152448;
 bh=EoU2iH+NVaoYwUi51efylRJKNutdEcvEzLEwv5X2Mkg=;
 h=From:To:Subject:In-Reply-To:References:Date;
 b=NP6CgQ17Y18feWSoxDkkJxHD6McNDXU56tEpYdcGr9TtkbIwZAEBJkUeg0AdtmnHX
 SHV11YewCo1zzRwcPzbjkaYkUBs2BGhj1ODlU3tnzNmUADERCeRkUITj8om+Mz7+HE
 NpBp0DltIj0/U/Q8ehGYL6upoVV3l8YTpFiOSt9c=
To: 53818 <at> debbugs.gnu.org
Subject: [PATCH 3/3] gnu: xorg-server-xwayland: Set 'repology-name' property.
In-Reply-To: <cover.1644147246.git.public@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
Message-Id: <c648a7af35de04f863e4ffed1b935b2f486ec869.1644147246.git.public@HIDDEN>
Date: Sun, 06 Feb 2022 14:00:48 +0100
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: * gnu/packages/xorg.scm (xorg-server-xwayland):[properties]:
 Set 'repology-name'. --- gnu/packages/xorg.scm | 2 ++ 1 file changed,
 2 insertions(+)
 diff --git a/gnu/packages/xorg.scm b/gnu/packages/xorg.scm index
 14e35d19ae..ee45630596
 100644 --- a/gnu/packages/xorg.scm +++ b/gnu/packages/xorg.scm @@ -5520,6
 +5520,8 @@ (define-public xorg-server- [...] 
 Content analysis details:   (2.5 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
 [URI: yoctocell.xyz (xyz)]
 0.4 RDNS_DYNAMIC           Delivered to internal network by host with
 dynamic-looking rDNS 0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  * gnu/packages/xorg.scm (xorg-server-xwayland):[properties]:
    Set 'repology-name'. --- gnu/packages/xorg.scm | 2 ++ 1 file changed, 2 insertions(+)
    diff --git a/gnu/packages/xorg.scm b/gnu/packages/xorg.scm index 14e35d19ae..ee45630596
    100644 --- a/gnu/packages/xorg.scm +++ b/gnu/packages/xorg.scm @@ -5520,6
    +5520,8 @@ (define-public xorg-server- [...] 
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps

* gnu/packages/xorg.scm (xorg-server-xwayland):[properties]: Set
'repology-name'.
---
 gnu/packages/xorg.scm | 2 ++
 1 file changed, 2 insertions(+)

diff --git a/gnu/packages/xorg.scm b/gnu/packages/xorg.scm
index 14e35d19ae..ee45630596 100644
--- a/gnu/packages/xorg.scm
+++ b/gnu/packages/xorg.scm
@@ -5520,6 +5520,8 @@ (define-public xorg-server-xwayland
                     (lambda _
                       (substitute* (find-files "." "\\.c$")
                         (("/bin/sh") (which "sh"))))))))
+    (properties
+     '((repology-name . "xwayland")))
     (synopsis "Xorg server with Wayland backend")
     (description "Xwayland is an X server for running X clients under
 Wayland.")
-- 
2.34.1







Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 6 Feb 2022 13:00:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 06 08:00:50 2022
Received: from localhost ([127.0.0.1]:36738 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nGh9r-0006qp-3P
	for submit <at> debbugs.gnu.org; Sun, 06 Feb 2022 08:00:50 -0500
Received: from h178-251-242-94.cust.a3fiber.se ([178.251.242.94]:59566
 helo=mail.yoctocell.xyz) by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <public@HIDDEN>) id 1nGh9p-0006qY-Je
 for 53818 <at> debbugs.gnu.org; Sun, 06 Feb 2022 08:00:46 -0500
From: Xinglu Chen <public@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yoctocell.xyz;
 s=mail; t=1644152438;
 bh=S5OekjJ2N4vruz0JVpeRRmwYuEgUgM5YHEZ0vPFbk88=;
 h=From:To:Subject:In-Reply-To:References:Date;
 b=d6vc96Bg90kUnxzVrd88UV0Uof3XSk7jOPXDv9ZRH48GYnq0oYLIZqZGSznx50LIz
 EQonpbq3z63nUK++Rw5a6soxGkrs76uiiTA+Ysd4Isn9v3qoOrc6xXmBqYCrjHGoHm
 Kmae7aKVg6CO5Pmck/ngK6vIMxw7845rbdsC6HIA=
To: 53818 <at> debbugs.gnu.org
Subject: [PATCH 2/3] import: Add 'repology' updater.
In-Reply-To: <cover.1644147246.git.public@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
Message-Id: <88f866aff65c0ec9611b6cc0ee9d680ba711df38.1644147246.git.public@HIDDEN>
Date: Sun, 06 Feb 2022 14:00:37 +0100
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: * guix/import/repology.scm * tests/import-repology.scm: New
 files. * Makefile.am (MODULES): Register them. * doc/guix.texi (Invoking
 guix refresh): Document it. --- Makefile.am | 3 + doc/guix.texi | 7 [...] 
 Content analysis details:   (2.5 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
 [URI: yoctocell.xyz (xyz)]
 0.4 RDNS_DYNAMIC           Delivered to internal network by host with
 dynamic-looking rDNS 0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  * guix/import/repology.scm * tests/import-repology.scm: New
    files. * Makefile.am (MODULES): Register them. * doc/guix.texi (Invoking
   guix refresh): Document it. --- Makefile.am | 3 + doc/guix.texi | 7 [...] 
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps

* guix/import/repology.scm
* tests/import-repology.scm: New files.
* Makefile.am (MODULES): Register them.
* doc/guix.texi (Invoking guix refresh): Document it.
---
 Makefile.am               |   3 +
 doc/guix.texi             |   7 ++
 guix/import/repology.scm  | 226 ++++++++++++++++++++++++++++++++++++++
 tests/import-repology.scm | 145 ++++++++++++++++++++++++
 4 files changed, 381 insertions(+)
 create mode 100644 guix/import/repology.scm
 create mode 100644 tests/import-repology.scm

diff --git a/Makefile.am b/Makefile.am
index 7463606d20..6792917b59 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -16,6 +16,7 @@
 # Copyright =C2=A9 2019 Efraim Flashner <efraim@HIDDEN>
 # Copyright =C2=A9 2021 Chris Marusich <cmmarusich@HIDDEN>
 # Copyright =C2=A9 2021 Andrew Tropin <andrew@HIDDEN>
+# Copyright =C2=A9 2022 Xinglu Chen <public@HIDDEN>
 #
 # This file is part of GNU Guix.
 #
@@ -271,6 +272,7 @@ MODULES =3D					\
   guix/import/opam.scm				\
   guix/import/print.scm				\
   guix/import/pypi.scm				\
+  guix/import/repology.scm			\
   guix/import/stackage.scm			\
   guix/import/texlive.scm   			\
   guix/import/utils.scm				\
@@ -488,6 +490,7 @@ SCM_TESTS =3D					\
   tests/home-import.scm				\
   tests/import-git.scm				\
   tests/import-github.scm			\
+  tests/import-repology.scm			\
   tests/import-utils.scm			\
   tests/inferior.scm				\
   tests/lint.scm				\
diff --git a/doc/guix.texi b/doc/guix.texi
index 0cf865a672..15d215dd48 100644
--- a/doc/guix.texi
+++ b/doc/guix.texi
@@ -12932,6 +12932,13 @@
       (release-tag-version-delimiter . ":"))))
 @end lisp
=20
+@item repology
+an updater that scans @uref{https://repology.org, Repology}, a website
+that tracks packages on various package repositories, for updates.
+
+The name of a package in Guix is not always that same as the name on
+Repology; users can set the @code{repology-name} package property to
+make the updater use the correct name.
=20
 @end table
=20
diff --git a/guix/import/repology.scm b/guix/import/repology.scm
new file mode 100644
index 0000000000..1d88022c1d
--- /dev/null
+++ b/guix/import/repology.scm
@@ -0,0 +1,226 @@
+;;; GNU Guix --- Functional package management for GNU
+;;; Copyright =C2=A9 2022 Xinglu Chen <public@HIDDEN>
+;;;
+;;; This file is part of GNU Guix.
+;;;
+;;; GNU Guix is free software; you can redistribute it and/or modify it
+;;; under the terms of the GNU General Public License as published by
+;;; the Free Software Foundation; either version 3 of the License, or (at
+;;; your option) any later version.
+;;;
+;;; GNU Guix is distributed in the hope that it will be useful, but
+;;; WITHOUT ANY WARRANTY; without even the implied warranty of
+;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+;;; GNU General Public License for more details.
+;;;
+;;; You should have received a copy of the GNU General Public License
+;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
+
+(define-module (guix import repology)
+  #:use-module (guix diagnostics)
+  #:use-module (guix diagnostics)
+  #:use-module (guix git-download)
+  #:use-module (guix i18n)
+  #:use-module (guix import json)
+  #:use-module (guix import utils)
+  #:use-module (guix memoization)
+  #:use-module (guix packages)
+  #:use-module (guix upstream)
+  #:use-module (guix utils)
+  #:use-module (ice-9 match)
+  #:use-module (json)
+  #:use-module (srfi srfi-1)
+  #:use-module (srfi srfi-2)
+  #:use-module (srfi srfi-26)
+  #:use-module (srfi srfi-43)
+  #:export (repology-latest-release
+            %repology-updater))
+
+;;; Commentary:
+;;;
+;;; This module provides an updater which scans Repology, a site that moni=
tors
+;;; several package repolsitories, for updates.  This means that if any ot=
her
+;;; package repository has a version of a package that is newer than the
+;;; version in Guix, the package should be able to be updated.  The updater
+;;; should in theory work for all packages in Guix, but the names of some
+;;; packages on Repology don't match the name in Guix.  The 'repology-name'
+;;; package property can be used to fix this.
+;;;
+;;; Guix already has many different updaters for language-specific package=
s,
+;;; and these typically provide more accurate data, e.g., input changes,
+;;; signature URLs.  The Repology updater should really be treated as a la=
st
+;;; resort for those packages that don't have any other updater to rely on.
+;;;
+;;; See <https://repology.org/api/v1> for the API.
+;;;
+;;; Code:
+
+(define %repology-url
+   "https://repology.org/api/v1/project")
+
+(define* (package-name->repology-name name #:key (attempt 1))
+  "Convert NAME, the name of a Guix package, to the name of the package on
+Repology.  It doesn't always guess the correct name on the first attempt, =
so
+on the second attempt it will try to guess another name."
+  (match attempt
+    (1 (cond
+        ((string-prefix? "ghc-" name)
+         (string-append "haskell:"
+                        (string-drop name (string-length "ghc-"))))
+        ((string-prefix? "ocaml-" name)
+         (string-append "ocaml:"
+                        (string-drop name (string-length "ocaml-"))))
+        ((string-prefix? "perl-" name)
+         (string-append "perl:"
+                        (string-drop name (string-length "perl-"))))
+        ((string-prefix? "emacs-" name)
+         (string-append "emacs:"
+                        (string-drop name (string-length "emacs-"))))
+        ((string-prefix? "go-" name)
+         (string-append "go:"
+                        (string-drop name (string-length "go-"))))
+        ((string-prefix? "rust-" name)
+         (string-append "rust:"
+                        (string-drop name (string-length "rust-"))))
+        ((string-prefix? "lua-" name)
+         (string-append "lua:"
+                        (string-drop name (string-length "lua-"))))
+        ((string-prefix? "node-" name)
+         (string-append "node:"
+                        (string-drop name (string-length "node-"))))
+        ((string-prefix? "python-" name)
+         (string-append "python:"
+                        (string-drop name (string-length "python-"))))
+        ((string-prefix? "java-" name)
+         (string-append "java:"
+                        (string-drop name (string-length "java-"))))
+        ((string-prefix? "r-" name)
+         (string-append "r:"
+                        (string-drop name (string-length "r-"))))
+        ((string-prefix? "ruby-" name)
+         (string-append "ruby:"
+                        (string-drop name (string-length "ruby-"))))
+        ((string-prefix? "xf86-" name)
+         (string-append "xdrv:"
+                        (string-drop name (string-length "xf86-"))))
+        ((string-prefix? "font-" name)
+         (string-append "fonts:"
+                        (string-drop name (string-length "font-"))))
+        (else name)))
+    (2 (cond
+        ((string-prefix? "xf86-video" name)
+         (string-append "xdrv:"
+                        (string-drop name (string-length "xf86-video-"))))
+        ((string-prefix? "xf86-input" name)
+         (string-append "xdrv:"
+                        (string-drop name (string-length "xf86-input-"))))
+        (else name)))))=20=20
+
+
+;;; JSON mappings.
+
+(define-json-mapping <repology-package> make-repology-package
+  repology-package?
+  json->repology-package
+  (repository repology-package-repository "repo")
+  (src-name repology-package-src-name "srcname")
+  (binary-name repology-package-binary-name "binname")
+  (visible-name repology-package-visible-name "visiblename")
+  (version repology-package-version)
+  (original-version repology-package-original-version "origversion")
+  (status repology-package-status)
+  (summary repology-package-summary)
+  (categories repology-package-categories)
+  (licenses repology-package-licenses)
+  (maintainers repology-package-maintainers))
+
+
+;;; Updater.
+
+(define repology-fetch-info
+  (memoize
+   (lambda (package)
+     "Fetch information about PACKAGE using the Repology API."
+     (define (name->info name )
+       (let ((url (string-append %repology-url "/" name)))
+         (and=3D> (json-fetch url)
+                (lambda (url)
+                  (vector-map (lambda (a b)
+                                (json->repology-package b))
+                              url)))))
+=20=20=20=20=20
+     (let* ((name (or (assoc-ref (package-properties package)
+                                 'repology-name)
+                      (package-name->repology-name (package-name package))=
))
+            (info (name->info name)))
+       (if (and info (not (vector-empty? info)))
+           info
+           (let ((info (name->info (package-name->repology-name
+                                    (package-name package)
+                                    #:attempt 2))))
+             (if (and info (not (vector-empty? info)))
+                 info
+                 (begin
+                   (warning (G_ "package not found on Repology: ~a\n")
+                            (package-name package))
+                   #f))))))))
+
+(define (update-url url old-version new-version)
+  "Replace OLD-VERSION in URL with NEW-VERSION."
+  (match (factorize-uri url old-version)
+    ((? string? uri) #f)
+    ((factorized ...)
+     (apply string-append
+            (map (lambda (component)
+                   (match component
+                     ('version new-version)
+                     ((? string?) component)))
+                 factorized)))))
+
+(define (package-source-urls package version)
+  "Return a list of URLs for PACKAGE at VERSION.  If no URL was successful=
ly constructed, return #f."
+  (let ((old-version (package-version package)))
+    ;; XXX: (guix upstream) only supports tarballs and Git repos for now.
+    (match (origin-uri (package-source package))
+      (($ <git-reference> url commit recursive?)
+       (and-let* ((updated-commit (if (string=3D? old-version commit)
+                                      version
+                                      (update-url commit old-version versi=
on))))
+         (list (git-reference
+                (url url)
+                (commit updated-commit)
+                (recursive? recursive?)))))
+      ((? string? url)
+       (list (update-url url old-version version)))
+      ((? list? urls)
+       (map (cut update-url <> old-version version) urls))
+      (_ #f))))
+
+(define (stable-version? repology-package)
+  (and (or (equal? "newest" (repology-package-status repology-package))
+           (equal? "unique" (repology-package-status repology-package)))
+       (repology-package-version repology-package)))
+
+;; XXX: 'package' will clash with the 'package' field of 'upstream-source'.
+(define (repology-latest-release pkg)
+  "Return the latest release of the PKG on Repology named NAME."
+  (and-let* ((packages (repology-fetch-info pkg))
+             (versions (filter-map stable-version?
+                                          (vector->list packages)))
+             (latest-version (if (null? versions)
+                                 #f
+                                 (car versions))))
+    ;; TODO: set 'signature-urls'.
+    (upstream-source
+     (package (package-name pkg))
+     (version latest-version)
+     (urls (package-source-urls pkg latest-version)))))
+
+(define %repology-updater
+(upstream-updater
+ (name 'repology)
+ (description "Updater for packages on Repology")
+ (pred (const #t))
+ (latest repology-latest-release)))
+
+;;; repology.scm ends here
diff --git a/tests/import-repology.scm b/tests/import-repology.scm
new file mode 100644
index 0000000000..f95071ce07
--- /dev/null
+++ b/tests/import-repology.scm
@@ -0,0 +1,145 @@
+;;; GNU Guix --- Functional package management for GNU
+;;; Copyright =C2=A9 2022 Xinglu Chen <public@HIDDEN>
+;;;
+;;; This file is part of GNU Guix.
+;;;
+;;; GNU Guix is free software; you can redistribute it and/or modify it
+;;; under the terms of the GNU General Public License as published by
+;;; the Free Software Foundation; either version 3 of the License, or (at
+;;; your option) any later version.
+;;;
+;;; GNU Guix is distributed in the hope that it will be useful, but
+;;; WITHOUT ANY WARRANTY; without even the implied warranty of
+;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+;;; GNU General Public License for more details.
+;;;
+;;; You should have received a copy of the GNU General Public License
+;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
+
+(define-module (test-import-repology)
+  #:use-module (guix download)
+  #:use-module (guix git-download)
+  #:use-module (guix import repology)
+  #:use-module (guix packages)
+  #:use-module (guix tests)
+  #:use-module (guix upstream)
+  #:use-module (json)
+  #:use-module (srfi srfi-64))
+
+(test-begin "repology")
+
+(define package-using-git-repository
+  (dummy-package
+   "foo"
+   (version "1.0")
+   (source
+    (origin
+      (method git-fetch)
+      (uri (git-reference
+            (url "https://git.example.org/foo")
+            (commit "1.0")))
+      (sha256 #f)))))
+
+(define package-using-tarball
+  (dummy-package
+   "foo"
+   (version "1.0")
+   (source
+    (origin
+      (method git-fetch)
+      (uri (string-append "https://example.org/foo-" version ".tar.gz"))
+      (sha256 #f)))))
+
+(define package-using-tarball-multiple-urls
+  (dummy-package
+   "foo"
+   (version "1.0")
+   (source
+    (origin
+      (method git-fetch)
+      (uri (list (string-append "https://example.org/foo-"
+                                version ".tar.gz")
+                 (string-append "https://mirror.example.org/foo-"
+                                version ".tar.gz")))
+      (sha256 #f)))))
+
+(define %test-json
+"[
+  {
+    \"repo\": \"aur\",
+    \"srcname\": \"foo\",
+    \"binname\": \"foo\",
+    \"visiblename\": \"foo\",
+    \"version\": \"1.0.r25.gb86405a\",
+    \"maintainers\": [
+      \"bob@aur\"
+    ],
+    \"licenses\": [
+      \"LGPL3+\"
+    ],
+    \"summary\": \"foo bar\"
+    \"status\": \"rolling\",
+    \"origversion\": \"1.0.r25.gb86405a-1\"
+  },
+  {
+    \"repo\": \"gnuguix\",
+    \"srcname\": \"foo\",
+    \"binname\": \"foo\",
+    \"visiblename\": \"foo\",
+    \"version\": \"1.0\",
+    \"summary\": \"foo bar\",
+    \"status\": \"outdated\",
+    \"origversion\": null
+  },
+  {
+    \"repo\": \"nix_unstable\",
+    \"name\": \"foo\",
+    \"visiblename\": \"foo\",
+    \"version\": \"2.0\",
+    \"maintainers\": [
+      \"bob@HIDDEN\"
+    ],
+    \"licenses\": [
+      \"LGPL-3.0-or-later\"
+    ],
+    \"summary\": \"foo bar\",
+    \"status\": \"newest\",
+    \"origversion\": null
+  }
+]")
+
+(define (latest-release package)
+  (mock ((guix import json) json-fetch
+         (lambda (url)
+           (json-string->scm %test-json)))
+        (repology-latest-release package)))
+
+(test-equal "package using Git repo: version"
+  "2.0"
+  (upstream-source-version
+   (latest-release package-using-git-repository)))
+
+(test-equal "package using Git repo: git-reference"
+  (list (git-reference
+         (url "https://git.example.org/foo")
+         (commit "2.0")))
+  (upstream-source-urls
+   (latest-release package-using-git-repository)))
+
+(test-equal "package using tarball: version"
+  "2.0"
+  (upstream-source-version
+   (latest-release package-using-tarball)))
+
+(test-equal "package using tarball: URL"
+  (list "https://example.org/foo-2.0.tar.gz")
+  (upstream-source-urls
+   (latest-release package-using-tarball)))
+
+(test-equal "package using tarball: multiple URLs"
+  (list "https://example.org/foo-2.0.tar.gz"
+        "https://mirror.example.org/foo-2.0.tar.gz")
+  (upstream-source-urls
+   (latest-release package-using-tarball-multiple-urls)))
+
+(test-end "repology")
--=20
2.34.1







Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 6 Feb 2022 13:00:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 06 08:00:39 2022
Received: from localhost ([127.0.0.1]:36735 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nGh9i-0006qQ-SJ
	for submit <at> debbugs.gnu.org; Sun, 06 Feb 2022 08:00:39 -0500
Received: from h178-251-242-94.cust.a3fiber.se ([178.251.242.94]:59546
 helo=mail.yoctocell.xyz) by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <public@HIDDEN>) id 1nGh9g-0006q2-74
 for 53818 <at> debbugs.gnu.org; Sun, 06 Feb 2022 08:00:37 -0500
From: Xinglu Chen <public@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yoctocell.xyz;
 s=mail; t=1644152428;
 bh=9IC8WLimIFDk6Am5snW9QzYw+ml2B5RYbrxkVe7aNsQ=;
 h=From:To:Subject:In-Reply-To:References:Date;
 b=Kb0fAPOiq7VhyEZU19lmmHNu9jniG21MnasGnZqtSb8bOmtrT4SHplrxB8XQGB6Pv
 6lfWLzGjYFUs1D7mnsUqNndhDe7aD7O2Q1+bvE4LNEI1pDdtiHdgsffYaoYJv8T634
 dsurcLxsYniel5KLSblPOqJE0V6HnUnN7Q8RC9hU=
To: 53818 <at> debbugs.gnu.org
Subject: [PATCH 1/3] git-download: Export <git-reference>.
In-Reply-To: <cover.1644147246.git.public@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
Message-Id: <25f4c5212f9461bd14f668b3fbd9ccb80f8bc5a4.1644147246.git.public@HIDDEN>
Date: Sun, 06 Feb 2022 14:00:28 +0100
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 2.5 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: * guix/git-download.scm: Export <git-reference> record. ---
 guix/git-download.scm | 3 ++- 1 file changed, 2 insertions(+), 1 deletion(-)
 diff --git a/guix/git-download.scm b/guix/git-download.scm index
 5e624b9ae9..43424f2f19
 100644 --- a/guix/git-download.scm +++ b/guix/git-download.scm @@ -44, 7 +44, 8
 @@ (define-module (guix git-downlo [...] 
 Content analysis details:   (2.5 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
 [URI: yoctocell.xyz (xyz)]
 0.4 RDNS_DYNAMIC           Delivered to internal network by host with
 dynamic-looking rDNS 0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  * guix/git-download.scm: Export <git-reference> record. ---
    guix/git-download.scm | 3 ++- 1 file changed, 2 insertions(+), 1 deletion(-)
    diff --git a/guix/git-download.scm b/guix/git-download.scm index 5e624b9ae9..43424f2f19
    100644 --- a/guix/git-download.scm +++ b/guix/git-download.scm @@ -44,7 +44,8
    @@ (define-module (guix git-downlo [...] 
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.4 RDNS_DYNAMIC           Delivered to internal network by host with
                             dynamic-looking rDNS
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
  0.0 PDS_RDNS_DYNAMIC_FP    RDNS_DYNAMIC with FP steps

* guix/git-download.scm: Export <git-reference> record.
---
 guix/git-download.scm | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

diff --git a/guix/git-download.scm b/guix/git-download.scm
index 5e624b9ae9..43424f2f19 100644
--- a/guix/git-download.scm
+++ b/guix/git-download.scm
@@ -44,7 +44,8 @@ (define-module (guix git-download)
   #:use-module (srfi srfi-1)
   #:use-module (srfi srfi-34)
   #:use-module (srfi srfi-35)
-  #:export (git-reference
+  #:export (<git-reference>
+            git-reference
             git-reference?
             git-reference-url
             git-reference-commit
-- 
2.34.1







Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at 53818 <at> debbugs.gnu.org:


Received: (at 53818) by debbugs.gnu.org; 6 Feb 2022 12:41:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 06 07:41:41 2022
Received: from localhost ([127.0.0.1]:36701 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nGgrN-0006Ja-9c
	for submit <at> debbugs.gnu.org; Sun, 06 Feb 2022 07:41:41 -0500
Received: from xavier.telenet-ops.be ([195.130.132.52]:42388)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <maximedevos@HIDDEN>) id 1nGgrK-0006JQ-O4
 for 53818 <at> debbugs.gnu.org; Sun, 06 Feb 2022 07:41:40 -0500
Received: from [172.20.10.5] ([188.188.251.13])
 by xavier.telenet-ops.be with bizsmtp
 id roha2600A0J677g01ohaU5; Sun, 06 Feb 2022 13:41:36 +0100
Message-ID: <2ba4a342b6c2b53f7038a84c8337608e51ecf13a.camel@HIDDEN>
Subject: Re: [bug#53818] [PATCH 0/3] Add Repology updater
From: Maxime Devos <maximedevos@HIDDEN>
To: Xinglu Chen <public@HIDDEN>, 53818 <at> debbugs.gnu.org
Date: Sun, 06 Feb 2022 13:41:29 +0100
In-Reply-To: <cover.1644147246.git.public@HIDDEN>
References: <cover.1644147246.git.public@HIDDEN>
Content-Type: multipart/signed; micalg="pgp-sha512";
 protocol="application/pgp-signature"; boundary="=-ZnSI7cgLiqP4k3lNx9jj"
User-Agent: Evolution 3.38.3-1 
MIME-Version: 1.0
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=telenet.be; s=r22;
 t=1644151297; bh=IjZJqjHDO4WJ2bephfwIeyaqBhzu03RG41jb/obWCk0=;
 h=Subject:From:To:Date:In-Reply-To:References;
 b=Uyxo9O41q2fTCo7JZnYFB7cCcqotHC2zT2/HDy/oCZRxbzfvD5XGiS67g3ktoPrkQ
 1/V7r9dlZ7nPR8D/5Z4mi5WqrOdMEcTN9mDRhmX20CqK1yBl9serumW15/SYcDctLt
 S1abPChEvByo7RwY1LDIc21qXNRwFq1P6omrf2vSjhU6YkhtFRmZ28X+qhuWTkxBn9
 bBtwT4nLsxxybyzat9PwtSOwWpCV52AeM+rsB4/K0gaRnBCtNo3DciLllaDzlhqcb5
 +2IwM/bU1X0wwP3UdK/Vtpv/WrFkdhrJg+1Y169QvdhD2LriDH5yJt09eKE34TZCJD
 voclWl7la5fXA==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 53818
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)


--=-ZnSI7cgLiqP4k3lNx9jj
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable

Xinglu Chen schreef op zo 06-02-2022 om 12:50 [+0100]:
> Because of the way =E2=80=98%updaters=E2=80=99 in (guix upstream) works, =
the Repology
> updater is the first or second updater that is used (since it
> technically works on ever package), but because of the limitations I
> mentioned above, the result might not always be the best.  The Repology
> updater is mostly useful for things that don=E2=80=99t already have an up=
dater,
> e.g., =E2=80=98maven-dependency-tree=E2=80=99.  Would it make sense to ha=
rd-code the
> =E2=80=98%updaters=E2=80=99 variable and put the Repology last in the lis=
t?

I would prefer not to hardcode %updaters and keep the current
discovery mechanism, such that people can experiment with updaters
outside a git checkout of guix and in channels.

FWIW it would be useful to have the same mechanism for importers.

However, it might be a good idea to do some _postprocessing_ on
the discovered list of updaters, e.g. they could be sorted on
'genericity' with 'stable-sort' (*):

(define (genericity x)
  (cond ((it is "generic-SOMETHING") 1)
        ((it is repology) 2)
        (#true 0)))

(define (less x y)
  (<=3D (genericity x) (genericity y)))

(*) stable-sort and not sort, to preserve alphabetical ordering
for updaters with the same genericity.

Greetings,
Maxime.

--=-ZnSI7cgLiqP4k3lNx9jj
Content-Type: application/pgp-signature; name="signature.asc"
Content-Description: This is a digitally signed message part
Content-Transfer-Encoding: 7bit

-----BEGIN PGP SIGNATURE-----

iI0EABYKADUWIQTB8z7iDFKP233XAR9J4+4iGRcl7gUCYf/B+RccbWF4aW1lZGV2
b3NAdGVsZW5ldC5iZQAKCRBJ4+4iGRcl7kwHAP9vamvhIFQUUY9qfgv6X4JT6xjq
QHRdA+w51aw/A0R+SwD9GE/Mpw/22XbZ3y7WwR4mGcSIerIloYFGo/YFrpQORw4=
=4GIv
-----END PGP SIGNATURE-----

--=-ZnSI7cgLiqP4k3lNx9jj--





Information forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 6 Feb 2022 11:51:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 06 06:51:51 2022
Received: from localhost ([127.0.0.1]:36673 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nGg59-0002nP-1Q
	for submit <at> debbugs.gnu.org; Sun, 06 Feb 2022 06:51:51 -0500
Received: from lists.gnu.org ([209.51.188.17]:42588)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <public@HIDDEN>) id 1nGg56-0002nD-NQ
 for submit <at> debbugs.gnu.org; Sun, 06 Feb 2022 06:51:49 -0500
Received: from eggs.gnu.org ([209.51.188.92]:34816)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <public@HIDDEN>)
 id 1nGg55-0002uK-SM
 for guix-patches@HIDDEN; Sun, 06 Feb 2022 06:51:48 -0500
Received: from h178-251-242-94.cust.a3fiber.se ([178.251.242.94]:44752
 helo=mail.yoctocell.xyz)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <public@HIDDEN>)
 id 1nGg4v-00059z-22
 for guix-patches@HIDDEN; Sun, 06 Feb 2022 06:51:47 -0500
From: Xinglu Chen <public@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yoctocell.xyz;
 s=mail; t=1644148228;
 bh=54WkDCuqqYI6GKnypr7gnKPXUPmUCNOWNXoqVoiYzGQ=;
 h=From:To:Subject:Date;
 b=dzCcUm1jJM2FAXA/UzA1vn1N2aXoB3Evx7AitNiJWIHCmxm60eiZ3kJ0IkIq/J2Tr
 zeLVMqXks44lyvgCJ2gCBaSB/i0y4h69nDDTxo1pAdktzzAZT0+Vvb32PCvEjgjwKU
 DbcoeSPW69tFahx81XS9+D8yH7Jyi9n3DM9epmPs=
To: guix-patches@HIDDEN
Subject: [PATCH 0/3] Add Repology updater
Message-Id: <cover.1644147246.git.public@HIDDEN>
Date: Sun, 06 Feb 2022 12:50:27 +0100
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
Received-SPF: pass client-ip=178.251.242.94; envelope-from=public@HIDDEN;
 helo=mail.yoctocell.xyz
X-Spam_score_int: 31
X-Spam_score: 3.1
X-Spam_bar: +++
X-Spam_report: (3.1 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1, DKIM_VALID=-0.1,
 DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1, FROM_SUSPICIOUS_NTLD=0.499,
 FROM_SUSPICIOUS_NTLD_FP=1.999, PDS_OTHER_BAD_TLD=1.772,
 PDS_RDNS_DYNAMIC_FP=0.001, RDNS_DYNAMIC=0.982, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001, T_SCC_BODY_TEXT_LINE=-0.01 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: 2.8 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Hi, This patchset adds a new updater, which scans Repology[1]
    for updates. It should technically support all packages in Guix! :-) The
   data on Repology isn’t as detailed as the one on language-specific repos,
    e.g., PyPI, so the updater doesn’t support things like ‘input changes’.
    If the source URL doesn’t contain the ve [...] 
 
 Content analysis details:   (2.8 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
  1.0 SPF_SOFTFAIL           SPF: sender does not match SPF record (softfail)
  1.6 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
 -2.3 RCVD_IN_DNSWL_MED      RBL: Sender listed at https://www.dnswl.org/,
                             medium trust
                             [209.51.188.17 listed in list.dnswl.org]
  2.0 FROM_SUSPICIOUS_NTLD_FP From abused NTLD
  0.5 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.2 (/)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

Hi,

This patchset adds a new updater, which scans Repology[1] for updates.
It should technically support all packages in Guix!  :-)

The data on Repology isn=E2=80=99t as detailed as the one on language-speci=
fic
repos, e.g., PyPI, so the updater doesn=E2=80=99t support things like =E2=
=80=98input
changes=E2=80=99.  If the source URL doesn=E2=80=99t contain the version ve=
rbatim[2], it
won=E2=80=99t be able reconstruct the URL of the updated version, meaning t=
hat
=E2=80=98guix refresh -u=E2=80=99 won=E2=80=99t work.

Because of the way =E2=80=98%updaters=E2=80=99 in (guix upstream) works, th=
e Repology
updater is the first or second updater that is used (since it
technically works on ever package), but because of the limitations I
mentioned above, the result might not always be the best.  The Repology
updater is mostly useful for things that don=E2=80=99t already have an upda=
ter,
e.g., =E2=80=98maven-dependency-tree=E2=80=99.  Would it make sense to hard=
-code the
=E2=80=98%updaters=E2=80=99 variable and put the Repology last in the list?

[1]: <https://repology.org>
[2]: e.g., the version is =E2=80=9C1.0.0=E2=80=9D but the URL is
     =E2=80=9Chttps://example.org/1_0_0.tar.gz=E2=80=9D

Xinglu Chen (3):
  git-download: Export <git-reference>.
  import: Add 'repology' updater.
  gnu: xorg-server-xwayland: Set 'repology-name' property.

 Makefile.am               |   3 +
 doc/guix.texi             |   7 ++
 gnu/packages/xorg.scm     |   2 +
 guix/git-download.scm     |   3 +-
 guix/import/repology.scm  | 226 ++++++++++++++++++++++++++++++++++++++
 tests/import-repology.scm | 145 ++++++++++++++++++++++++
 6 files changed, 385 insertions(+), 1 deletion(-)
 create mode 100644 guix/import/repology.scm
 create mode 100644 tests/import-repology.scm


base-commit: 7c9ad54b0616112c7eea6dd02379616aef206490
=2D-=20
2.34.1




--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQJJBAEBCAAzFiEEAVhh4yyK5+SEykIzrPUJmaL7XHkFAmH/tgMVHHB1YmxpY0B5
b2N0b2NlbGwueHl6AAoJEKz1CZmi+1x5ueMP+wWlMMv507Da85m9aFArAhY+gZOD
OyKWCwnqAsQguW/Ijh2u6yGyutFhtDMhE/d29Z0Eu5VhXfrztCxqWStf9LWKN5G1
kgZlRgkbdx1mzlJIiIIbFsmsxpEoVCUpmH6T3Vm/hZQpta6xAWjiU+orOBt53rci
3PR2pU+XGSkmnRpFwzaWeW1ki08HvPsAVRX6VRGjep8p7zhpQh2nEW63tgNzeDRX
L8IuxqT4o+ywSIOEiqYjYF5+rA5HodcZ8C9D3LT2BLyPwYoA80HIdthrfyYhqKVP
XZaiy1sP2aeoyXK+I8mF+C/DQXcb9XUkH8kiMLr5noBK3Ork847YrJmBlP7sFEfP
xOW41Ep7S0ZlFdAVkTlTJ44jTyepqgcSnHp8Eg9MVK7oqQMKafGEe7h9rCf4I5xV
jCljfvlLQ748vsSgvGtU3jq88KNDx7KoMD//Y5yPHmY6pWk55KvZMn2LIDxqzZJA
Jzd1d+EsgGLj1ot242te0bM3pzPBPVzQazgH1+F3EMOzLzlWCxkn2XRorKdwi/XP
DlL24j/cjpfzRVZpRLMi91PmmPRZNiB3rRHjq4l2fCfVnjdEy+W/Cl3cm2GLte91
jcooyT8tNWJiWWszeAd85/3AfmQYk82PBHPPh6yj1fIKpSJuwqhJCXvdeQrrr8xh
JCunDMPlLQ+K6BXR
=ab47
-----END PGP SIGNATURE-----
--=-=-=--




Acknowledgement sent to Xinglu Chen <public@HIDDEN>:
New bug report received and forwarded. Copy sent to guix-patches@HIDDEN. Full text available.
Report forwarded to guix-patches@HIDDEN:
bug#53818; Package guix-patches. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Fri, 18 Feb 2022 10:30:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.